#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <ctype.h>
#include <string>

#include <CMotion2DImage.h>
#include "filt_gauss.h"

using namespace std;

/*

  Robust multiresolution estimation of parametric motion model.

*/
int main(int argc, char **argv)
{
  CMotion2DImage<unsigned char> I;	// Image
  CMotion2DImage<unsigned char> F;	// Image Filtree

  string src_filename = "../sequence/rond-point0004.pgm";
  string dst_filename = "/tmp/ima.pgm";

 
  if (I.ReadPGM(src_filename))	// Load the image PGM P5 file
    exit(-1);

  // Initialize the filtered image size
  F.Init(I.GetRows(), I.GetCols());

  // Interface
  TImage src;
  src.ad = I.bitmap;
  src.nbli = I.GetRows();
  src.nbco = I.GetCols();
  
  TImage dst;
  dst.ad = F.bitmap;
  dst.nbli = F.GetRows();
  dst.nbco = F.GetCols();

  float sigma2 = 2.0; // Variance pour le lissage de l'image

  filtre_gauss(src, dst, sigma2);

  if (F.WritePGM(dst_filename))	// Write the backwarped image in PGM P5 format
    exit(-1);

  return 0;
}
