/*****************************************************************************
**
**       Copyright (c) 1995-1996-1997-1998 by IRISA/INRIA Rennes.
**       All Rights Reserved.
**
**       IRISA/INRIA Rennes
**       Campus Universitaire de Beaulieu
**       35042 Rennes Cedex
**
*****************************************************************************/

/************************************************************************

 FICHIER	: acast.h

 REPERTOIRE	: /home/corre/src/cprim

 MACHINE HOTE	: Sun386i timeat

 MACHINE CIBLE	: Sun386i SunIPC SunIPX

 PROJET		: Bibliotheque logicielle de primitives en langage C.

 CLIENT		: S.A TIMEAT			TELEPHONE	: 99.26.93.00

 COPYRIGHT	: S.A TIMEAT			TELEPHONE	: 99.26.93.00

 AUTEUR		: Jean-Luc CORRE

 ENVIRONNEMENT	: Compilation	- Neant.
		  Liens		- Neant.
		  Execution	- Neant.

 DESCRIPTION	: Le fichier (acast = Array CAST) contient les declarations
		  des procedures de conversions de types de tableaux
		  monodimensionnels.

 RESUME		:

 Declarations des procedures du fichier "acast.c".

 HISTORIQUE	:

 1.00 - 17/12/91 - Original.

*************************************************************************/


#ifndef	__ACAST_H
#define	__ACAST_H

#include	<stdlib.h>	/* pour size_t	*/
#include        <sys/types.h>

/* types a la POSIX	*/
typedef unsigned char	uchar;
#ifdef WIN32
typedef unsigned int	uint;
typedef unsigned long	ulong;
#endif // WIN32

extern	void	cast_double_float (const double *src, float *dst, size_t n);
extern	void	cast_float_double (const float *src, double *dst, size_t n);
extern	void	cast_float_short (const float *src, short *dst, size_t n);
extern	void	cast_short_float (const short *src, float *dst, size_t n);
extern	void	cast_short_uchar (const short *src, uchar *dst, size_t n);
extern	void	cast_uchar_short (const uchar *src, short *dst, size_t n);
extern	void	cast_uchar_uint (const uchar *src, uint *dst, size_t n);
extern	void	cast_uchar_float (const uchar *src, float *dst, size_t n);
extern	void	cast_char_short (const char *src, short *dst, size_t n);
extern	void	castinc_short_float (const short *src, float *dst, size_t n,
			int incsrc, int incdst);


#endif	/* __ACAST_H	*/

