/*****************************************************************************
**
**       Copyright (c) 1995-1996-1997-1998 by IRISA/INRIA Rennes.
**       All Rights Reserved.
**
**       IRISA/INRIA Rennes
**       Campus Universitaire de Beaulieu
**       35042 Rennes Cedex
**
*****************************************************************************/

/************************************************************************

 FICHIER	: fafirf5.h

 REPERTOIRE	: /home/corre/src/cprim

 MACHINE HOTE	: Sun386i timeat

 MACHINE CIBLE	: Sun386i SunIPC SunIPX

 PROJET		: Bibliotheque logicielle de primitives en langage C.

 CLIENT		: S.A TIMEAT			TELEPHONE	: 99.26.93.00

 COPYRIGHT	: S.A TIMEAT			TELEPHONE	: 99.26.93.00

 AUTEUR		: Jean-Luc CORRE

 ENVIRONNEMENT	: Compilation	- Neant.
		  Liens		- Neant.
		  Execution	- Neant.

 DESCRIPTION	: Le fichier (fafirf5 = Float Array Finite Impulse Response
	 	  Filter 5) contient les declarations des procedures de
		  filtrage spatial de 5 coefficients operant sur les tableaux
		  de reels simple precision monodimensionnels.

 RESUME		:

 Declarations des procedures du fichier "fafirf5.c".

 HISTORIQUE	:

 1.00 - 26/07/95 - Original.

*************************************************************************/


#ifndef	__FAFIRF5_H
#define	__FAFIRF5_H


#include	<stdlib.h>	/* pour size_t	*/


extern	void	firf5_float (const float *src, float *dst, size_t n,
			const float *fir);
extern	void	firf5inc_float (const float *src, float *dst, size_t n,
			int incsrc, int incdst, const float *fir);
extern	void	firf5sym_float (const float *src, float *dst, size_t n,
			const float *fir);
extern	void	firf5syminc_float (const float *src, float *dst, size_t n,
			int incsrc, int incdst, const float *fir);


#endif	/* __FAFIRF5_H	*/

