/*****************************************************************************
**
**       Copyright (c) 1995-1996-1997-1998 by IRISA/INRIA Rennes.
**       All Rights Reserved.
**
**       IRISA/INRIA Rennes
**       Campus Universitaire de Beaulieu
**       35042 Rennes Cedex
**
*****************************************************************************/

#ifndef type_h
#define type_h

#define Max(A,B) (((A) > (B) )? (A) : (B))
#define	MIJ(m,i,j,s)	((m) + ((i) * (s)) + (j))


/*
 * Structure utilisee pour sauvegarder les coefficients du
 * filtre gaussien utilise pour filtrer l'image avant sous-echantillonnage.
 */
typedef struct{
  bool   flag;          /* si 0; le filtre n'existe pas, sinon 1          */
  float variance;      /* variance du filtre gaussien                    */
  int   taille;        /* taille du filtre gaussien: taille = 2*nindex+1 */
  int   nindex;
  float *ad_coef;       /* pointeur sur les coefficients du filtre        */
  float *ad_pond;       /* pointeur sur la ponderation du filtre          */
} TFiltreGauss;

/*
 * Structure TImageShort utilisee pour sauvegarder les caracteristiques d'une
 * image de SHORTI.
 */
typedef struct {
  unsigned char  *ad;    /* pointeur sur le debut de l'image          */
  int	  nbli;		 /* nbre de lignes de l'image                 */
  int	  nbco;		 /* nbre de colonnes de l'image               */
} TImage;




#endif	/* type_h */
