#ifndef _CALIBRAGE_FLGLIMAGEVIEWER_H_
#define _CALIBRAGE_FLGLIMAGEVIEWER_H_

#include "includes.h"
#include "EventHandler.h"

class FlGlImageViewer : public Fl_Gl_Window
{
 private:

  friend class FlMainWindow;

  sPoint2d initialPosition;
  sPoint2d currentPosition;
  EventHandler* imageHandler;
  EventHandler* equalizationHandler;

  //EventHandler* originHandler;

  eOnOff loaded;
  //void initializeEvent(sEvent& evt,int event);
/*   ImgaeRGB *viewedImage; */
  
 protected:
  /** common event handlers 
  void switchdebug(void* data);
  void switchmode(void* data);
  void load(void* data);
  void save(void* data);
  void importData(void* data);
  void exportData(void* data);
  void calibrate(void* data);
  /** image event handlers */
  //void resetview(void* data);
  void initmove(void* data);
  void move(void* data);
  void initzoom(void* data);
  void zoom(void* data);
/*   void initzoomout(void* data); */
/*   void zoomout(void* data); */
/*   void endmanipulate(void* data); */
  /** equalizing histogram event handlers */

  /*void selectpoint(void* data);
  void validpolygon(void* data);
  void equalize(void* data);*/
  
 public:
  /** image event handlers */
  //static void s_resetview(void* widget,void* data);
  static void s_initmove(void* widget,void* data);
  static void s_move(void* widget,void* data);
  static void s_initzoom(void* widget,void* data);
  static void s_zoom(void* widget,void* data);
/*   static void s_initzoomout(void* widget,void* data); */
/*   static void s_zoomout(void* widget,void* data); */
/*   static void s_endmanipulate(void* widget,void* data); */
  /** vanishing point event handlers */

  static void s_selectpoint(void* widget,void* data);
  static void s_validpolygon(void* widget,void* data);
  static void s_equalize(void* widget,void* data);
  static void s_undo(void* widget,void* data);
  static void s_initial(void* widget,void* data);
  static void s_normalize(void* widget,void* data);
  static void s_gray(void* widget,void* data);
  static void s_modified(void* widget,void* data);

 public:
  FlGlImageViewer(const int xx,const int yy,const int ww,const int hh,const char* title = NULL);
  ~FlGlImageViewer();
  int handle(int event);
  void draw();
  void resize(int x, int y, int ww, int hh);
}; /* class FlGlImageViewer */

#endif /* #ifndef _CALIBRAGE_FLGLIMAGEVIEWER_H_ */
