#ifndef FLMAINWINDOW_H
#define FLMAINWINDOW_H

#include "includes.h"
#include "EventHandler.h"
#include "FlGlImageViewer.h"
#include "fonct.h"
#include "graph.h"
#include "polygon.h"
#include "Traitement.h"

//#include "Image.h"

#define RGBF 0
#define RGB 1
#define GRAYF 2



class FlMainWindow : public Fl_Window
{
 private:

  friend class FlGlImageViewer;

  static FlMainWindow* mainapp;
 private:
  static Traitement traitement;

  Fl_Group *group;
  FlGlImageViewer* imageViewer;
  Fl_Gl_Window *window1,*window2,*window3,*window4;
  graph *g_ombr,*g_eclair,*g_transf;
  Fl_Output* informationStatus;
  Fl_Output* modeStatus;
  Fl_Output* coordinateStatus;
  Fl_Output* resultStatus;
  EventHandler* commonHandler;

  static unsigned int currentMode;
  
  GLuint imageList;
  CameraOrthographique viewingCamera;
  //double ax,bx,ay,by;

  //SetPolygon pol;

/*   static ImageRGB initialImage; */
/*   static ImageRGBf modifiedImage,normalizedImage; */
/*   static ImageGRAYf grayImage; */

  //static ImageRGBf *rgbf;
  //static ImageGRAYf *grayf;

  //static unsigned int viewedImage;	//  RGBF  /  RGB  /  GRAYF

  //fonct f_eclair_r,f_ombr_r,f_transf_r,f_eclair_g,f_ombr_g,f_transf_g,f_eclair_b,f_ombr_b,f_transf_b;
/*   map<int,set<int> > carte; */

 private:
  void transfo();
  void fresh_f();
  static void aff_image();
  static void init_camera();
/*   static bool rgb_viewed(); */
/*   static bool float_viewed(); */
/*   static void init_viewedImage(void* v); */

/*   static void gray(const ImageRGB &s,ImageRGB &d); */
/*   static void gauss_filter(const ImageRGB &s,const ImageRGB &d,float sigma2 = 2.0); */
/*   static void diviz_gg(const ImageRGB &i1,const ImageRGB &i2,ImageRGB &r); */
/*   static void diviz(const ImageRGB &i1,const ImageRGB &i2,ImageRGB &r); */
/*   static void undiviz(const ImageRGB &i1,const ImageRGB &i2,ImageRGB &r); */
/*   static void mult(const ImageRGB &i1,const ImageRGB &i2,ImageRGB &r); */
/*   static void double_lum(const ImageRGB &i1,ImageRGB &i2); */
  //  void enterGaussMode();

/*   void gauss_filter(unsigned int iter,bool inside,vector<Polygon> vp); */
  void gauss_filter(ImageRGB &s,ImageRGB &d,unsigned int iter,bool *t);
  void superpose(ImageRGB &i1,ImageRGB &i2,ImageRGB &dest,bool *t1,bool *t2);
  void get_map_in(vector<Polygon> vp,bool *t,unsigned int w,unsigned int h);
  void get_maps(vector<Polygon> vp,bool *t_in,bool *t_out,unsigned int w,unsigned int h);
  void get_map_out(vector<Polygon> vp,bool *t,unsigned int w,unsigned int h);

  /** common event handlers */
  static void s_switchdebug(void* widget,void* data);
  static void s_switchmode(void* widget,void* data);
  static void s_load(void* widget,void* data);
  static void s_load_modified(void* widget,void* data);
  static void s_save(void* widget,void* data);
/*   static void s_importData(void* widget,void* data); */
/*   static void s_exportData(void* widget,void* data); */
/*   static void s_calibrate(void* widget,void* data); */
  static void s_diviz(void* widget,void* data);
  static void s_undiviz(void* widget,void* data);
  static void s_mult(void* widget,void* data);
  static void s_double_lum(void* widget,void* data);
  static void s_gauss_filter(void* widget,void* data);
  static void s_aniso_diff(void* widget,void* data);
  static void s_selective_filter(void* widget,void* data);
  static void s_gradient(void* widget,void* data);
  static void s_push_image(void* widget,void* data);
  static void s_pushed_image(void* widget,void* data);
  static void s_load_polygons(void* data);
  static void s_save_polygons(void* data);
  static void s_clear_polygons(void* data);
  static void s_fill_hole(void* data);
  static void s_valid_set_polygons(void *data);
  static void s_equalize(void *data);
  static void s_histogram(void *data);


  static void s_initial(void* widget,void* data);
  static void s_modified(void* widget,void* data);
  static void s_normalize(void* widget,void* data);
  static void s_gray(void* widget,void* data);

  void diviz(void* data);
  void undiviz(void* data);
  void mult(void* data);
  void double_lum(void* data);
  void gauss_filter(void* data);
  void aniso_diff(void* data);
  void selective_filter(void* data);
  void gradient(void* data);
/*   void push_image(void* data); */
  void pushed_image(void* data);

/*
  sVanishingPoint fu;
  sVanishingPoint fv;
  sVanishingPoint fw;
  void estimateVanishingPoint(sVanishingPoint& vpd);*/
 public:
  static FlMainWindow* MainWindow() { return mainapp; };
 public:
  FlMainWindow(int ww,int hh,const char* title = NULL);
  ~FlMainWindow();

  int handle(int event);

  //void draw();

/*   void resize(int x, int y, int ww, int hh); */

  void information(const char* c);
  void mode(const char* c);
  void coordinate(const char* c);
  void result(const char* c);

  void selectpoint(void *data);
  void validpolygon(void *data);
  void equalize(void *data);
  void undo(void *data);

  static sPoint2d im2gl(sPoint2d p);
  static double im2glD(double d);

  //sPoint2d gl2im(sPoint2d);

}; /* class FlMainWindow */

#endif
