#ifndef TRAITEMENT_H
#define TRAITEMENT_H

#include "includes.h"
#include "polygon.h"
#include "fonct.h"

class FlMainWindow;
class FlGlImageViewer;

class Traitement{

 private:

  friend class FlMainWindow;
  friend class FlGlImageViewer;

  Polygon currentPolygon_ombr;
  Polygon currentPolygon_eclair;
  vector<Polygon> polygons_ombr;
  vector<Polygon> polygons_eclair;

  fonct f_eclair_y,f_ombr_y,f_transf_y;//,f_eclair_x,f_ombr_x,f_transf_x,f_eclair_z,f_ombr_z,f_transf_z;
  fonct f_eclair_y2,f_transf_y2;

  unsigned int select_eclair;

  ImageRGB initialImage,transformedImage,normalizedImage,transformedImage2,transformedImage3,pushedImage;
  ImageRGB *viewedImage,*modifiedImage;

  bool _loaded;
  bool _color_viewed,_color_pushed,_color_modified;

/*   void gauss_filter_sub(const ImageRGB &s,ImageRGB &d,float sigma2); */
  void diviz_sub(const ImageRGB &image1,const ImageRGB &image2,ImageRGB &res);
/*   void diviz_sub(const ImageRGB &image1,const ImageRGB &image2,ImageRGB &res,int r,int g,int b); */
  void mult_sub(const ImageRGB &i1,const ImageRGB &i2,ImageRGB &r);
  void double_lum_sub(const ImageRGB &i1,ImageRGB &i2);
/*   void fill_hole(const ImageRGB &image1,const ImageRGB &image2,ImageRGB &res,int rr,int gg,int bb); */

  void superpose(ImageRGB &i1,ImageRGB &i2,ImageRGB &dest,bool* t1,bool *t2);
  void get_map_in(vector<Polygon> vp,bool *t,unsigned int w,unsigned int h);
  void get_maps(vector<Polygon> vp,bool *t_in,bool *t_out,unsigned int w,unsigned int h);
  void get_map_out(vector<Polygon> vp,bool *t,unsigned int w,unsigned int h);
  void get_map_in_out(vector<Polygon> vp_out,vector<Polygon> vp_in,bool *t,unsigned int w,unsigned int h);

 public:

  Traitement();
  
  bool load		(char* fname);
  void save		(char* name);
  bool load_modified	(char* name);
  void load_polygons	(char *name);
  void save_polygons	(char *name);
  void clear_polygons	();
  void equalize();
  void fill_hole	(int rr,int gg,int bb);

  void selective_filter (unsigned int param);
  void gradient		(float param);
  void aniso_diff	(unsigned int iter,int option,float kappa,float lambda);
  void gauss_filter	(unsigned int iter);
  void gauss_filter	(unsigned int iter,bool*t);
  void gauss_filter	(unsigned int iter,bool*t,bool*t2);

  void gray		();
  void normalize       	();

  void push		();
  void diviz		();
/*   void diviz		(int r,int g,int b); */
  void undiviz		();
  void mult		();
  void double_lum	();

  void initial		();
  void modified		();
  void pushed		();

  const ImageRGB& initial_image();
  ImageRGB& transformed_image();
  const ImageRGB& transformed_image2();
  const ImageRGB& transformed_image3();
  const ImageRGB& pushed_image();
  const ImageRGB* modified_image();
  ImageRGB* viewed_image();

  void view_transformed_image();
  void view_transformed_image2();
  void view_transformed_image3();
 
  bool loaded		();
  bool color_viewed	();
  bool color_modified	();

  /*   void gauss_filter(ImageRGB &s,ImageRGB &d,unsigned int iter,bool *t); */
  void gauss_filter_split(unsigned int iter);

};

#endif

