#ifndef FONCT_H
#define FONCT_H

#include "includes.h"

class fonct{

 protected:

  //friend class egalisation;

  map<double,double> _f;
  
 public:

  fonct();
  void clear();
  bool empty()const;
  bool existe_cle(const double x)const;
  const map<double,double>& get_map()const;
  double operator*()const;			// calcule la somme des valeurs definies
  double evaluer(const double x)const;	// acces a la valeur associee , interpolation lineaire si necessaire
  double evaluer_lower(const double x)const;	// acces a la valeur associee inferieure la plus proche, pas d'interpolation lineaire
  double& operator[](const double x);		// initialisation / modification de la valeur
  void operator+=(const double x);		// si la cle y existe : f(x)++ , sinon : f(x) = 1;
  void operator-=(const double x);		// si la cle y existe : f(x)-- , sinon : f(x) = -1;
  fonct operator*(double d)const;	// multiplie les images par d
  fonct operator/(double d)const;	// divise les images par d
  fonct operator!()const;		// fonction reciproque
  fonct operator++()const;		// integrale (milieux)
  fonct integr()const;			// integrale (sommets)
  fonct operator^(const fonct &f)const;	// composee de 2 fonctions
  fonct operator>>(const fonct &f)const;	// fonction d'egalisation d'histogrammes
};

#endif



