

#ifndef GLOBALS_H
//#if(0)

#define GLOBALS_H

#include "includes.h"



//////////////////////////////////////////////////////////////


#define EVENT_FROMKEYBOARD	0x01
#define EVENT_FROMMOUSE		0x02

#define EVENT_KEYPRESSED	0x01
#define EVENT_MOUSEMOVE		0x01
#define EVENT_MOUSEDRAG		0x02
#define EVENT_MOUSEDOWN		0x03
#define EVENT_MOUSEUP		0x04

#define EVENT_NOSTATE		0x00200000
#define EVENT_SHIFT		0x00010000
#define EVENT_CAPS_LOCK		0x00020000
#define EVENT_CTRL		0x00040000
#define EVENT_ALT		0x00080000
#define EVENT_NUM_LOCK		0x00100000
#define EVENT_META		0x00400000
#define EVENT_SCROLL_LOCK	0x00800000
#define EVENT_BUTTON1		0x01000000
#define EVENT_BUTTON2		0x02000000
#define EVENT_BUTTON3		0x04000000

#define EVENT_NOKEY		0x00

#define EVENT_NOBUTTON		0x00
#define EVENT_MOUSELEFT		0x01
#define EVENT_MOUSEMIDDLE	0x02
#define EVENT_MOUSERIGHT	0x03

typedef void ( handlerfunction )(void*,void*);

typedef struct __event
{
  unsigned int _eventsource;
  unsigned int _eventtype;
  unsigned int _eventstate;
  int _key;
  unsigned int _button;
  int operator < (const __event evt) const;
  int operator == (const __event evt) const;
} sEvent;

typedef struct __eventhandling
{
  handlerfunction* _f;
  void* _widget;
  void* _data;
} sEventHandling;

extern sEvent mousemove;
extern sEvent dragleft;
extern sEvent dragmiddle;
extern sEvent dragright;
extern sEvent pushleft;
extern sEvent pushmiddle;
extern sEvent pushright;
extern sEvent releaseleft;
extern sEvent releasemiddle;
extern sEvent releaseright;






//////////////////////////////////////////////////////






/*#define VP_U 1
#define VP_V 2
#define VP_W 3

typedef struct {
  sPoint2d sp,ep;
} sSegment2d;

typedef struct __vanishingelement
{
  sSegment2d glsegment;
  __vanishingelement* prev;
  __vanishingelement* next;
} sVanishingElement;

typedef struct
{
  int nbp;
  sVanishingElement* first;
  sPoint2d vp;
} sVanishingPoint;
*/


extern unsigned int CW_MODE_IMAGE		;
extern unsigned int CW_IMAGE_MOVE		;
/* extern unsigned int CW_IMAGE_ZOOMIN		; */
/* extern unsigned int CW_IMAGE_ZOOMOUT		; */
/* extern unsigned int CW_VANISHING_CREATE     	; */
/* extern unsigned int CW_VANISHING_MOVE       	; */
/* extern unsigned int CW_VANISHING_DELETE     	; */
/* extern unsigned int CW_MODE_ORIGIN		; */

/* extern unsigned int CW_VANISHING_U		; */
/* extern unsigned int CW_VANISHING_V		; */
/* extern unsigned int CW_VANISHING_W		; */

extern unsigned int CW_MODE_EQUALIZING		;
extern unsigned int CW_MODE_DIVIZ		;
extern unsigned int CW_MODE_UNDIVIZ		;
extern unsigned int CW_MODE_MULT		;
extern unsigned int CW_MODE_DOUBLELUM		;

extern unsigned int CW_KEY_SWITCHDEBUG		;
/* extern unsigned int CW_KEY_SWITCHMODE       	; */
extern unsigned int CW_KEY_SWITCHGAUSSMODE     	;
extern unsigned int CW_KEY_LOAD			;
/* extern unsigned int CW_KEY_SAVE	       	; */
/* extern unsigned int CW_KEY_IMPORT		; */
/* extern unsigned int CW_KEY_EXPORT		; */
/* extern unsigned int CW_KEY_CALIBRATE		; */
/* extern unsigned int CW_KEY_RESETVIEW        	; */
extern unsigned int CW_KEY_UNDO  	   	;
//extern unsigned int CW_KEY_SWITCHVANISHING	;

extern unsigned int CW_KEY_INITIAL		;
extern unsigned int CW_KEY_NORMALIZE		;
extern unsigned int CW_KEY_GRAY			;
extern unsigned int CW_KEY_MODIFIED		;
extern unsigned int CW_KEY_LOADGREY		;
extern unsigned int CW_KEY_ANISODIFF		;
extern unsigned int CW_KEY_GAUSSFILTER		;
extern unsigned int CW_KEY_SELECTIVEFILTER     	;
extern unsigned int CW_KEY_GRADIENT     	;
extern unsigned int CW_KEY_PUSHIMAGE	       	;
extern unsigned int CW_KEY_PUSHEDIMAGE	       	;
extern unsigned int CW_KEY_LOAD_POLYGONS      	;
extern unsigned int CW_KEY_SAVE_POLYGONS      	;
extern unsigned int CW_KEY_CLEAR_POLYGONS      	;
extern unsigned int CW_KEY_FILL_HOLE      	;
extern unsigned int CW_KEY_EQUALIZE      	;
extern unsigned int CW_KEY_HISTOGRAM      	;


extern sEvent evt_switchdebug	;
/* extern sEvent evt_switchmode	; */
extern sEvent evt_load		;
extern sEvent evt_save		;
extern sEvent evt_diviz		;
extern sEvent evt_undiviz      	;
extern sEvent evt_mult		;
extern sEvent evt_double_lum   	;
extern sEvent evt_load_grey    	;
extern sEvent evt_aniso_diff	;
extern sEvent evt_gauss_filter	;
extern sEvent evt_selective_filter	;
extern sEvent evt_gradient	;
extern sEvent evt_push_image	;
extern sEvent evt_pushed_image	;
extern sEvent evt_load_polygons	;
extern sEvent evt_save_polygons	;
extern sEvent evt_clear_polygons;
extern sEvent evt_fill_hole	;
extern sEvent evt_equalize	;
extern sEvent evt_histogram	;
/* extern sEvent evt_import    	; */
/* extern sEvent evt_export    	; */
/* extern sEvent evt_calibrate	; */

extern sEvent evt_initmove	;
extern sEvent evt_move		;
extern sEvent evt_initzoom	;
extern sEvent evt_zoom      	;
/* extern sEvent evt_initzoomout; */
/* extern sEvent evt_zoomout	; */
/* extern sEvent evt_endmove	; */
/* extern sEvent evt_endzoomin	; */
/* extern sEvent evt_endzoomout	; */
//extern sEvent evt_resetview	;

/*extern sEvent evt_switchvanish   	;
extern sEvent evt_setstart	   	;
extern sEvent evt_setline		;
extern sEvent evt_setend	   	;
extern sEvent evt_initmovepoint   	;
extern sEvent evt_movepoint		;
extern sEvent evt_endmovepoint   	;
extern sEvent evt_initdeleteline   	;
extern sEvent evt_deleteline		;
extern sEvent evt_enddeleteline   	;
*/

extern sEvent evt_selectpoint	;
extern sEvent evt_validpolygon	;
extern sEvent evt_valid_set_polygons;
extern sEvent evt_undo		;
extern sEvent evt_initial	;
extern sEvent evt_normalize	;
extern sEvent evt_gray		;
extern sEvent evt_modified     	;


extern void FLtoGL(sPoint2d& flp,sPoint2d& glp,int ww,int hh,double ou,double ov,sPoint3d& pc,sVector3d& uc,sVector3d& rc);

extern int default_dash ;
extern int default_fill ;

extern void glDrawVertex2d(const sPoint2d& p);
extern void glDrawDashedLine2d(sPoint2d& sp,sPoint2d& ep);
extern void glDrawLine2d(const sPoint2d& sp,const sPoint2d& ep);

/* extern float get_y(const ImageRGBPixel& p); */
/* extern ImageRGBPixel modif_y(const ImageRGBPixel& p,float y); */


extern void initializeEvent(sEvent& evt,int event);































#endif


