#ifndef _TUNNEL_GUI_FLGENERATETUNNEL_H_
#define _TUNNEL_GUI_FLGENERATETUNNEL_H_

#include "others/includes.h"
#include "gui/Flincludes.h"

class FlGenerateTunnel : public Fl_Window
{
 private:
  /* icons and images */
  Fl_Pixmap* icn_planar;
  Fl_Pixmap* icn_triangular;
  Fl_Pixmap* icn_spherical;
  Fl_Pixmap* image_planar;
  Fl_Pixmap* image_triangular;
  Fl_Pixmap* image_spherical;
  Fl_Pixmap* image_sources[3][3];
 private:
  Fl_Tabs* _tabulator;
  /* general shape of the tunnel */
  Fl_Group* _tunnelShape;
  Fl_Group* _tunnelShapeButton;
  Fl_Button* _tunnelShapeTriangular;
  Fl_Button* _tunnelShapeSpherical;
  Fl_Button* _tunnelShapePlanar;
  Fl_Group* _tunnelShapeLane;
  Fl_Light_Button* _tunnelShapeOneLane;
  Fl_Light_Button* _tunnelShapeTwoLanes;
  Fl_Group* _tunnelShapeDimension;
  Fl_Float_Input* _tunnelShapeLength;
  Fl_Float_Input* _tunnelShapeMaxHeight;
  Fl_Float_Input* _tunnelShapeWidth;
  Fl_Float_Input* _tunnelShapeMinHeight;
  Fl_Float_Input* _tunnelShapeAngle;
  Fl_Group* _tunnelShapeImage;
  /* tunnel's light manager */
  Fl_Group* _tunnelLight;
  Fl_Multi_Browser* _tunnelLightSelector;
  Fl_Group* _tunnelLightButton;
  Fl_Button* _tunnelLightCenter;
  Fl_Button* _tunnelLightMiddle;
  Fl_Button* _tunnelLightSide;
  Fl_Group* _tunnelLightParameters;
  Fl_Light_Button* _tunnelLightSymmetrical;
  Fl_Float_Input* _tunnelLightSpacing;
  Fl_Float_Input* _tunnelLightSlope;
  /* tunnel's material manager */
  Fl_Group* _tunnelMaterial;
  Fl_Multi_Browser* _tunnelFloorSelector;
  Fl_Multi_Browser* _tunnelWallSelector;
  Fl_Multi_Browser* _tunnelRoofSelector;
  /* window manager */
  Fl_Button* _validateButton;
  Fl_Button* _cancelButton;
 protected:
  sTunnelParameters temporaryParameters;
  int _buttonClicked;
  /* button callback functions */
  inline void cb_tunnellight_i(Fl_Widget* o, void* v);
  static void cb_tunnellight(Fl_Widget* o, void* v);
  inline void cb_tunnelshape_i(Fl_Widget* o, void* v);
  static void cb_tunnelshape(Fl_Widget* o, void* v);
  inline void cb_validate_i(Fl_Widget* o, void* v);
  static void cb_validate(Fl_Widget* o, void* v);
  inline void cb_cancel_i(Fl_Widget* o, void* v);
  static void cb_cancel(Fl_Widget* o, void* v);
 public:
  FlGenerateTunnel();
  ~FlGenerateTunnel();

  void draw();
  void resize(const int& xx,const int& yy,const int& ww,const int& hh);
  int handle(int event);
  int clicked();
};

#endif
