#ifndef _TUNNEL_GUI_FLGLVISUSCENE_H_
#define _TUNNEL_GUI_FLGLVISUSCENE_H_

#include "others/includes.h"
#include "others/GlobalData.h"
#include "gui/Flincludes.h"

#include "data/SceneNFF.h"
#include "data/Camera.h"

#include "radiosite/Surface.h"
#include "radiosite/Patch.h"

class FlGlVisuScene : public Fl_Gl_Window
{
 private:
  Env* _resolution;
  SceneNFF* _scene;
  GLuint _scenelist;
  Camera _camera;
  int _moving;
  int _rotating;
  int _straffing;
  int _mouseX;
  int _mouseY;
  int _referenceMouseX;
  int _referenceMouseY;
 private:
  void moveTo(double,double);
  void rotateTo(double,double);
  void straffTo(double,double);
  inline void movingIdle_i();
  inline void rotatorIdle_i();
  inline void straffIdle_i();
  static void movingIdle(void*);
  static void rotatorIdle(void*);
  static void straffIdle(void*);
 protected:
  void glDrawCamera();
  void glDrawScreenLine(double,double,double,double);
  void glDrawPatch(int,Patch&);
  void glDrawSurface(Surface&);
  void glDrawPolygon(PolygonNFF&);
 public:
  FlGlVisuScene(const int& xx,const int& yy,const int& w,const int& h,const char* title = NULL);
  ~FlGlVisuScene();

  void draw();
  void resize(const int& x,const int& y,const int& w,const int& h);
  int handle(int event);

  const Camera& getCamera() const;
};

#endif
