#ifndef _TUNNEL_GUI_FLGLVISUSOURCE_H_
#define _TUNNEL_GUI_FLGLVISUSOURCE_H_

#include "others/includes.h"
#include "gui/Flincludes.h"

class FlSelectSource;

class FlGlVisuSource : public Fl_Gl_Window
{
 private:
  typedef enum { VISUSOURCE_PHOTOMETRY = 0 , VISUSOURCE_GEOMETRY = 1 } eVisuSourceMode;
 private:
  int _firstTimeDrawing;
  enum eVisuSourceMode _visuMode;
  GLuint _axesDrawingList;
  GLuint _sourceDrawingList;
  int _clickedAbcisse;
  FlSelectSource* _sourceSelector;
  double _thetacam;
  double _rhocam;
  double _fovcam;
  /* private methods */
  void initializeAxesDrawingList();
  void initializeSourceDrawingList();
 protected:
 public:
  FlGlVisuSource(const int& xx,const int& yy,const int& w,const int& h,const char* title = NULL);
  ~FlGlVisuSource();

  void draw();
  void resize(const int& xx,const int& yy,const int& ww,const int& hh);
  int handle(int event);

  void link(FlSelectSource* selector);
  int getAbcisse();
};

#endif
