#ifndef _TUNNEL_GUI_FLMANAGEMATERIALLIST_H_
#define _TUNNEL_GUI_FLMANAGEMATERIALLIST_H_

#include "others/includes.h"
#include "gui/Flincludes.h"

#include "data/MaterialReflectanceSpectrum.h"

class FlManageMaterialList : public Fl_Window
{
 private:
  cList< sMaterialReflectanceSpectrum* > materiallist;
  enum eTunnelSurface materialtype;
  int _buttonClicked;
 protected:
  Fl_Select_Browser* _materialList;
  Fl_Button* _addButton;
  Fl_Button* _delButton;
  Fl_Button* _newButton;
  Fl_Button* _validateButton;
  Fl_Button* _cancelButton;
  /* callback methods */
  inline void cb_select_i(Fl_Widget* o, void* v);
  static void cb_select(Fl_Widget* o, void* v);
  inline void cb_add_i(Fl_Widget* o, void* v);
  static void cb_add(Fl_Widget* o, void* v);
  inline void cb_delete_i(Fl_Widget* o, void* v);
  static void cb_delete(Fl_Widget* o, void* v);
  inline void cb_new_i(Fl_Widget* o, void* v);
  static void cb_new(Fl_Widget* o, void* v);
  inline void cb_validate_i(Fl_Widget* o, void* v);
  static void cb_validate(Fl_Widget* o, void* v);
  inline void cb_cancel_i(Fl_Widget* o, void* v);
  static void cb_cancel(Fl_Widget* o, void* v);
 public:
  FlManageMaterialList(enum eTunnelSurface);
  ~FlManageMaterialList();
  void draw();
  int handle(int event);
  int clicked();
};

#endif
