#ifndef _TUNNEL_GUI_FLSIMULATIONPARAMETERS_H_
#define _TUNNEL_GUI_FLSIMULATIONPARAMETERS_H_

#include "others/includes.h"
#include "gui/Flincludes.h"

class FlSimulationParameters : public Fl_Window
{
private:
  static FlSimulationParameters* _win;
  sSimulationParameters temporaryParameters;
private:
  Fl_Tabs* _tabulator;
  /* pre-simulation parameters */
  Fl_Group* _preprocessParameters;
  Fl_Float_Input* _preprocessParametersAreaThreshold;
  Fl_Float_Input* _preprocessParametersLightAreaThreshold;
  Fl_Float_Input* _preprocessParametersThreshold;
  Fl_Float_Input* _preprocessParametersErrorThreshold;
  Fl_Menu_Button* _preprocessParametersMode;
  Fl_Menu_Button* _preprocessParametersWaveletBasis;
  Fl_Value_Slider* _preprocessParametersConfigNumber;
  /* final simulation parameters */
  Fl_Group* _finalParameters;
  Fl_Float_Input* _finalParametersAreaThreshold;
  Fl_Float_Input* _finalParametersLightAreaThreshold;
  Fl_Float_Input* _finalParametersThreshold;
  Fl_Float_Input* _finalParametersErrorThreshold;
  Fl_Menu_Button* _finalParametersMode;
  Fl_Menu_Button* _finalParametersWaveletBasis;
  /* parameters manager */
  Fl_Button* _loadButton;
  Fl_Button* _saveButton;
  Fl_Button* _defaultButton;
  /* window manager */
  Fl_Button* _validateButton;
  Fl_Button* _cancelButton;
 protected:
  int _buttonClicked;
  void init();
  void reinit();
  /* button callback functions */
  inline void cb_load_i(Fl_Widget* o, void* v);
  static void cb_load(Fl_Widget* o, void* v);
  inline void cb_save_i(Fl_Widget* o, void* v);
  static void cb_save(Fl_Widget* o, void* v);
  inline void cb_default_i(Fl_Widget* o, void* v);
  static void cb_default(Fl_Widget* o, void* v);
  inline void cb_validate_i(Fl_Widget* o, void* v);
  static void cb_validate(Fl_Widget* o, void* v);
  inline void cb_cancel_i(Fl_Widget* o, void* v);
  static void cb_cancel(Fl_Widget* o, void* v);
 public:
  FlSimulationParameters();
  ~FlSimulationParameters();

  void draw();
  void resize(const int& xx,const int& yy,const int& ww,const int& hh);
  int handle(int event);
  int clicked();
};

#endif
