#ifndef _CALIB_INCLUDES_H_
#define _CALIB_INCLUDES_H_

#define WITH_FL_GL

#include <math.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <vector>
#include <set>
#include <map>

using namespace std;

/* pour la bibliotheque fltk */

#include <FL/Fl.H>
#include <FL/Enumerations.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Float_Input.H>
#include <FL/Fl_Check_Button.H>
#include <FL/fl_ask.H>
#include <FL/fl_file_chooser.H>
#include <FL/gl.h>

#include <Espws/FileBrowser.h>
#include <Espws/FileChooser.h>

#include <GL/glut.h>

/* pour la bibliotheque utilitaires */

#include <Utility/Includes.h>
#include <Utility/BinaryCoding.h>
#include <Utility/Mode.h>
#include <Utility/Debugger.h>
#include <Utility/Memory.h>
#include <Utility/Statistic.h>
#include <Utility/CounterStatistic.h>
#include <Utility/Utility.h>

#ifdef USENAMESPACE
using namespace DebugManager;
using namespace MemoryManager;
using namespace CallingStatisticManager;
using namespace CounterStatisticManager;
using namespace BinaryCoder;
using namespace Serializer;
using namespace ErrorCode;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque math */

#include <Math/includes.h>
#include <Math/imath.h>
#include <Math/dmath.h>
#include <Math/cmath.h>
#include <Math/NR.h>
#include <Math/functions.h>

#ifdef USENAMESPACE
using namespace NumericalRecipes;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque geometric */

#include <Geometric/Includes.h>
#include <Geometric/BinaryCoding.h>
#include <Geometric/Data.h>
#include <Geometric/Constant.h>
#include <Geometric/Functions.h>
#include <Geometric/IntersectFunctions.h>

#ifdef USENAMESPACE
using namespace Geometric;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque camera */

#include <Camera/includes.h>
#include <Camera/CameraGenerique.h>
#include <Camera/CameraOrthographique.h>
#include <Camera/CameraPerspective.h>
#include <Camera/CameraFile.h>

#ifdef USENAMESPACE
using namespace Camera;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque rle */

#include <Rle/includes.h>
#include <Rle/Enumeration.h>
#include <Rle/Exception.h>
#include <Rle/RLE.h>

#ifdef USENAMESPACE
using namespace Rle;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque tga */

#include <Tga/includes.h>
#include <Tga/Enumeration.h>
#include <Tga/Structures.h>
#include <Tga/Exception.h>
#include <Tga/TgaFile.h>
#include <Tga/TgaFileInput.h>
#include <Tga/TgaFileOutput.h>

#ifdef USENAMESPACE
using namespace Tga;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque image */

#include "Image/includes.h"
#include "Image/ImageRGB.h"
#include "Image/ImageManipulation.h"
#include "Image/ImageIO.h"

enum AXE_DIR {
  ORIGINAL,
  OPPOSITE,
  CROSSPRODUCT,
  OPPCROSS
};



#include "globals.h"

/* #include "polygon.h" */
/* #include "Spectral.h" */
/* #include "fl_float_input.h" */
/* #include "include_filtre.h" */


#endif
