#ifndef _TUNNEL_OTHERS_DEBUGGER_H_
#define _TUNNEL_OTHERS_DEBUGGER_H_

#include <iostream.h>
#include <iomanip.h>

#ifdef DEBUG

extern ostream& consoledebug;
extern long decalagedebug;
extern void decalerdebug();

#define ENTERINGFUNCTION { decalerdebug(); consoledebug << "begin" << " :: " << __FUNCTION__; decalagedebug++; consoledebug.flush(); }
#define EXITINGFUNCTION { decalagedebug--; decalerdebug(); consoledebug << "end" << " :: " << __FUNCTION__ << " :: " << __LINE__; consoledebug.flush(); }

#define TRACEFUNCTION { decalerdebug(); consoledebug << "in" << " :: " << __FUNCTION__ << " :: " << __LINE__; consoledebug.flush(); }

#define TRACECALL(v) { TRACEFUNCTION; consoledebug << " call to " << #v; consoledebug.flush(); }
#define TRACEVARIABLE(v) { consoledebug << "  " << #v << "=[" << v << "]"; consoledebug.flush(); }
#define TRACEMESSAGE(s) { consoledebug << s; consoledebug.flush(); }

#else

#define ENTERINGFUNCTION { }
#define EXITINGFUNCTION { }

#define TRACEFUNCTION { }

#define TRACECALL(v) { }
#define TRACEVARIABLE(v) { }

#endif

#endif
