#ifndef _TUNNEL_ENUMERATION_H_
#define _TUNNEL_ENUMERATION_H_

typedef enum
{
  OFF = 0 ,
  ON = 1
} OnOff;

typedef enum
{
  TUNNELSHAPE_TRIANGULAR = 0 ,
  TUNNELSHAPE_SPHERICAL = 1 ,
  TUNNELSHAPE_PLANAR = 2
} TunnelShape;

typedef enum
{
  TUNNELSHAPE_ONELANE = 0 ,
  TUNNELSHAPE_TWOLANES = 1
} TunnelLane;

typedef enum
{
  TUNNELLIGHT_CENTER = 0 ,
  TUNNELLIGHT_MIDDLE = 1 ,
  TUNNELLIGHT_SIDE = 2
} TunnelLight;

typedef enum
{
  TUNNELSURFACE_FLOOR = 0 ,
  TUNNELSURFACE_WALL = 1 ,
  TUNNELSURFACE_ROOF = 2 ,
  TUNNELSURFACE_LIGHT = 3
} eTunnelSurface;

typedef enum
{
  TUNNELMODEL_NFF = 0 ,
  TUNNELMODEL_INITIAL = 1 ,
  TUNNELMODEL_SOLUTION = 2
} eTunnelModel;

typedef enum
{
  SIMULATIONMODE_SHOOTING = 0 ,
  SIMULATIONMODE_GATHERING = 1
} eSimulationMode;

typedef enum
{
  WAVELETBASIS_LINEAR = 1 ,
  WAVELETBASIS_QUADRATIC = 2
} eWaveletBasis;

typedef enum
{
  SPLITTING_NONE = 0 ,
  SPLITTING_BIN = 2 ,
  SPLITTING_QUAD = 4
} eSurfaceSplittingMode;

typedef enum
{
  ERROR_NONE = 0 ,
  ERROR_FILEOPEN = 1 ,
  ERROR_FILEFORMAT = 2 ,
  ERROR_UNDEFINEDVALUE = 3 ,
  ERROR_WRONGCOMMANDLINEARGUMENT = 4
} eErrorCode;

typedef enum
{
  PARTIALLY_VISIBLE = -1 ,
  INVISIBLE = 0 ,
  FULLY_VISIBLE = 1
} eVisibilityCode;

#endif
