#ifndef _TUNNEL_MACROS_H_
#define _TUNNEL_MACROS_H_

#define ABS(a)   (((a)<(0))?-(a):(a))

/* find minimum of a and b */
#define MIN(a,b)   (((a)<(b))?(a):(b))

/* find maximum of a and b */
#define MAX(a,b) (((a)>(b))?(a):(b))

#define LERP(a,l,h)	((l)+(((h)-(l))*(a)))

#define DISTANCE(a,b) sqrt( (a[0]-b[0])*(a[0]-b[0]) + (a[1]-b[1])*(a[1]-b[1]) + (a[2]-b[2])*(a[2]-b[2]) )

#define SEMIPOINTNFF(a,b) PointNFF((a[0]+b[0])/2.,(a[1]+b[1])/2.,(a[2]+b[2])/2.)
#define VECTORNFF(a,b) PointNFF(((b)[0]-(a)[0])/2.,((b)[1]-(a)[1])/2.,((b)[2]-(a)[2])/2.)
#define LONGUEURNFF(a) DISTANCE((a),(a))
#define CROSSPRODNFF(a,b) PointNFF(((a)[1]*(b)[2])-((a)[2]*(b)[1]),((a)[2]*(b)[0])-((a)[0]*(b)[2]),((a)[0]*(b)[1])-((a)[1]*(b)[0]))
#define NORMALIZENFF(a) PointNFF((a)[0]/LONGUEURNFF((a)),(a)[1]/LONGUEURNFF((a)),(a)[2]/LONGUEURNFF((a)))
#define SUMMNFF(a,b) PointNFF((a)[0]+(b)[0],(a)[1]+(b)[1],(a)[2]+(b)[2])
#define PRODNFF(a,v) PointNFF((a)[0]*v,(a)[1]*v,(a)[2]*v)
#define NORMALNFF(a,b,c) NORMALIZENFF(CROSSPRODNFF(VECTORNFF((a),(b)),VECTORNFF((a),c)))

#endif
