#ifndef _TUNNEL_PARAMETERS_H_
#define _TUNNEL_PARAMETERS_H_

#include "others/includes.h"

class Parameters
{
 private:
 protected:
 public:
  static char _programName[255];
  static char _programDirectory[255];
  static char _language[255];

  static char _requiredRadianceCurveDirectory[255];
  static char _reflectanceMaterialSpectrumDirectory[255];
  static char _lightSourceDirectory[255];
  static char _lightSourceListDirectory[255];
  static char _materialListDirectory[255];
  static char _tunnelParametersDirectory[255];
  static char _simulationParametersDirectory[255];
  static char _resolutionSearchDirectory[255];
  static char _geometricDataDirectory[255];

  static char _requiredRadianceCurveFileExtension[255];
  static char _reflectanceMaterialSpectrumFileExtension[255];
  static char _lightSourceExtension[255];
  static char _listFileExtension[255];
  static char _tunnelParametersFileExtension[255];
  static char _simulationParametersFileExtension[255];
  static char _resolutionSearchFileExtension[255];
  static char _geometricDataFileExtension[255];

  static char _requiredRadianceCurveFilename[255];
  static char _reflectanceMaterialSpectrumFilename[255];
  static char _lightSourceFilename[255];
  static char _lightSourceListFilename[255];
  static char _floorMaterialListFilename[255];
  static char _wallMaterialListFilename[255];
  static char _roofMaterialListFilename[255];
  static char _tunnelFilename[255];
  static char _simulationFilename[255];
  static char _resolutionSearchFilename[255];
  static char _geometricDataFilename[255];

  static float _limiteEntreeDuTunnel;
  static float _surfaceMaximumLength;
  static float _surfaceMaximumAspectRatio;

  static int _MaxM;

  static int _solutionNumber;

  static enum OnOff _interfaceMode;
  static enum OnOff _configurationSearch;
  static enum OnOff _finalSimulation;
  static enum OnOff _outputSearchResult;
 public:
  static void updateParameters();
  static void showCommandLineUsage(char*);
  static void verifyCommandLineParameters();
  static void initializeDefaultParameters();
  static void initializeProgramParameters(char*);
  static void initializeCommandLineModeParameters(int,char**);
  static void initializeCommandLineParameters(int,char**);
  static void initializeParameters(int,char**);
  static eErrorCode loadConfiguration(char*);
  static eErrorCode saveConfiguration(char*);
  static void updateFileParameters(char*,char*,char*,char*);
  static void dumpParameters();
};

#endif
