#ifndef _TUNNEL_TYPES_H_
#define _TUNNEL_TYPES_H_

typedef struct {
  double _curveStopDistance;
  int _curveDataSize;
  double _curveAbcisse[maxNumberOfPointsInRequiredRadianceCurve];
  double _curveValue[maxNumberOfPointsInRequiredRadianceCurve];
} sRequiredRadianceCurve;

typedef struct
{
  struct {
    enum TunnelShape _roofShape;
    enum TunnelLane _floorLanes;
    double _length;
    double _maxHeight;
    double _width;
    double _minHeight;
    double _angle;
  } shape;
  struct {
    cList< int > _lightSelected;
    enum TunnelLight _lightPosition;
    enum OnOff _lightSymmetrical;
    double _lightSpacing;
    double _lightSlope;
  } light;
  struct {
    cList< int > _floorSelected;
    cList< int > _wallSelected;
    cList< int > _roofSelected;
  } material;
} sTunnelParameters;

typedef struct
{
  double _patchAreaThreshold;
  double _lightAreaThreshold;
  double _globalThreshold;
  double _errorThreshold;
  enum eSimulationMode _simulationMode;
  enum eWaveletBasis _waveletBasis;
} sIlluminationParameters;

typedef struct
{
   sIlluminationParameters _preprocessParameters;
  int _configurationNumber;
   sIlluminationParameters _finalstepParameters;
} sSimulationParameters;

#endif
