#ifndef POLYGON_H
#define POLYGON_H

#include "includes.h"

class Polygon{

 protected:


  bool _desc;
  bool _valid;
  vector<sPoint2d> _v;
  map<int,set<int> > _m;
  float _r,_g,_b;

  void inserer(int x, int y);
  void inserer_segment(int x1,int y1,int x2,int y2);
  void init_carte();

 public:
  
  Polygon(float r,float g,float b);

  void init_color(float r,float g,float b);
  //void operator+=(int x,int y);	// ajouter un point
  void operator+=(sPoint2d p);
  void operator!();			// validation du Polygone
  void unvalid();			// invalidation du Polygone
  bool operator*()const;		// le Polygone est-il valide ?
  bool operator()(int x,int y)const;	// le point appartient-il au Polygone ?
  bool operator()(sPoint2d p)const;
  
  void pop();				// enleve le dernier point
  bool empty()const;

#ifdef WITH_FL_GL
  void draw()/*const*/;			// dessiner le Polygone
#endif
  void clear();
  int size()const;

  const vector<sPoint2d>& get_v()const;

};

#endif

