#ifndef _TUNNEL_RADIOSITE_LINK_H_
#define _TUNNEL_RADIOSITE_LINK_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

class Patch;
class Surface;

class Link
{
 private:
  static int _numberOfInstances;
 public:
  static void stat();
 public:
  Patch* source;
  long int no_surface_source;
  long int no_patch_source;
  long int no_cell_source;
  int depth;
  double**** F;
  Link* next_link;
 public:
  Link();
  ~Link();
};

void create_link(int VM,int J_a,Patch *a,int J_b,Patch *b,double *kernel);
int already_exists_link(Patch *a, Patch *b);
void link(int vis,Surface *slist,int M,int J_a,Patch *a,int J_b,Patch *b,double Area_Threshold, double Threshold);
void link2(int vis,Surface *slist,int M,int J_a,Patch *a,int J_b,Patch *b,double Area_Threshold,double Area_Threshold_sources, double Threshold);
void link_lum(int vis,int M,Surface *slist,double Area_Threshold,double Area_Threshold_sources,double Threshold);
void link_surfaces(int M,Surface *slist,double Area_Threshold,double Threshold);
void link_surfaces2(int M,Surface *slist,double Area_Threshold,double Area_Threshold_sources,double Threshold);

#endif
