#ifndef _TUNNEL_RADIOSITE_PATCH_H_
#define _TUNNEL_RADIOSITE_PATCH_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

class Surface;
class Link;

class Patch
{
 private:
  static int _numberOfInstances;
 public:
  static void stat();
 public:
  long int no_cellule;
  long int no_surface;
  long int no_patch;
  Point3 P1,P2,P3,P4;
  double area;
  double min_u,min_v,max_u,max_v;
  double** coeff;
  double** d_coeff;
  double** de_coeff;
  Patch* nextp;
  Link* link;
  Surface* s;
 public:
  Patch();
  Patch(const Patch& p);
  ~Patch();
  Patch& operator=(const Patch& p);
  void getColor(int,int,double,double,double*,double*,double*);
};

void initSurface(Patch& p,Surface* s);
double patch_area(Point3 *P1,Point3 *P2,Point3 *P3,Point3 *P4);
void create_children(Patch *a);
Patch *which_one(Patch *a, Patch *b);

void computeUVspectrum(int M,Patch *p,int factor, double u,double v,double* s,double area);

#endif
