#ifndef _TUNNEL_RADIOSITE_SHOOT_H_
#define _TUNNEL_RADIOSITE_SHOOT_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "radiosite/Patch.h"
#include "radiosite/Surface.h"

void init_delta_B(Env* env);
void init_null_delta_E(Patch *P);
void init_null_delta_B(Patch *P);
double  evaluate_dB( Patch *P);

int reflector(Surface *s);
void get_seen_onestep(Patch *P, Surface** seen, int *nb_seen);
void get_seen(Patch *P, Surface** seen, int *nb_seen);
void link_shoot_onestep(int M,Env *env,Surface* S,double Area_Threshold,double Threshold, Surface* source, Surface** seen, int *nb_seen);
void link_shoot(int M,Env *env,double Area_Threshold,double Threshold, Surface* source, Surface** seen, int *nb_seen);

Surface*  accelerated_shoot_find_source(Env *env, int step);
Surface* find_source(Env *env, int step);

double shoot_energy(Patch *P, Link *l, int M, double Area_Threshold, double Threshold);
void gather_energy_from_patch(Patch *S, Patch *P, int M, double Area_Threshold, double Threshold);
double gather_from_source_with_push_pull(int M,double factor,Patch *p, Surface* source,
					 double **coeffs, double Area);

double accelerated_shoot_from_source(int M,Env *env,double Area_Threshold,double Threshold, Surface* source, Surface** seen, int nb_seen);
double shoot_from_source_onestep(int M,Env *env,int i,double Area_Threshold,double Threshold, Surface* source, Surface** seen, int nb_seen);
double shoot_from_source(int M,Env *env,double Area_Threshold,double Threshold, Surface* source, Surface** seen, int nb_seen);

void push_pull_source(int M, Patch *P);
void print_coeffs_source(Patch P);
void shooter(Env* env, double Area_Threshold, double Threshold, double Error_Threshold,int MaxM);

void Shoot(Env* env, double Area_Threshold, double Threshold, double Error_Threshold,int MaxM);

#endif
