#ifndef _TUNNEL_RADIOSITE_STATICMEMORY_H_
#define _TUNNEL_RADIOSITE_STATICMEMORY_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

class StaticMemory
{
 public:
#define ALLOCATE(v,t) { (v) = new (t); StaticMemory::_memoryallocated += sizeof(t); /* TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated); TRACEVARIABLE(v); */ }
#define ALLOCATEI(v,t,i) { (v) = new (t)(i); StaticMemory::_memoryallocated += sizeof(t); /* TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated); TRACEVARIABLE(v); */ }
#define FREE(v,t) { delete (v); StaticMemory::_memoryallocated -= sizeof(t); /* TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated); TRACEVARIABLE(v); */ }
#define ALLOCATEARRAY(v,t,n) { (v) = (t*)(new (t)[n]); StaticMemory::_memoryallocated += n*sizeof(t); /* TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated); TRACEVARIABLE(v); */ }
#define FREEARRAY(v,t,n) { delete [] (v); StaticMemory::_memoryallocated -= n*sizeof(t); /* TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated); TRACEVARIABLE(v); */ }
 public:
  static long _memoryallocated;
 private:
  static int _allocated;
  static int _maxS;
  static int _maxM;
  static int _M;
 public:
  static double** Shoot_shootenergy_C;
  static double* Shoot_shootenergy_f;
  static double* Shoot_shootenergy_B;
  static double* Shoot_gatherfromsourcewithpushpull_f;
  static double* Shoot_gatherfromsourcewithpushpull_B;
  static double*** Shoot_gatherfromsourcewithpushpull_c;
  static double** Shoot_shootfromsourceonestep_C;
  static double* Shoot_pushpullsource_SW;
  static double* Shoot_pushpullsource_NW;
  static double* Shoot_pushpullsource_SE;
  static double* Shoot_pushpullsource_NE;

  static double* Solver_gatherwithpushpull_f;
  static double* Solver_gatherwithpushpull_B;
  static double*** Solver_gatherwithpushpull_c;
  static double** Solver_solve_C;
  static double** Solver_solve2_C;

  static double** Wavelet_pullupenergytoroot_TMP_PULL;
  static double** Wavelet_pullupenergytoroot_PULL;

  static Vlist *Voxel_addtovlist_p;
 public:
  static void allocate(int maxS,int MaxM,int M);
  static void free(int maxS,int MaxM,int M);
  static void stat();
};

#endif
