#ifndef _TUNNEL_RADIOSITE_STRUCTURES_H_
#define _TUNNEL_RADIOSITE_STRUCTURES_H_

#include "others/includes.h"

#include "others/Parameters.h"

extern  sIlluminationParameters __simulationParameters;

#define Magic_square_size 16
#define maximumIteration 5

#define interactiveMode 1

typedef struct
{
  double x, y;
} Point2;
typedef Point2 Vector2;

typedef struct
{
  double x, y, z;
} Point3;
typedef Point3 Vector3;

typedef struct
{
  Point3 min, max;
} Box3;

#define point_on_line(s,d,t,p) {(p).x=(s).x+t*(d).x;(p).y=(s).y+t*(d).y;(p).z=(s).z+t*(d).z;}

#define project_point(p,P,i) {\
        switch(i){\
                case 0 : /* X axis */ p.x = (P).y; p.y = (P).z; break;\
                case 1 : /* Y axis */ p.x = (P).z; p.y = (P).x; break;\
                case 2 : /* Z axis */ p.x = (P).x; p.y = (P).y; break;\
        }\
}

#define adjust_limits(o) {\
	xlo=x2voxel(volume_grid,(o).bbox.min.x);\
	ylo=y2voxel(volume_grid,(o).bbox.min.y);\
	zlo=z2voxel(volume_grid,(o).bbox.min.z);\
	xhi=x2voxel(volume_grid,(o).bbox.max.x);\
	yhi=y2voxel(volume_grid,(o).bbox.max.y);\
	zhi=z2voxel(volume_grid,(o).bbox.max.z);\
	if (xlo >= volume_grid.x_subdivision) xlo = volume_grid.x_subdivision-1;\
	if (ylo >= volume_grid.y_subdivision) ylo = volume_grid.y_subdivision-1;\
	if (zlo >= volume_grid.z_subdivision) zlo = volume_grid.z_subdivision-1;\
	if (xhi >= volume_grid.x_subdivision) xhi = volume_grid.x_subdivision-1;\
	if (yhi >= volume_grid.y_subdivision) yhi = volume_grid.y_subdivision-1;\
	if (zhi >= volume_grid.z_subdivision) zhi = volume_grid.z_subdivision-1;\
}

#define update_scene_bound(bb,b) {\
        b->min.x = MIN(bb->min.x,b->min.x); b->max.x = MAX(bb->max.x,b->max.x);\
        b->min.y = MIN(bb->min.y,b->min.y); b->max.y = MAX(bb->max.y,b->max.y);\
        b->min.z = MIN(bb->min.z,b->min.z); b->max.z = MAX(bb->max.z,b->max.z);\
}

typedef struct VLIST
{
  int voxnum;
  double t_near,t_far;
  struct VLIST *next;
} Vlist;

typedef struct
{
  Box3 extent;
  int *intersecting_surface_list;
  int nsurfaces;
} Voxel;

typedef struct
{
  Box3 extent;
  Voxel *voxels;
  int x_subdivision,y_subdivision,z_subdivision;
  Point3 voxel_size;
  Point3 voxel_density;
} Volume_grid;

typedef struct
{
  int N_surfaces;
  struct Surface *slist;
} Env;	

#endif
