#ifndef _TUNNEL_RADIOSITE_SURFACE_H_
#define _TUNNEL_RADIOSITE_SURFACE_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "radiosite/Patch.h"
#include "radiosite/OpticalProperty.h"
#include "radiosite/Luminaire.h"

//class Patch;

class Surface
{
 private:
  static int _numberOfInstances;
 public:
  static void stat();
 public:
  int type_surface;
  long int no_cellule;
  long int no_surface;
  Point3 P1,P2,P3,P4;
  Vector3 normal;
  double plane_constant;
  Vector3 Na,Nb,Nc;
  Vector3 Qux,Quy,Qvx,Qvy;
  double Du0,Du1,Du2,Dux,Duy,Dv0,Dv1,Dv2,Dvx,Dvy;
  double a[4];
  int already_done;
  Patch p;
  struct {        
    long ray_num;
    double t,u,v;
  } mail_box;
  double* rho;//[maxNumberOfPointsInSpectrum];
  double* E;//[maxNumberOfPointsInSpectrum];
  Surface* nexts;
  Box3 bbox;
  Optical_prop* o;
  Luminaire* luminaire;
  /* rajoute par moi pour accelerer le tout (surtout les calculs de visibilite) */
  eSurfaceSplittingMode _splitting;
  Surface** _splitted;
  Surface* _highLevelParent;
  Surface* _upperLevelParent;
 public:
  Surface();
  Surface(Surface& s);
  Surface(enum eTunnelSurface type,double p0[3],double p1[3],double p2[3],double p3[3]);
  ~Surface();
  Surface& operator=(const Surface& ss);
};

#endif
