#ifndef _TUNNEL_RADIOSITE_VECTLIB_H_
#define _TUNNEL_RADIOSITE_VECTLIB_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

/* returns squared length of input vector */	
double V3SquaredLength(Vector3 *a) ;
/* returns length of input vector */
double V3Length(Vector3 *a) ;
/* normalizes the input vector and returns it */
Vector3 *V3Normalize(Vector3 *v) ;
/* return vector sum c = a+b */
Vector3 *V3Add(Vector3 *a, Vector3 *b, Vector3 *c);
/* return vector difference c = a-b */
Vector3 *V3Sub(Vector3 *a, Vector3 *b, Vector3 *c);
/* return the dot product of vectors a and b */
double V3Dot(Vector3 *a, Vector3 *b);
/* linearly interpolate between vectors by an amount alpha */
/* and return the resulting vector. */
/* When alpha=0, result=lo.  When alpha=1, result=hi. */
Vector3 *V3Lerp(Vector3 *lo, Vector3 *hi, double alpha, Vector3 *result);
/* return the cross product c = a cross b */
Vector3 *V3Cross(Vector3 *a, Vector3 *b, Vector3 *c);
/* Returns un unoriented angle between zero and pi */
double angle(Vector3 *a,Vector3 *b);

#endif
