#ifndef _TUNNEL_RADIOSITE_VOXEL_H_
#define _TUNNEL_RADIOSITE_VOXEL_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "radiosite/Surface.h"

extern Volume_grid volume_grid;

#define x2voxel(v,a) (((a)-(v).extent.min.x)*(v).voxel_density.x)
#define y2voxel(v,a) (((a)-(v).extent.min.y)*(v).voxel_density.y)
#define z2voxel(v,a) (((a)-(v).extent.min.z)*(v).voxel_density.z)
#define voxel2x(v,a) ((a)*(v).voxel_size.x+(v).extent.min.x)
#define voxel2y(v,a) ((a)*(v).voxel_size.y+(v).extent.min.y)
#define voxel2z(v,a) ((a)*(v).voxel_size.z+(v).extent.min.z)
#define voxel_index(v,x,y,z) ((x*(v).y_subdivision+y)*(v).z_subdivision+z)
#define voxel_addr(v,x,y,z) ((v).voxels+voxel_index(v,x,y,z))

void initializeVolumeGrid();
void spacially_sub_divide(Surface *slist,int nbS);
void preProcess(Surface *slist,int nbS);
void add_to_list(Vlist **vlist,int voxnum,double t1,double t2);
Vlist *create_vlist(Point3 *ray_start,Vector3 *ray_direction,double tmin, double tmax);
void purge_vlist(Vlist *vlist);

#endif
