#ifndef _TUNNEL_RADIOSITE_WAVELET_H_
#define _TUNNEL_RADIOSITE_WAVELET_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "radiosite/Patch.h"

extern double A_f[4][4];
extern double C_f[4][4];

int get_two_power_J(int J);
double Phi(int M,double u);
double MultiWavelet_basis_1v(int J, int M, int k, double u);
double MultiWavelet_basis_2v(int J,int M,int k,double u,int N,int l,double v);
double MultiWavelet_basis_4v(int J,int M,int k,double u,int N,int l,double v,
			     int O, int m, double s, int P, int n, double t);
void push_1v(int M,double *parent,double *L,double *R);
void push_2v(int M,double *parent,double *SW,double *NW,
	     double *SE,double *NE);
void pull_1v(int M,double *parent,double *L,double *R);
void pull_2v(int M,double *parent,double *SW,double *NW,
	     double *SE,double *NE);
void pull_up_energy_to_root(Patch *R, int N, int M, double **C);

#endif
