#ifndef _TUNNEL_RECHERCHE_GLOBALS_H_
#define _TUNNEL_RECHERCHE_GLOBALS_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "radiosite/Surface.h"
#include "radiosite/Patch.h"

#include "data/LightSource.h"
#include "data/MaterialReflectanceSpectrum.h"

typedef struct
{
  int ramp[3];
  int nsou[3];
  sLightSource* sou;
  sMaterialReflectanceSpectrum* fr;
  sMaterialReflectanceSpectrum* wl;
  sMaterialReflectanceSpectrum* rf;
  double prix;
} sRepartition;

typedef struct
{
  int npoint;
  double absrad[maxNumberOfPointsInMotif];
  double radio[maxNumberOfPointsInMotif];
  double ysource;
} Motif;

typedef void (*f_func)(Surface& S);

extern int MM;
extern double AArea_Threshold;
extern double TThreshold;

extern  sTunnelParameters _tp;
extern  sIlluminationParameters _sp;
extern  sRequiredRadianceCurve _rrc;
extern  Motif _mbase;
extern  Motif _mrecouv;
extern  sRepartition tres;

extern int nbSolutions;
extern int maxSolutions;
extern  sRepartition lesSolutions[maxNumberOfConfiguration];

extern Env* _maillage;
extern cList< sLightSource* > _ls;
extern cList< sMaterialReflectanceSpectrum* > _lf;
extern cList< sMaterialReflectanceSpectrum* > _lw;
extern cList< sMaterialReflectanceSpectrum* > _lr;

extern double coutmin;
extern int _numberOfRamps;
extern int _positionOnMotif;
extern int _nbemit;

extern int lfi;
extern int lfw;
extern int lfr;

extern int nbSolutions;
extern  sRepartition lesSolutions[maxNumberOfConfiguration];

ostream& operator<<(ostream& out, sRepartition& r);
void ident( sRepartition& r1, sRepartition& r2);
int vraiegal( sRepartition& r1, sRepartition& r2);
int egal( sRepartition& r1, sRepartition& r2);

#endif
