#ifndef _TUNNEL_RECHERCHE_MAILLAGE_H_
#define _TUNNEL_RECHERCHE_MAILLAGE_H_

#include "others/includes.h"
#include "radiosite/Structures.h"

#include "data/LightSource.h"
#include "data/MaterialReflectanceSpectrum.h"

#include "radiosite/Surface.h"
#include "radiosite/Patch.h"

#include "recherche/Globals.h"

extern int researchMode;

void addLuminaireMaillage( sRepartition& solution,
			   sTunnelParameters& tunnelParameters,
			  sLightSource* light,
			  Env* env);
void addLuminaireMaillage( sTunnelParameters& tunnelParameters,
			  sLightSource* light,
			  Env* env);

Env* getMaillageNoLink( sTunnelParameters& tunnelParameters);
Env* getMaillage( sTunnelParameters& tunnelParameters,
		  sIlluminationParameters& simulationParameters);

void addLights( sRepartition& solution,
	        sTunnelParameters& tunnelParameters, sIlluminationParameters& simulationParameters,
	       sLightSource* light,
	       Env* env);

void addLight( sTunnelParameters& tunnelParameters, sIlluminationParameters& simulationParameters,
	      sLightSource* light,
	      Env* env);

void initializeSpectralProperties( sIlluminationParameters& simulationParameters,sLightSource* light);

void setPhotometricProperties(Env* env,sLightSource* light);

void setPhotometricProperties(Env* env,sMaterialReflectanceSpectrum* floor,
			      sMaterialReflectanceSpectrum* wall,
			      sMaterialReflectanceSpectrum* roof);

void resetLightLinks(Env*);

void removeAllLinks(Patch*);
void removeAllLinks(Env*);

void saveNFF(ostream&,int,Env*,enum OnOff,enum OnOff);

void saveNFF(char*,int,Env*,enum OnOff,enum OnOff);

#endif
