#ifndef _TEMPLATE_PTRELEMENT_H_
#define _TEMPLATE_PTRELEMENT_H_

#include "Element.h"

template <class T> class cElement< T* >
{
 private:
 protected:
  cElement* _next;
  cElement* _prev;
  T* _data;
  cElement() :
    _next(NULL) ,
    _prev(NULL) ,
    _data(NULL)
    {}
  cElement(T*& v) :
    _next(NULL) ,
    _prev(NULL) ,
    _data(v)
    {}
  cElement(cElement * p,cElement * n) :
    _next(n) ,
    _prev(p) ,
    _data(NULL)
    {
      if (p != NULL) p->_next = this;
      if (n != NULL) n->_prev = this;
    }
  cElement(cElement * p,cElement * n,T*& v) :
    _next(n) ,
    _prev(p) ,
    _data(v)
    {
      if (p != NULL) p->_next = this;
      if (n != NULL) n->_prev = this;
    }
  ~cElement()
    {
      if (_next != NULL) _next->_prev = _prev;
      if (_prev != NULL) _prev->_next = _next;
    }

  friend class cList< T* >;
  friend class cListIterator< T* >;
  friend ostream& operator<<< T* >(ostream& out,cList< T* >& v);
};

#endif
