#ifndef _TEMPLATE_PTRLIST_H_
#define _TEMPLATE_PTRLIST_H_

#include "Element.h"
#include "List.h"
#include "ptrElement.h"

template < class T > class cList< T* >
{
 private:
 protected:
  cElement< T* >* _head;
  cElement< T* >* _tail;
  int _card;
  int _isiterating;
 protected:
  void _removeall()
    {
      cElement< T* >* tmp = _head->_next;
      while (tmp != _tail)
	{
	  cElement< T* >* n = tmp->_next;
	  // if (tmp->_data != NULL) delete tmp->_data;
	  delete tmp;
	  _card--;
	  tmp = n;
	}
    }
 public:
  cList() :
    _card(0) ,
    _isiterating(0)
    {
      _head = new cElement< T* >(NULL,NULL);
      _tail = new cElement< T* >(_head,NULL);
    }
  cList(cList< T* >& lst) :
    _card(0) ,
    _isiterating(0)
    {
      _head = new cElement< T* >(NULL,NULL);
      _tail = new cElement< T* >(_head,NULL);
      cElement< T* >* tmp = lst._head->_next;
      while (tmp != lst._tail)
	{
	  T* data = NULL;
	  if (tmp->_data != NULL) data = new T(*(tmp->_data));
	  cElement< T* >* toadd = new cElement< T* >(_tail->_prev,_tail,data);
	  _card++;
	  tmp = tmp->_next;
	}
    }
  ~cList()
    {
      _removeall();
      delete _head;
      delete _tail;
    }
  void freeMemory()
    {
      _removeall();
    }
  int card() const
    {
      return _card;
    }
  cList< T* >& add(T*& v,ListPosition lp = LP_last)
    {
      cElement< T* >* tmp;
      switch (lp)
	{
	case LP_first:
	  tmp = new cElement< T* >(_head,_head->_next,v);
	  _card++;
	  break;
	case LP_last:
	  tmp = new cElement< T* >(_tail->_prev,_tail,v);
	  _card++;
	  break;
	case LP_pos:
	  break;
	default:
	  int idpos = lp - (int)LP_pos;
	  if (idpos < (_card+1))
	    {
	      cElement< T* >* tmpelt = _head->_next; int id = 0;
	      while (id != idpos)
		{
		  tmpelt = tmpelt->_next; id++;
		}
	      tmp = new cElement< T* >(tmpelt->_prev,tmpelt,v);
	    }
	  else
	    {
	    }
	  _card++;
	}
      return *this;
    }
  cList< T* >& del(T*& v)
    {
      if (_isiterating) {}
      cElement< T* >* tmp = _head->_next;
      while ((tmp != _tail) && (tmp->_data != v))
	tmp = tmp->_next;
      if (!(tmp == _tail))
	{
	  delete tmp;
	  _card--;
	}
      return *this;
    }
  T*& operator[](int idx)
    {
      int id = 1;
      cElement< T* >* tmp = _head->_next;
      while ((tmp != _tail) && (id != idx)) { tmp = tmp->_next; id++; }
      if (tmp == _tail) {}
      return tmp->_data;
    }
  T* operator[](int idx) const
    {
      int id = 1;
      cElement< T* >* tmp = _head->_next;
      while ((tmp != _tail) && (id != idx)) { tmp = tmp->_next; id++; }
      if (tmp == _tail) {}
      return tmp->_data;
    }
  cList< T* >& operator =(const cList< T* >& lst)
    {
      if (_isiterating) return *this;
      if (this != &lst)
	{
	  _removeall();
	  cElement< T* >* tmp = lst._head->_next;
	  while (tmp != lst._tail)
	    {
	      T* data = NULL;
	      if (tmp->_data != NULL) data = new T(*(tmp->_data));
	      cElement< T* >* toadd = new cElement< T* >(_tail->_prev,_tail,data);
	      _card++;
	      tmp = tmp->_next;
	    }
	}
      return (*this);
    }
  void iterate(int& it)
    {
      _isiterating = it;
    }
  int iterate() const
    {
      return _isiterating;
    }

  friend class cListIterator< T* >;
  friend ostream& operator<<< T* >(ostream& out,cList< T* >& v);
};

/**
 * stream dumping of a list.
 * dumps a list on a stream.
 * \param ostream& out, the dumping stream.
 * \param cList< T >& v, the list to dump.
 * \return a reference on the dumping stream.
 */
/* template < class T > ostream& operator<<(ostream& out,cList< T >& v) */
/* { */
/*   int precis = out.precision(); */
/*   if (precis == 0) */
/*     { */
/*       out << "List(" << v.card() << ") [" << v._head->_prev << "," << v._head << "," << v._head->_next << "] [" << v._tail->_prev << "," << v._tail << "," << v._tail->_next << "]"; */
/*     } */
/*   else */
/*     { */
/*       out << "(" << v.card() << ") ["; */
/*       for (cListIterator< T > iter = v;!(iter.finished());++iter) */
/* 	out << "\t" << iter.getCurrent() << endl; */
/*       out << "]"; */
/*     } */
/*   return out; */
/* } */

#endif
