#ifndef _CAMERA_BINARYCODING_H_
#define _CAMERA_BINARYCODING_H_

#include "Camera/includes.h"
#include "Camera/CameraGenerique.h"
#include "Camera/CameraOrthographique.h"
#include "Camera/CameraPerspective.h"

#ifdef USENAMESPACE
namespace BinaryCoder
{
  using namespace Camera;
#endif /* #ifdef USENAMESPACE */

  /*! \class BinaryCoding<CameraGenerique>
   * \brief specialization of binary encoding/decoding for CameraGenerique object.
   */
  class BinaryCoding<CameraGenerique> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,CameraGenerique& value);
    static void decode(unsigned char* array,long& index,CameraGenerique& value);
  }; /* class BinaryCoding<CameraGenerique> */

  /*! \class BinaryCoding<CameraOrthographique>
   * \brief specialization of binary encoding/decoding for CameraOrthographique object.
   */
  class BinaryCoding<CameraOrthographique> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,CameraOrthographique& value);
    static void decode(unsigned char* array,long& index,CameraOrthographique& value);
  }; /* class BinaryCoding<CameraOrthographique> */

  /*! \class BinaryCoding<CameraPerspective>
   * \brief specialization of binary encoding/decoding for CameraPerspective object.
   */
  class BinaryCoding<CameraPerspective> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,CameraPerspective& value);
    static void decode(unsigned char* array,long& index,CameraPerspective& value);
  }; /* class BinaryCoding<CameraPerspective> */

#ifdef USENAMESPACE
} /* namespace BinaryCoder */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _CAMERA_BINARYCODING_H_ */
