#ifndef _CAMERA_INCLUDES_H_
#define _CAMERA_INCLUDES_H_

#include <math.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>

using namespace std;

/* pour la bibliotheque utilitaires */

#include <Utility/Includes.h>
#include <Utility/BinaryCoding.h>
#include <Utility/Mode.h>
#include <Utility/Debugger.h>
#include <Utility/Memory.h>
#include <Utility/Statistic.h>
#include <Utility/CounterStatistic.h>
#include <Utility/Utility.h>

#ifdef USENAMESPACE
using namespace DebugManager;
using namespace MemoryManager;
using namespace CallingStatisticManager;
using namespace CounterStatisticManager;
using namespace BinaryCoder;
using namespace Serializer;
using namespace ErrorCode;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque math */

#include <Math/includes.h>
#include <Math/imath.h>
#include <Math/dmath.h>
#include <Math/cmath.h>
#include <Math/NR.h>
#include <Math/functions.h>

#ifdef USENAMESPACE
using namespace NumericalRecipes;
#endif /* #ifdef USENAMESPACE */

/* pour la bibliotheque geometric */

#include <Geometric/Includes.h>
#include <Geometric/BinaryCoding.h>
#include <Geometric/Data.h>
#include <Geometric/Constant.h>
#include <Geometric/Functions.h>
#include <Geometric/IntersectFunctions.h>

#ifdef USENAMESPACE
using namespace Geometric;
#endif /* #ifdef USENAMESPACE */

#ifdef USENAMESPACE
/*! \namespace Camera
 * Namespace containing various camera descriptions with manipulation functions.
 */
namespace Camera
{
#endif /* #ifdef USENAMESPACE */

  /*!
    \enum Camera_Types
  */
  typedef enum {
    CAMERA_GENERIQUE = 0 , /**< generic camera */
    CAMERA_ORTHOGRAPHIQUE = 1 , /**< orthographic camera */
    CAMERA_PERSPECTIVE = 2 /**< perspective camera */
  } Camera_Types;
  /*!
    \brief defines the type 'byte'.
  */
  typedef unsigned char byte;

#ifdef USENAMESPACE
} /* namespace Camera */
#endif /* #ifdef USENAMESPACE */

#ifdef USENAMESPACE
namespace ErrorCode
{
#endif /* #ifdef USENAMESPACE */

  /*! \def CAMERAERROR
   * Camera manipulation error code.
   */
#define CAMERAERROR 3000

#ifdef USENAMESPACE
} /* namespace ErrorCode */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _CAMERA_INCLUDES_H_ */
