#ifndef _GEOMETRIC_BINARYCODING_H_
#define _GEOMETRIC_BINARYCODING_H_

#include "Geometric/Includes.h"
#include "Geometric/Data.h"

#ifdef USENAMESPACE
namespace BinaryCoder
{
#endif /* #ifdef USENAMESPACE */

  /*! \class BinaryCoding<sPoint2d>
   * \brief specialization of binary encoding/decoding for unsigned sPoint2d.
   */
  class BinaryCoding<sPoint2d> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,sPoint2d& value);
    static void decode(unsigned char* array,long& index,sPoint2d& value);
  };
  /*! \class BinaryCoding<sVector2d>
   * \brief specialization of binary encoding/decoding for unsigned sVector2d.
   */
  class BinaryCoding<sVector2d> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,sVector2d& value);
    static void decode(unsigned char* array,long& index,sVector2d& value);
  };
  /*! \class BinaryCoding<sPoint3d>
   * \brief specialization of binary encoding/decoding for unsigned sPoint3d.
   */
  class BinaryCoding<sPoint3d> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,sPoint3d& value);
    static void decode(unsigned char* array,long& index,sPoint3d& value);
  };
  /*! \class BinaryCoding<sVector3d>
   * \brief specialization of binary encoding/decoding for unsigned sVector3d.
   */
  class BinaryCoding<sVector3d> {
  public:
    static int codingSize;
    static void encode(unsigned char* array,long& index,sVector3d& value);
    static void decode(unsigned char* array,long& index,sVector3d& value);
  };

#ifdef USENAMESPACE
} /* namespace BinaryCoder */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _GEOMETRIC_BINARYCODING_H_ */
