#ifndef _GEOMETRIC_CONSTANT_H_
#define _GEOMETRIC_CONSTANT_H_

#include "Geometric/Includes.h"
#include "Geometric/Data.h"

/** \defgroup structureconstant geometric constants for 2d/3d datas. */

#ifdef USENAMESPACE
namespace Geometric
{
#endif /* #ifdef USENAMESPACE */

  /** \var sPoint2d p2d_origine
   * \brief 2d point located at (0.,0.).
   * \ingroup structureconstant
   */
  extern sPoint2d p2d_origine;
  /** \var sVector2d v2d_axex
   * \brief 2d vector describing the x axis of a 2d coordinate system.
   * \ingroup structureconstant
   */
  extern sVector2d v2d_axex;
  /** \var sVector2d v2d_axey
   * \brief 2d vector describing the y axis of a 2d coordinate system.
   * \ingroup structureconstant
   */
  extern sVector2d v2d_axey;
  /** \var sPoint3d p3d_origine
   * \brief 3d point located at (0.,0.,0.).
   * \ingroup structureconstant
   */
  extern sPoint3d p3d_origine;
  /** \var sVector3d v3d_axex
   * \brief 3d vector describing the x axis of a 3d coordinate system.
   * \ingroup structureconstant
   */
  extern sVector3d v3d_axex;
  /** \var sVector3d v3d_axey
   * \brief 3d vector describing the y axis of a 3d coordinate system.
   * \ingroup structureconstant
   */
  extern sVector3d v3d_axey;
  /** \var sVector3d v3d_axez
   * \brief 3d vector describing the z axis of a 3d coordinate system.
   * \ingroup structureconstant
   */
  extern sVector3d v3d_axez;

#ifdef USENAMESPACE
} /* namespace Geometric */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _GEOMETRIC_CONSTANT_H_ */
