#ifndef _IMAGE_IMAGEGRAY_H_
#define _IMAGE_IMAGEGRAY_H_

#include "Image/includes.h"

extern long _allocatedGRAY;

class ImageGRAYPixel {
private:
  static long _nbocc;
  int _depth;
  unsigned char* _data;
  int _allocated;
protected:
public:
  ImageGRAYPixel();
  ImageGRAYPixel(const ImageGRAYPixel&);
  ImageGRAYPixel(int);
  ImageGRAYPixel(unsigned char*,int);
  ~ImageGRAYPixel();

  int Depth() const;
  unsigned char* Data();

  ImageGRAYPixel& operator=(const ImageGRAYPixel&);
  unsigned char& operator[](int idx);
  unsigned char operator[](int idx) const;
  friend void image_memusage();
};

class ImageGRAYLine {
private:
  static long _nbocc;
  int _width;
  int _depth;
  unsigned char *_data;
  int _allocated;
protected:
public:
  ImageGRAYLine();
  ImageGRAYLine(const ImageGRAYLine&);
  ImageGRAYLine(int,int);
  ImageGRAYLine(unsigned char*,int,int);
  ~ImageGRAYLine();

  int Width() const;
  int Depth() const;
  unsigned char* Data();

  ImageGRAYLine& operator=(const ImageGRAYLine&);
  ImageGRAYPixel operator[](int idx);
  ImageGRAYPixel operator[](int idx) const;
  friend void image_memusage();
};

class ImageGRAY {
private:
  static long _nbocc;
  int _width;
  int _height;
  int _depth;
  unsigned char *_data;
  int _allocated;
protected:
public:
  ImageGRAY();
  ImageGRAY(const ImageGRAY&);
  ImageGRAY(int,int,int);
  ImageGRAY(unsigned char*,int,int,int);
  ~ImageGRAY();

  int Width() const;
  int Height() const;
  int Depth() const;
  unsigned char* Data();

  ImageGRAY& operator=(const ImageGRAY&);
  ImageGRAYLine operator[](int idx);
  ImageGRAYLine operator[](int idx) const;
  ImageGRAYPixel operator()(double v,double u);
  friend void image_memusage();
};

#endif
