#ifndef _IMAGE_IMAGEGRAYF_H_
#define _IMAGE_IMAGEGRAYF_H_

#include "Image/includes.h"

extern long _allocatedGRAYf;

class ImageGRAYfPixel {
private:
  static long _nbocc;
  int _depth;
  float* _data;
  int _allocated;
protected:
public:
  ImageGRAYfPixel();
  ImageGRAYfPixel(const ImageGRAYfPixel&);
  ImageGRAYfPixel(int);
  ImageGRAYfPixel(float*,int);
  ~ImageGRAYfPixel();

  int Depth() const;
  float* Data();

  ImageGRAYfPixel& operator=(const ImageGRAYfPixel&);
  float& operator[](int idx);
  float operator[](int idx) const;
  friend void image_memusage();
};

class ImageGRAYfLine {
private:
  static long _nbocc;
  int _width;
  int _depth;
  float* _data;
  int _allocated;
protected:
public:
  ImageGRAYfLine();
  ImageGRAYfLine(const ImageGRAYfLine&);
  ImageGRAYfLine(int,int);
  ImageGRAYfLine(float*,int,int);
  ~ImageGRAYfLine();

  int Width() const;
  int Depth() const;
  float* Data();

  ImageGRAYfLine& operator=(const ImageGRAYfLine&);
  ImageGRAYfPixel operator[](int idx);
  ImageGRAYfPixel operator[](int idx) const;
  friend void image_memusage();
};

class ImageGRAYf {
private:
  static long _nbocc;
  int _width;
  int _height;
  int _depth;
  float *_data;
  int _allocated;
protected:
public:
  ImageGRAYf();
  ImageGRAYf(const ImageGRAYf&);
  ImageGRAYf(int,int,int);
  ImageGRAYf(float*,int,int,int);
  ~ImageGRAYf();

  int Width() const;
  int Height() const;
  int Depth() const;
  float* Data();

  ImageGRAYf& operator=(const ImageGRAYf&);
  ImageGRAYfLine operator[](int idx);
  ImageGRAYfLine operator[](int idx) const;
  ImageGRAYfPixel operator()(double v,double u);
  friend void image_memusage();
};

#endif
