#ifndef _IMAGE_IMAGEMANIPULATION_H_
#define _IMAGE_IMAGEMANIPULATION_H_

#include "Image/includes.h"
#include "Image/ImageRGB.h"
#include "Image/ImageRGBf.h"
#include "Image/ImageGRAY.h"
#include "Image/ImageGRAYf.h"

ImageRGBPixel Interpolation(ImageRGBPixel&,double,ImageRGBPixel&,double);
ImageRGBfPixel Interpolation(ImageRGBfPixel&,double,ImageRGBfPixel&,double);
ImageGRAYPixel Interpolation(ImageGRAYPixel&,double,ImageGRAYPixel&,double);
ImageGRAYfPixel Interpolation(ImageGRAYfPixel&,double,ImageGRAYfPixel&,double);

ImageRGB Scale(ImageRGB&,int,int);
ImageRGBf Scale(ImageRGBf&,int,int);
ImageGRAY Scale(ImageGRAY&,int,int);
ImageGRAYf Scale(ImageGRAYf&,int,int);

ImageRGBPixel toRGB(ImageRGBfPixel&);
ImageRGBPixel toRGB(ImageGRAYPixel&);
ImageRGBPixel toRGB(ImageGRAYfPixel&);

ImageRGBfPixel toRGBf(ImageRGBPixel&);
ImageRGBfPixel toRGBf(ImageGRAYPixel&);
ImageRGBfPixel toRGBf(ImageGRAYfPixel&);

ImageGRAYPixel toGRAY(ImageRGBPixel&);
ImageGRAYPixel toGRAY(ImageRGBfPixel&);
ImageGRAYPixel toGRAY(ImageGRAYfPixel&);

ImageGRAYfPixel toGRAYf(ImageRGBPixel&);
ImageGRAYfPixel toGRAYf(ImageRGBfPixel&);
ImageGRAYfPixel toGRAYf(ImageGRAYPixel&);

ImageRGB toRGB(ImageRGBf&);
ImageRGB toRGB(ImageGRAY&);
ImageRGB toRGB(ImageGRAYf&);

ImageRGBf toRGBf(ImageRGB&);
ImageRGBf toRGBf(ImageGRAY&);
ImageRGBf toRGBf(ImageGRAYf&);

ImageGRAY toGRAY(ImageRGB&);
ImageGRAY toGRAY(ImageRGBf&);
ImageGRAY toGRAY(ImageGRAYf&);

ImageGRAYf toGRAYf(ImageRGB&);
ImageGRAYf toGRAYf(ImageRGBf&);
ImageGRAYf toGRAYf(ImageGRAY&);

ImageRGBf Normalize(ImageRGB&);

ImageRGBf operator*(const ImageRGB&,const float&);
ImageRGBf operator/(const ImageRGB&,const float&);

ImageRGBf operator*(const ImageRGBf&,const float&);
ImageRGBf operator/(const ImageRGBf&,const float&);

ImageGRAYf operator+(const ImageGRAY&,const float&);
ImageGRAYf operator-(const ImageGRAY&,const float&);
ImageGRAYf operator*(const ImageGRAY&,const float&);
ImageGRAYf operator/(const ImageGRAY&,const float&);

ImageGRAYf operator+(const ImageGRAYf&,const float&);
ImageGRAYf operator-(const ImageGRAYf&,const float&);
ImageGRAYf operator*(const ImageGRAYf&,const float&);
ImageGRAYf operator/(const ImageGRAYf&,const float&);

#endif
