#ifndef _IMAGE_IMAGERGB_H_
#define _IMAGE_IMAGERGB_H_

#include "Image/includes.h"

extern long _allocatedRGB;

class ImageRGBPixel {
private:
  static long _nbocc;
  int _depth;
  unsigned char* _data;
  int _allocated;
protected:
public:
  ImageRGBPixel();
  ImageRGBPixel(const ImageRGBPixel&);
  ImageRGBPixel(int);
  ImageRGBPixel(unsigned char*,int);
  ~ImageRGBPixel();

  int Depth() const;
  unsigned char* Data();

  ImageRGBPixel& operator=(const ImageRGBPixel&);
  unsigned char& operator[](int idx);
  unsigned char operator[](int idx) const;
  friend void image_memusage();
};

class ImageRGBLine {
private:
  static long _nbocc;
  int _width;
  int _depth;
  unsigned char* _data;
  int _allocated;
protected:
public:
  ImageRGBLine();
  ImageRGBLine(const ImageRGBLine&);
  ImageRGBLine(int,int);
  ImageRGBLine(unsigned char*,int,int);
  ~ImageRGBLine();

  int Width() const;
  int Depth() const;
  unsigned char* Data();

  ImageRGBLine& operator=(const ImageRGBLine&);
  ImageRGBPixel operator[](int idx);
  ImageRGBPixel operator[](int idx) const;
  friend void image_memusage();
};

class ImageRGB {
private:
  static long _nbocc;
  int _width;
  int _height;
  int _depth;
  unsigned char* _data;
  int _allocated;
protected:
public:
  ImageRGB();
  ImageRGB(const ImageRGB&);
  ImageRGB(int,int,int);
  ImageRGB(unsigned char*,int,int,int);
  ~ImageRGB();

  int Width() const;
  int Height() const;
  int Depth() const;
  unsigned char* Data();

  ImageRGB& operator=(const ImageRGB&);
  ImageRGBLine operator[](int idx);
  ImageRGBLine operator[](int idx) const;
  ImageRGBPixel operator()(double v,double u);
  friend void image_memusage();
};

#endif
