#ifndef _IMAGE_IMAGERGBF_H_
#define _IMAGE_IMAGERGBF_H_

#include "Image/includes.h"

extern long _allocatedRGBf;

class ImageRGBfPixel {
private:
  static long _nbocc;
  int _depth;
  float* _data;
  int _allocated;
protected:
public:
  ImageRGBfPixel();
  ImageRGBfPixel(const ImageRGBfPixel&);
  ImageRGBfPixel(int);
  ImageRGBfPixel(float*,int);
  ~ImageRGBfPixel();

  int Depth() const;
  float* Data();

  ImageRGBfPixel& operator=(const ImageRGBfPixel&);
  float& operator[](int idx);
  float operator[](int idx) const;
  friend void image_memusage();
};

class ImageRGBfLine {
private:
  static long _nbocc;
  int _width;
  int _depth;
  float* _data;
  int _allocated;
protected:
public:
  ImageRGBfLine();
  ImageRGBfLine(const ImageRGBfLine&);
  ImageRGBfLine(int,int);
  ImageRGBfLine(float*,int,int);
  ~ImageRGBfLine();

  int Width() const;
  int Depth() const;
  float* Data();

  ImageRGBfLine& operator=(const ImageRGBfLine&);
  ImageRGBfPixel operator[](int idx);
  ImageRGBfPixel operator[](int idx) const;
  friend void image_memusage();
};

class ImageRGBf {
private:
  static long _nbocc;
  int _width;
  int _height;
  int _depth;
  float* _data;
  int _allocated;
protected:
public:
  ImageRGBf();
  ImageRGBf(const ImageRGBf&);
  ImageRGBf(int,int,int);
  ImageRGBf(float*,int,int,int);
  ~ImageRGBf();

  int Width() const;
  int Height() const;
  int Depth() const;
  float* Data();

  ImageRGBf& operator=(const ImageRGBf&);
  ImageRGBfLine operator[](int idx);
  ImageRGBfLine operator[](int idx) const;
  ImageRGBfPixel operator()(double v,double u);
  friend void image_memusage();
};

#endif
