#ifndef _MATH_NRCHAPTER06SECTION01_H_
#define _MATH_NRCHAPTER06SECTION01_H_

/*!
 * \file Math/NRChapter06Section01.h
 * \brief mathematical functions on float vetor/matrix.
 *
 * mathematical algorithms described in Numerical Recipes Chapter 6, Section 1.
 */

#include "Math/includes.h"

/** \defgroup chapitre06section01 6.1 Gamma Function, Beta Function, Factorials, Binomial Coefficients
 * \ingroup chapitre06
 */

#ifdef USENAMESPACE
namespace NumericalRecipes
{
#endif /* #ifdef USENAMESPACE */

  /*!
    \fn double gammln(double xx)
    \brief logarithm of gamma function
    \ingroup chapitre06section01
    \param xx an integer supposed to be positive (non nul).
    \return the value of the gamma function at point xx.

    As described in "Numerical Recipes in c" p. 214.

    Returns the value of the gamma function at point xx for xx >0.
  */
  extern double gammln(double xx);

#ifdef USENAMESPACE
} /* namespace NumericalRecipes */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _MATH_NRCHAPTER06SECTION01_H_ */
