#ifndef _MATH_NRCHAPTER08_H_
#define _MATH_NRCHAPTER08_H_

/*!
 * \file Math/NRChapter08.h
 * \brief mathematical functions on float vetor/matrix.
 *
 * mathematical algorithms described in Numerical Recipies Chapter 8.
 */

#include "Math/includes.h"

/** \defgroup chapitre08 8. Sorting
 * \ingroup NR
 */

#include "Math/NRChapter08Section04.h"

#ifdef USENAMESPACE
namespace NumericalRecipes
{
#endif /* #ifdef USENAMESPACE */

  /*!
    \fn void iindexx(unsigned long n, long arr[], unsigned long indx[])
    \brief constrct an index for an array.
    \ingroup chapitre08
    \param n size of the array.
    \param arr input array.
    \param indx output indexes on array arr.

    As described in "Numerical Recipes in c" pp. 338-340

    Indexes an array arr[1..n], i.e., outputs the array indx[1..n] such that arr[indx[j]] is in ascending order for j = 1;2; : : :;N. The input quantities n and arr are not changed. Version of indexx with all double variables changed to long.
  */
  void iindexx(unsigned long n, long arr[], unsigned long indx[]);

#ifdef USENAMESPACE
} /* namespace NumericalRecipes */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _MATH_NRCHAPTER08_H_ */

