#ifndef _RADIOSITE_BINARYCODING_H_
#define _RADIOSITE_BINARYCODING_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Surface.h"
#include "Radiosite/Patch.h"
#include "Radiosite/Link.h"

#include "Radiosite/Material.h"
#include "Radiosite/LightSource.h"

#include "Radiosite/Scene.h"
#include "Radiosite/Sky.h"

class BinaryCoding<sPatchID> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sPatchID& value);
  static void decode(unsigned char* array,long& index,sPatchID& value);
};

class BinaryCoding<sLinkID> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sLinkID& value);
  static void decode(unsigned char* array,long& index,sLinkID& value);
};

class BinaryCoding<sContributionKey> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sContributionKey& value);
  static void decode(unsigned char* array,long& index,sContributionKey& value);
};


class BinaryCoding<sLightSource> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sLightSource& value);
  static void decode(unsigned char* array,long& index,sLightSource& value);
};

class BinaryCoding<sMaterial> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sMaterial& value);
  static void decode(unsigned char* array,long& index,sMaterial& value);
};

class BinaryCoding<sSurface> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sSurface& value);
  static void decode(unsigned char* array,long& index,sSurface& value);
};

class BinaryCoding<sPatch> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sPatch& value);
  static void decode(unsigned char* array,long& index,sPatch& value);
};

class BinaryCoding<sLink> {
 public:
  static int codingSize;
  static void encode(unsigned char* array,long& index,sLink& value);
  static void decode(unsigned char* array,long& index,sLink& value);
};

void initializeBinarySize();

#endif
