#ifndef _RADIOSITE_ENUMERATION_H_
#define _RADIOSITE_ENUMERATION_H_

typedef enum
  {
    RESOLUTIONSHOOTING = 1 ,
    RESOLUTIONGATHERING = 2
  } eSimulationMethod;

typedef enum
  {
    WAVELETCONSTANT = 1 ,
    WAVELETLINEAR = 2 ,
    WAVELETBILINEAR = 3 ,
    WAVELETBICUBIQUE = 4
  } eWaveletBasis;

typedef enum
{
  SPLITTINGNONE = 0 ,
  SPLITTINGBINH = 1 ,
  SPLITTINGBINV = 2 ,
  SPLITTINGQUAD = 3
} eSurfaceSplittingMode;

typedef enum
{
  RENDERREAL = 0 ,
  RENDERMATERIALRHOA = 1 ,
  RENDERMATERIALRHOD = 2 ,
  RENDERMATERIALRHOS = 3 ,
  RENDERMATERIALRHOT = 4 ,
  RENDERMATERIALID = 5 ,
  RENDERHIGHESTPATCHID = 6 ,
  RENDERLOWESTPATCHID = 7 ,
  RENDERHIGHESTSURFACEID = 8 ,
  RENDERLOWESTSURFACEID = 9 ,
  RENDERSKYCONTRIBUTION = 10 ,
  RENDERRADIANCE = 11
} eRenderingMode;

typedef enum
{
  HEMISPHERESAMPLING = 0 ,
  SURFACESAMPLING = 1
} eMonteCarloMethod;

typedef enum
{
  PARTIALLYVISIBLE = -1 ,
  INVISIBLE = 0 ,
  FULLYVISIBLE = 1
} eVisibilityCode;

typedef enum
{
  UNIFORM = 1 ,
  MOONSPENCER = 2 ,
  SERENE = 3
} eSkyModel;

typedef enum
{
  FFAREADISC = 0 ,
  FFAREAPOLYGON = 1
} eFormFactorCalculation;

typedef enum
{
  INTERACTIVESTDSTREAM = 1 ,
  INTERACTIVEFILE = 2 ,
  INTERACTIVESOCKET = 3 ,
  INTERACTIVEFUNCTION = 4
} eInteractiveMode;

typedef enum
{
  SAVENONE = 0x0000 ,
  SAVECONTEXT = 0x0001 ,
  SAVEOPTIONS = 0x0002 ,
  SAVESOURCES = 0x0004 ,
  SAVEMATERIALS = 0x0008 ,
  SAVESURFACES = 0x0010 ,
  SAVEPATCHES = 0x0020 ,
  SAVELINKS = 0x0040 ,
  SAVESKYDATA = 0x0080 ,
  SAVEALL = 0x00FF ,
  SAVELOWEST = 0x0100 ,
} eSaveWhat;

typedef enum
{
  WHENNEVER = 0x0000 ,
  WHENSURFACECREATED = 0x0001 ,
  WHENSURFACEDELETED = 0x0002 ,
  WHENSURFACEGEOMETRYMODIFIED = 0x0003 ,
  WHENPATCHCREATED = 0x0004 ,
  WHENPATCHDELETED = 0x008 ,
  WHENPATCHGEOMETRYMODIFIED = 0x000C ,
  WHENLINKCREATED = 0x00010 ,
  WHENLINKDELETED = 0x0020 ,
  WHENLINKGEOMETRYMODIFIED = 0x0030 ,
  WHENGEOMETRYMODIFIED = 0x003F ,
  WHENLOWPATCHPHOTOMETRYMODIFIED = 0x0040 ,
  WHENLOWPHOTOMETRYMODIFIED = 0x0080 ,
  WHENHIGHPHOTOMETRYMODIFIED = 0x0100 ,
  WHENPHOTOMETRYMODIFIED = 0x01C0 ,
  WHENALLMODIFIED = 0x01FF ,
  WHENFINISHEDRESOLUTIONSTEP = 0x0200 ,
  WHENFINISHEDRESOLUTION = 0x0400 ,
  WHENEVERRESOLUTION = 0x0600 ,
  WHENALWAYS = 0x07FF
} eSaveWhen;

#endif
