#ifndef _RADIOSITE_INCLUDES_H_
#define _RADIOSITE_INCLUDES_H_

#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <procbuf.h>

#include <map>
#include <stack>

using namespace std;

/* pour la bibliotheque utilitaires */

#include <Utility/Includes.h>
#include <Utility/BinaryCoding.h>
#include <Utility/Debugger.h>
#include <Utility/Memory.h>
#include <Utility/Statistic.h>
#include <Utility/CounterStatistic.h>
#include <Utility/Utility.h>

/* pour la bibliotheque geometric */

#include <Geometric/Includes.h>
#include <Geometric/BinaryCoding.h>
#include <Geometric/Data.h>
#include <Geometric/Functions.h>
#include <Geometric/IntersectFunctions.h>

/* pour la bibliotheque utilitaires */

#include <Template/include.h>
#include <Template/Element.h>
#include <Template/Stack.h>

/* pour la bibliotheque spectrum */

#include <Spectrum/Includes.h>
#include <Spectrum/Spectrum.h>
#include <Spectrum/SpectrumFile.h>
#include <Spectrum/Lambda.h>
#include <Spectrum/Converter.h>
#include <Spectrum/CIE.h>
#include <Spectrum/Munsell.h>
#include <Spectrum/BinaryCoding.h>
#include <Spectrum/serialiser.h>
#include <Spectrum/unserialiser.h>

/* pour la bibliotheque wavelet */

#include <Wavelet/Includes.h>
#include <Wavelet/Basis.h>
#include <Wavelet/Phi.h>
#include <Wavelet/Gauss.h>
#include <Wavelet/Wavelet.h>

#define USESTRUCT

#define RADIOSITEERROR 4000

#define POLINTERROR 4100
#define COINCIDENTPOINTINARRAYERROR 4101

#define LIGHTERROR 4200
#define TOOFEWDATAINLIGHT 4201
#define LIGHTFILEERROR 4202

#define OPTIONERROR 4300
#define OPTIONFILEERROR 4301
#define UNRECOGNIZEDOPTIONERROR 4302

#define OUTFILEERROR 4400
#define UNDEFINEDFILEEXTENSION 4401
#define OUTFILEOPENING 4402

#define PARAMETERERROR 4500
#define UNDEFINEDPARAMETER 4501
#define MALFORMEDPARAMETER 4502

#endif
