#ifndef _RADIOSITE_KERNEL_H_
#define _RADIOSITE_KERNEL_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Patch.h"

/*
  Neville's 1D interpolation.
  Taken directly from Fortran code found
  in `Numerical Recipes' by Press et al.
*/
extern double Polint(double* x,double* y,double u);

extern double approximateKernel(double* x,double* K,double u,double v,double s,double t);
extern sSpectrumPhotometric evaluateKernel(eVisibilityCode Vis,const __patch& a,double u_a,double v_a,const __patch& b,double u_b,double v_b,int& shadowflag);
extern void computeKernels(eVisibilityCode vis,const __patch& a,const __patch& b,double* kernel);
extern void computeKernels2(const __patch& a,const __patch& b,double* kernel,double* kernel2);

extern void kernelStats();

#endif
