#ifndef _RADIOSITE_LIGHTSOURCE_H_
#define _RADIOSITE_LIGHTSOURCE_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

extern tLightSourceID lightsourceCurrentID;

typedef struct __lightsource
{
  tLightSourceID lightsourceID;
  char _name[255];
  double width;
  double depth;
  double _stepDir;
  int _nbDir;
  double _stepPlans;
  int _nbPlans;
  double _firstPlan;
  int** _values;
} sLightSource;

extern __lightsource* createLightSource();
extern void deleteLightSource(__lightsource*);

extern void loadLightSource(sLightSource* light,istream& inputfile);
extern tLightSourceID loadLightSource(char*);

extern double getLuminanceFromAngle(__lightsource* luminaire,double thetaa,double psii,double Area);

#endif
