#ifndef _RADIOSITE_LINK_H_
#define _RADIOSITE_LINK_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Surface.h"
#include "Radiosite/Patch.h"

typedef struct __linkid
{
  sPatchID _fromID;
  sPatchID _toID;
  __linkid() {};
  __linkid(__patchid f,__patchid t) { _fromID = f; _toID = t; };
  int operator < (const __linkid e2) const { return ((_fromID < e2._fromID) || ((_fromID == e2._fromID) && (_toID < e2._toID))); }
  int operator == (const __linkid e2) const { return ((_fromID == e2._fromID) && (_toID == e2._toID)); }
} sLinkID;

typedef struct __link
{
  __link();
  struct __patch* fromPatch() const;
  struct __patch* toPatch() const;
  struct __link* nextfromlink() const;
  struct __link* prevfromlink() const;
  struct __link* nexttolink() const;
  struct __link* prevtolink() const;
  struct __linkid linkID;
  sSpectrumPhotometric F;  
  sSpectrumPhotometric**** w_F;
  double depth;
  sPatchID nexttolinkID;
  sPatchID nextfromlinkID;
  sPatchID prevtolinkID;
  sPatchID prevfromlinkID;
} sLink;

extern sLink* createLink();
extern void deleteLink(sLink*& l);

extern void deleteFromLink(__patch* s);
extern void deleteToLink(__patch* s);

extern void linkStats();

#endif
