#ifndef _RADIOSITE_MATERIAL_H_
#define _RADIOSITE_MATERIAL_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/LightSource.h"

extern tMaterialID materialCurrentID;

typedef struct __material
{
  struct __lightsource* lightsource();
  tMaterialID materialID;
  tLightSourceID sourceID;
  USESTRUCT sDetailledSpectrum* realspectrum;
  USESTRUCT sSampledSpectrum* usedspectrum;
  sSpectrumPhotometric ambient;
  sSpectrumPhotometric diffuse;
  sSpectrumPhotometric specularreflexion;
  sSpectrumPhotometric speculartransmission;
  sSpectrumPhotometric emissiveness;
  double coefin;
  double coefout;
  double phongexponent;
  char name[255];
} sMaterial;

extern sMaterial* createMaterial();
extern void deleteMaterial(__material*&);

extern tMaterialID loadMaterial(char*);

#endif
