#ifndef _RADIOSITE_ORACLE_H_
#define _RADIOSITE_ORACLE_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Patch.h"
#include "Radiosite/Link.h"

extern sSpectrumPhotometric computeOracle(const __patch* a,const __patch* b);
extern sSpectrumPhotometric computeOracle(const __patch& a,const __patch& b,eVisibilityCode vis,double* kernel,eVisibilityCode& new_vis);

extern sSpectrumPhotometric computeOracleLight(const __patch* a,const __patch* b);
extern sSpectrumPhotometric computeOracleLight(const __patch& a,const __patch& b,eVisibilityCode vis,double* kernel);

extern sSpectrumPhotometric computeOracleLink(const __link* l);
extern sSpectrumPhotometric computeOracleLinkLight(const __link* l);

extern void oracleStats();

#endif
