#ifndef _RADIOSITE_RAY_H_
#define _RADIOSITE_RAY_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Patch.h"
#include "Radiosite/Surface.h"

typedef struct __ray
{
  /* ray data */
  int rayLevel;
  USESTRUCT sLine3d rayLine;
  USESTRUCT sSurface* sourceSurface;
  /* intersection geometric data */
  sGeometricData currentItersectionRayParameter;
  USESTRUCT sPoint3d currentIntersectionPoint3d;
  USESTRUCT sPoint2d currentIntersectionPoint2d;
  USESTRUCT sPoint2d currentIntersectionPatchPoint2d;
  USESTRUCT sPatch* currentIntersectionPatch;
  USESTRUCT sSurface* currentIntersectionHighestSurface;
  USESTRUCT sSurface* currentIntersectionLowestSurface;
  /* intersection photometric data */
  USESTRUCT sSampledSpectrum* currentIntersectionPhotometry;
} sRay;

extern sRay* createRay();
extern void deleteRay(sRay*& s);

extern void initializeLowestIntersectionSurface(sRay& r);
extern void travelSurfaceHierarchy(sRay& r);
extern void travelPatchHierarchy(sRay& r);

#endif
