#ifndef _RADIOSITE_RAYTRACE_H_
#define _RADIOSITE_RAYTRACE_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Patch.h"
#include "Radiosite/Surface.h"
#include "Radiosite/Ray.h"

extern int intersectPrimaryRayPatch(sRay& r,sPatch& s);
extern int intersectPrimaryRaySurface(sRay& r,sSurface& s);
extern int intersectPrimaryRayScene(sRay& r);

extern int intersectSecondaryRayScene(sRay& r);

extern int intersectShadowRayScene(sRay& r);

extern unsigned char* raytrace(sPoint3d& origine,sVector3d& direction,sVector3d& right,sVector3d& up,
			       double focal,double width,double height,
			       int resx,int resy,int resz);

#endif
