#ifndef _RADIOSITE_SCENE_H_
#define _RADIOSITE_SCENE_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Surface.h"
#include "Radiosite/Patch.h"
#include "Radiosite/Link.h"

#include "Radiosite/Material.h"
#include "Radiosite/LightSource.h"

extern map < tLightSourceID , __lightsource* > __sceneLightSources;
typedef  map < tLightSourceID , __lightsource* >::const_iterator lightIterator;

extern map < tMaterialID , __material* > __sceneMaterials;
typedef map < tMaterialID , __material* >::const_iterator materialIterator;

extern map < tSurfaceID , __surface* > __sceneSurfaces;
typedef map < tSurfaceID , __surface* >::const_iterator surfaceIterator;

extern map < sPatchID , __patch* > __scenePatches;
typedef map < sPatchID , __patch* >::const_iterator patchIterator;

extern map < sLinkID , __link* > __sceneLinks;
typedef map < sLinkID , __link* >::const_iterator linkIterator;

extern void initializeSpectrumSampling();

extern void sceneStats();

extern void resetScene();

extern void interactiveCallToVisualizer(int finished = 0);

extern void exportScene(char* fname);
extern void importScene(char* fname);

extern void saveScene(char* fname);
extern void loadScene(char* fname);

extern void solveLighting();

#endif
