#ifndef _RADISOSITE_SKY_H_
#define _RADISOSITE_SKY_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Surface.h"
#include "Radiosite/Patch.h"
#include "Radiosite/Link.h"

#include "Radiosite/Material.h"
#include "Radiosite/LightSource.h"

typedef struct __contributionkey
{
  sPoint3d p;
  sVector3d v;
  int lvl;
  __contributionkey(sPoint3d& pp,sVector3d& vv,int level) { copyPoint3d(pp,p); copyVector3d(vv,v); lvl = level; }
  __contributionkey() { initPoint3d(p,0.,0.,0.); initVector3d(v,0.,0.,0.); lvl = 0; }
} sContributionKey;

typedef void (tMontecarloFunction)(double,double,double);

extern sDetailledSpectrum* skyRealSpectrum;
extern sSampledSpectrum* skySampledSpectrum;
extern sSpectrumPhotometric sunZenithRadiance;

extern map < sContributionKey , sSampledSpectrum* > skyContributions;
typedef map < sContributionKey , sSampledSpectrum* >::const_iterator skycontributionIterator;

extern int operator < (const sPoint3d& p1, const sPoint3d& p2);
extern int operator < (const sVector3d& p1, const sVector3d& p2);
extern int operator < (const sContributionKey& p1, const sContributionKey& p2);

extern void initializeSkyModel();

extern sSampledSpectrum* computeSkyContribution(sPatch* p,int level,int idpoint);
extern void computeSkyContribution(sPatch* p,int level,int idpoint,sSampledSpectrum* sky);
extern void addSkyContribution(sPatch* p,int level,int idpoint,sSampledSpectrum* current);
extern void addSkyContribution(sPatch* p,int level,sSampledSpectrum* current);

extern void initializeSkyContribution(sPatch* P);
extern void initializeSkyContribution(sSurface* S);
extern void initializeSkyContribution();

#endif
