#ifndef _RADIOSITE_VISIBILITY_H_
#define _RADIOSITE_VISIBILITY_H_

#include "Radiosite/Includes.h"
#include "Radiosite/Enumeration.h"
#include "Radiosite/Globals.h"

#include "Radiosite/Utility.h"
#include "Radiosite/Options.h"

#include "Radiosite/Surface.h"
#include "Radiosite/Patch.h"

extern int whichSidePointPlane(sPoint3d& p,sPlane3d& b);
extern int whichSidePolygonPlane(sPatch& a,sPatch& b);
extern int whichSidePolygonPlane(sSurface& a,sSurface& b);

extern int shadowRayTest(sPoint3d& start,sPoint3d& end);
extern int shadowRayTest(sPoint3d& start,sPoint3d& end,sSurface& S);
extern int underShadowTest1(sPlane3d& a,sPoint3d& start,sPlane3d& b,sPoint3d& end,sSurface* Sa,sSurface* Sb);
extern int underShadowTest2(sPlane3d& a,sPoint3d& start,sPlane3d& b,sPoint3d& end,sSurface* Sa,sSurface* Sb);

extern eVisibilityCode fastVisibilityTest(sPatch& s0,sPatch& s1);
extern eVisibilityCode fastVisibilityTest(sSurface& s0,sSurface& s1);
extern double complexVisibilityTest(sPatch& a,sPatch& b);

extern double computeVisibilityFactor(sPatch& a,sPatch& b);
extern double computeVisibilityFactor(sPoint3d& p,sVector3d& n,sSurface& S);

#endif
