#ifndef _RLE_ENUMERATION_H_
#define _RLE_ENUMERATION_H_

#ifdef USENAMESPACE
/*!
  \namespace Rle
  \brief namespace contaning utility functions and datas for rle compression/decompression.
*/
namespace Rle
{
#endif /* #ifdef USENAMESPACE */

  /*!
    \def PHM_PACKETTYPE
    \brief mask to access the type of a packet.
   */
#define PHM_PACKETTYPE 0x80
  /*!
    \def PHM_PACKETCOUNT
    \brief mask to access the number of bytes in a packet.
   */
#define PHM_PACKETCOUNT 0x7F
  /*!
    \def PH_RUNLENGTHPACKET
    \brief flag to indicate a run-length encoded packet.
   */
#define PH_RUNLENGTHPACKET 0x80
  /*!
    \def PH_RAWPACKET
    \brief flag to indicate a raw packet.
   */
#define PH_RAWPACKET 0
  /*!
    \enum eRleErrorCode
    \brief enumeration containing rle decoding error codes.
   */
  typedef enum
    {
      REC_NONE = 0 , /**< no error. */
      REC_INVALIDPACKETTYPE = 1 , /**< wrong packet type error. */
      REC_INVALIDDATASIZE = 2 /**< wrong packet size error. */
    } eRleErrorCode;

#ifdef USENAMESPACE
} /* namespace Rle */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _RLE_ENUMERATION_H_ */
