#ifndef _RLE_RLE_H_
#define _RLE_RLE_H_

#include "Rle/includes.h"
#include "Rle/Enumeration.h"

#ifdef USENAMESPACE
/*!
  \namespace Rle
  \brief namespace contaning utility functions and datas for rle compression/decompression.
*/
namespace Rle
{
#endif /* #ifdef USENAMESPACE */

  /*!
    \fn void uncompress(byte* sd,long sl,byte* dd,long dl,int ds)
    \brief rle buffer decompression.
    \param sd byte*, the source buffer.
    \param sl long, length of the source buffer.
    \param dd byte*, the destination buffer.
    \param dl long, size of the destination buffer.
    \param ds int, size of one data.
   */
  extern void uncompress(byte* sd,long sl,byte* dd,long dl,int ds);

#ifdef USENAMESPACE
} /* namespace Rle */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _RLE_RLE_H_ */
