#ifndef _SOURCE_INCLUDES_H_
#define _SOURCE_INCLUDES_H_

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>

/* pour la stl */

#include <map>

using namespace std;

/* pour la bibliotheque utilitaires */

#include <Utility/Includes.h>
#include <Utility/BinaryCoding.h>
#include <Utility/Mode.h>
#include <Utility/Debugger.h>
#include <Utility/Memory.h>
#include <Utility/Statistic.h>
#include <Utility/CounterStatistic.h>
#include <Utility/Utility.h>

/* pour la bibliotheque spectrum */

#include <Spectrum/Includes.h>
#include <Spectrum/Spectrum.h>
#include <Spectrum/SpectrumFile.h>
#include <Spectrum/Lambda.h>
#include <Spectrum/Converter.h>
#include <Spectrum/CIE.h>
#include <Spectrum/Munsell.h>
#include <Spectrum/BinaryCoding.h>
#include <Spectrum/serialiser.h>
#include <Spectrum/unserialiser.h>

#ifndef MAX
#define MAX(a,b) ((a) < (b) ? (b) : (a))
#endif

#ifndef MIN
#define MIN(a,b) ((a) > (b) ? (b) : (a))
#endif

#define maxNumberOfLightSubdivisionPlane 40
#define maxNumberOfLightSubdivisionDirection 40

#endif
