#ifndef _SOURCE_LIGHTSOURCE_H_
#define _SOURCE_LIGHTSOURCE_H_

#include "Source/Includes.h"

typedef long long tLightSourceID;

extern tLightSourceID lightsourceCurrentID;

typedef struct __lightsource
{
  tLightSourceID lightsourceID;
  string _name;
  double width;
  double depth;
  double _stepDir;
  int _nbDir;
  double _stepPlans;
  int _nbPlans;
  double _firstPlan;
  int** _values;
  sSpectrumPhotometric _temperature;
  sSpectrumPhotometric _wattinput;
  sSpectrumPhotometric _lumenoutput;
} sLightSource;

extern __lightsource* createLightSource();
extern void deleteLightSource(__lightsource*);

extern map < string , __lightsource* > __sourceByNameList;
typedef  map < string , __lightsource* >::const_iterator sourceByNameIterator;

extern map < tLightSourceID , __lightsource* > __sourceByIdList;
typedef  map < tLightSourceID , __lightsource* >::const_iterator sourceByIdIterator;

extern void registerLightSource(__lightsource& s);
extern void unregisterLightSource(__lightsource& s);
extern void unregisterLightSource(string name);
extern void unregisterLightSource(tLightSourceID id);

#endif
