#ifndef _SPECTRUM_CONVERTER_H_
#define _SPECTRUM_CONVERTER_H_

#include "Spectrum/Includes.h"

#include "Spectrum/Spectrum.h"

extern sSpectrumPhotometric gammaCorrectionFactor;

extern void clampComponent(sSpectrumPhotometric& r, sSpectrumPhotometric& g, sSpectrumPhotometric& b);

extern void gammaCorrection(sSpectrumPhotometric& R, sSpectrumPhotometric& V, sSpectrumPhotometric& B);

extern void XYZtoRGB(sSpectrumPhotometric X, sSpectrumPhotometric Y, sSpectrumPhotometric Z, sSpectrumPhotometric& R, sSpectrumPhotometric& V, sSpectrumPhotometric& B);
extern void RGBtoXYZ(sSpectrumPhotometric R, sSpectrumPhotometric V, sSpectrumPhotometric B, sSpectrumPhotometric& X, sSpectrumPhotometric& Y, sSpectrumPhotometric& Z);

extern void XYZtoLAB(sSpectrumPhotometric X, sSpectrumPhotometric Y, sSpectrumPhotometric Z, sSpectrumPhotometric& L, sSpectrumPhotometric& a, sSpectrumPhotometric& b);
extern void LABtoXYZ(sSpectrumPhotometric L, sSpectrumPhotometric a, sSpectrumPhotometric b, sSpectrumPhotometric& X, sSpectrumPhotometric& Y, sSpectrumPhotometric& Z);

extern void YIQtoRGB(sSpectrumPhotometric Y, sSpectrumPhotometric I, sSpectrumPhotometric Q, sSpectrumPhotometric& R, sSpectrumPhotometric& V, sSpectrumPhotometric& B);
extern void RGBtoYIQ(sSpectrumPhotometric R, sSpectrumPhotometric V, sSpectrumPhotometric B, sSpectrumPhotometric& Y, sSpectrumPhotometric& I, sSpectrumPhotometric& Q);

extern void HSVtoRGB(sSpectrumPhotometric H,sSpectrumPhotometric S,sSpectrumPhotometric V,sSpectrumPhotometric& R,sSpectrumPhotometric& G,sSpectrumPhotometric& B);
extern void RGBtoHSV(sSpectrumPhotometric R, sSpectrumPhotometric G, sSpectrumPhotometric B, sSpectrumPhotometric& H, sSpectrumPhotometric& S, sSpectrumPhotometric& V);

extern void HLStoRGB(sSpectrumPhotometric H,sSpectrumPhotometric L,sSpectrumPhotometric S,sSpectrumPhotometric& R,sSpectrumPhotometric& G,sSpectrumPhotometric& B);
extern void RGBtoHLS(sSpectrumPhotometric R, sSpectrumPhotometric G, sSpectrumPhotometric B, sSpectrumPhotometric& H, sSpectrumPhotometric& L, sSpectrumPhotometric& S);

extern void XYZtoXY(sSpectrumPhotometric X, sSpectrumPhotometric Y, sSpectrumPhotometric Z, sSpectrumPhotometric& x, sSpectrumPhotometric& y);

extern void CYMKtoRGB(sSpectrumPhotometric C,sSpectrumPhotometric M,sSpectrumPhotometric Y,sSpectrumPhotometric K,sSpectrumPhotometric& R,sSpectrumPhotometric& V,sSpectrumPhotometric& B);

extern void CYMtoRGB(sSpectrumPhotometric C,sSpectrumPhotometric M,sSpectrumPhotometric Y,sSpectrumPhotometric& R,sSpectrumPhotometric& V,sSpectrumPhotometric& B);

extern void RGBtoCorrectedRGB(sSpectrumPhotometric& R, sSpectrumPhotometric& V, sSpectrumPhotometric& B);

extern void XYtoCCT(sSpectrumPhotometric X, sSpectrumPhotometric Y, sSpectrumPhotometric& CCT);

extern sSpectrumPhotometric Km;
extern void computeKmFactor(sSpectrumPhotometric Kmax,int night = 0);

extern void SPECTRUMtoXYZ(sDetailledSpectrum& SpectreIn, sSpectrumPhotometric& X, sSpectrumPhotometric& Y, sSpectrumPhotometric& Z,int small = 0);
extern void SPECTRUMtoXYZ(sSampledSpectrum& SpectreIn, sSpectrumPhotometric& X, sSpectrumPhotometric& Y, sSpectrumPhotometric& Z,int small = 0);

extern sSpectrumPhotometric SPECTRUMintegrate(sDetailledSpectrum& SpectreIn);
extern sSpectrumPhotometric SPECTRUMintegrate(sSampledSpectrum& SpectreIn);

extern sSpectrumPhotometric SPECTRUMradiance(sDetailledSpectrum& SpectreIn,int night = 0);
extern sSpectrumPhotometric SPECTRUMradiance(sSampledSpectrum& SpectreIn,int night = 0);

#endif
