#ifndef _SPECTRUM_SPECTRUM_H_
#define _SPECTRUM_SPECTRUM_H_

#include "Spectrum/Includes.h"

typedef struct __sampledspectrum
{
  sSpectrumPhotometric operator()(sSpectrumPhotometric lambda);
  int _size;
  sSpectrumPhotometric* _data;
} sSampledSpectrum;

typedef struct __detailledspectrum
{
  __detailledspectrum(char* n = NULL);
  __detailledspectrum(char* n,int s,int fs,sSpectrumPhotometric* l,sSpectrumPhotometric* d);
  ~__detailledspectrum();
  sSpectrumPhotometric operator()(sSpectrumPhotometric lambda);
  sSpectrumPhotometric max();
  sSpectrumPhotometric min();
  string name;
  int _size;
  int _filledSize;
  sSpectrumPhotometric* _lambda;
  sSpectrumPhotometric* _data;
} sDetailledSpectrum;

typedef struct
{
  sSpectrumPhotometric _lambda;
  sSpectrumPhotometric _data;
} sSpectrumSample;

extern map < string , __detailledspectrum* > __detailledSpectraList;
typedef  map < string , __detailledspectrum* >::const_iterator spectraIterator;

extern sSampledSpectrum* createSampledSpectrum(const int& nb);
extern void deleteSampledSpectrum(sSampledSpectrum*& s);

extern sDetailledSpectrum* createDetailledSpectrum(const int& nb,char* n = NULL);
extern void deleteDetailledSpectrum(sDetailledSpectrum*& s);

extern void registerSpectrum(sDetailledSpectrum& s);
extern void unregisterSpectrum(string name);

extern sDetailledSpectrum* blackbodySpectrum(sSpectrumPhotometric T,sSpectrumPhotometric mn = minWavelength,sSpectrumPhotometric mx = maxWavelength,sSpectrumPhotometric d = deltaWavelength);

#endif
