#ifndef _UTILITY_MODE_H_
#define _UTILITY_MODE_H_

#include "Utility/Includes.h"

#ifdef USENAMESPACE
namespace DebugManager
{
#endif /* #ifdef USENAMESPACE */

  /*! \var eOnOff _debugMode
   * Switch indicating if debug mode is activated.
   */
extern eOnOff _debugMode;
  /*! \fn eOnOff getDebugMode()
   * Access to the state of debug mode.
   */
extern eOnOff getDebugMode();
  /*! \fn void setDebugMode()
   * Activate debug mode.
   */
extern void setDebugMode();
  /*! \fn void unsetDebugMode()
   * Desactivate debug mode.
   */
extern void unsetDebugMode();

#ifdef USENAMESPACE
}
#endif /* #ifdef USENAMESPACE */

#ifdef USENAMESPACE
namespace MemoryManager
{
#endif /* #ifdef USENAMESPACE */

  /*! \var eOnOff _memoryMode
   * Switch indicating if memory mode is activated.
   */
extern eOnOff _memoryMode;
  /*! \fn eOnOff getMemoryMode()
   * Access to the state of memory mode.
   */
extern eOnOff getMemoryMode();
  /*! \fn void setMemoryMode()
   * Activate memory mode.
   */
extern void setMemoryMode();
  /*! \fn void unsetMemoryMode()
   * Desactivate memory mode.
   */
extern void unsetMemoryMode();

#ifdef USENAMESPACE
} /* namespace MemoryManager */
#endif /* #ifdef USENAMESPACE */

#ifdef USENAMESPACE
namespace CallingStatisticManager
{
#endif /* #ifdef USENAMESPACE */

  /*! \var eOnOff _timeStatisticMode
   * Switch indicating if time statistics mode is activated.
   */
extern eOnOff _timeStatisticMode;
  /*! \fn eOnOff getTimeStatisticMode()
   * Access to the state of time statistics mode.
   */
extern eOnOff getTimeStatisticMode();
  /*! \fn void setTimeStatisticMode()
   * Activate time statistics mode.
   */
extern void setTimeStatisticMode();
  /*! \fn void unsetTimeStatisticMode()
   * Desactivate time statistics mode.
   */
extern void unsetTimeStatisticMode();
  /*! \var eOnOff _callStatisticMode
   * Switch indicating if call statistics mode is activated.
   */
extern eOnOff _callStatisticMode;
  /*! \fn eOnOff getCallStatisticMode()
   * Access to the state of call statistics mode.
   */
extern eOnOff getCallStatisticMode();
  /*! \fn void setCallStatisticMode()
   * Activate call statistics mode.
   */
extern void setCallStatisticMode();
  /*! \fn void unsetCallStatisticMode()
   * Desactivate call statistics mode.
   */
extern void unsetCallStatisticMode();

#ifdef USENAMESPACE
} /* namespace CallingStatisticManager */
#endif /* #ifdef USENAMESPACE */

#ifdef USENAMESPACE
namespace CounterStatisticManager
{
#endif /* #ifdef USENAMESPACE */

  /*! \var eOnOff _counterMode
   * Switch indicating if counter mode is activated.
   */
extern eOnOff _counterMode;
  /*! \fn eOnOff getCounterMode()
   * Access to the state of counter mode.
   */
extern eOnOff getCounterMode();
  /*! \fn void setCounterMode()
   * Activate counter mode.
   */
extern void setCounterMode();
  /*! \fn void unsetCounterMode()
   * Desactivate counter mode.
   */
extern void unsetCounterMode();

#ifdef USENAMESPACE
} /* namespace CounterStatisticManager */
#endif /* #ifdef USENAMESPACE */

#endif /* #ifndef _UTILITY_MODE_H_ */
