#ifndef _UTILITY_UTILITY_H_
#define _UTILITY_UTILITY_H_

#include "Utility/Includes.h"

/*! \fn int findNextArrayIndex(T* valuearray,T refvalue,int nbmax)
 * template function to find an element in an array.
 * it returns the index of the element directly superior to the one looked for.
 * \param valuearray T*, the array.
 * \param refvalue T, the value to find.
 * \param nbmax int, the size of the array.
 * \return the index on the array to place the value.
 */
template <class T> int findNextArrayIndex(T* valuearray,T refvalue,int nbmax) {
  int idx = 0;
  while ((idx < nbmax) && (valuearray[idx] < refvalue)) idx++;
  return idx;
}

/*! \fn int findPreviousArrayIndex(T* valuearray,T refvalue,int nbmax)
 * template function to find an element in an array.
 * it returns the index of the element directly inferior to the one looked for.
 * \param valuearray T*, the array.
 * \param refvalue T, the value to find.
 * \param nbmax int, the size of the array.
 * \return the index on the array to place the value.
 */
template <class T> int findPreviousArrayIndex(T* valuearray,T refvalue,int nbmax) {
  int idx = 0;
  while ((idx < nbmax) && (valuearray[idx] < refvalue)) idx++;
  return idx-1;
}

#endif /* #ifndef _UTILITY_UTILITY_H_ */
