#ifndef _WAVELET_BASIS_H_
#define _WAVELET_BASIS_H_

#include "Wavelet/Includes.h"

/*
  Wavelet Tools
  -----
  Author: S. N. Pattanaik
  Date  : 7-12-93
*/

extern unsigned int Bases_1v[];
extern unsigned int Bases_2v[];
extern unsigned long Bases_4v[L+1];

extern int  M,two_M;
extern sWaveletData *H, *G;
extern sWaveletData *G_H_2[MAX_M];
extern sWaveletData *G_H_4[MAX_M_x_MAX_M];

extern int init_filters(int m,sWaveletData *H_filters,int reso);
extern void deinit_filters();
extern int reconstruct_1v(sWaveletData *coeffs,int j);
extern int decompose_1v(sWaveletData *coeffs,int j);
extern int integral_operator_1v(int j,sWaveletData *s_space,sWaveletData *d_space, sWaveletData *i_space);
extern int integral_operator_2v(int j,sWaveletData *s_space,sWaveletData *d_space,sWaveletData *i_space);
extern int decompose_2v(int j,sWaveletData *s,sWaveletData *d);
extern int reconstruct_2v(sWaveletData *d_space,int j,int order);
extern int check_with_partial_decomposition_2v(int j,sWaveletData *s,sWaveletData T);
extern int check_with_partial_decomposition_4v(int j,sWaveletData *s,sWaveletData T);
extern int decompose_4v(int j,sWaveletData *s,sWaveletData *d);
extern int reconstruct_4v(sWaveletData *d_space,int j,int order);
extern void print_ns(int v,sWaveletData *d_space,int j,int flg);
extern void print_d(int v,sWaveletData *d,int j);
extern void print_s(int v,sWaveletData *s,int j,char *st);

#endif
