#include "EventHandler.h"

int sEvent::operator < (const __event evt) const
{
  if (_eventsource < evt._eventsource) return 1;
  if (_eventsource > evt._eventsource) return 0;
  if (_eventtype < evt._eventtype) return 1;
  if (_eventtype > evt._eventtype) return 0;
  if (_eventstate < evt._eventstate) return 1;
  if (_eventstate > evt._eventstate) return 0;
  if (_key < evt._key) return 1;
  if (_key > evt._key) return 0;
  if (_button < evt._button) return 1;
  if (_button > evt._button) return 0;
  return 0;
} /* int sEvent::operator < (const __event& evt) const */

int sEvent::operator == (const __event evt) const
{
  return ( (_eventsource == evt._eventsource) && (_eventtype == evt._eventtype) && (_eventstate == evt._eventstate) && (_key == evt._key) && (_button == evt._button) );
} /* int sEvent::operator == (const __event& evt) const */

sEvent mousemove    = { EVENT_FROMMOUSE , EVENT_MOUSEMOVE , EVENT_NOSTATE , EVENT_NOKEY , EVENT_NOBUTTON      };
sEvent dragleft          = { EVENT_FROMMOUSE , EVENT_MOUSEDRAG , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSELEFT     };
sEvent dragmiddle     = { EVENT_FROMMOUSE , EVENT_MOUSEDRAG , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSEMIDDLE };
sEvent dragright        = { EVENT_FROMMOUSE , EVENT_MOUSEDRAG , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSERIGHT    };
sEvent pushleft         = { EVENT_FROMMOUSE , EVENT_MOUSEDOWN , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSELEFT     };
sEvent pushmiddle    = { EVENT_FROMMOUSE , EVENT_MOUSEDOWN , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSEMIDDLE };
sEvent pushright       = { EVENT_FROMMOUSE , EVENT_MOUSEDOWN , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSERIGHT    };
sEvent releaseleft      = { EVENT_FROMMOUSE , EVENT_MOUSEUP      , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSELEFT      };
sEvent releasemiddle = { EVENT_FROMMOUSE , EVENT_MOUSEUP      , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSEMIDDLE  };
sEvent releaseright    = { EVENT_FROMMOUSE , EVENT_MOUSEUP      , EVENT_NOSTATE , EVENT_NOKEY , EVENT_MOUSERIGHT     };

EventHandler::EventHandler()
{
} /* EventHandler::EventHandler() */

EventHandler::~EventHandler()
{
} /* EventHandler::~EventHandler() */

void EventHandler::addHandler(sEvent evt,handlerfunction* f,void* widget,void* data)
{
  if (_handlerfunctions.find(evt) == _handlerfunctions.end()) {
    sEventHandling evthandle;
    evthandle._f = f;
    evthandle._widget = widget;
    evthandle._data = data;
    _handlerfunctions[evt] = evthandle;
  } /* if (_handlerfunctions.find(evt) != _handlerfunctions.end()) */
} /* void EventHandler::addHandler(sEvent& evt,handlerfunction* f) */

void EventHandler::removeHandler(sEvent evt)
{
  if (_handlerfunctions.find(evt) != _handlerfunctions.end()) {
    _handlerfunctions.erase(evt);
  } /* if (_handlerfunctions.find(evt) != _handlerfunctions.end()) */
} /* void EventHandler::removeHandler(sEvent& evt) */

int EventHandler::handle(sEvent evt)
{
  ENTERINGFUNCTION; TRACEVARIABLE(this); TRACEVARIABLE(evt._eventsource); TRACEVARIABLE(evt._eventtype);
  int res = 0;

  //cout << "EventHandler::handle : evt = " << evt._eventsource << " " << evt._eventtype << " " << evt._eventstate << " " << evt._key << " " << evt._button << endl;
//   map < sEvent , sEventHandling >::const_iterator it;
//   for(it = _handlerfunctions.begin();it != _handlerfunctions.end();it++)
    //cout << "handlerfunctions : evt = " << it->first._eventsource << " " << it->first._eventtype << " " << it->first._eventstate << " " << it->first._key << " " << it->first._button << endl;
    //cout << endl;

  if (_handlerfunctions.find(evt) != _handlerfunctions.end()) {

    //cout << "evt trouve" << endl;

    (*(_handlerfunctions[evt]._f))(_handlerfunctions[evt]._widget,_handlerfunctions[evt]._data);
    res = 1;
  } /* if (_handlerfunctions.find(evt) != _handlerfunctions.end()) */

  //else
  //cout << "evt non trouve" << endl;

  EXITINGFUNCTION; TRACEVARIABLE(res);
  return res;
} /* int EventHandler::handle(sEvent& evt) */

