#include "FlGlImageViewer.h"
#include "FlMainWindow.h"
#include "includes.h"
#include "fonct.h"




void FlGlImageViewer::initmove(void* data)
{
  ENTERINGFUNCTION;
  FlMainWindow::MainWindow()->currentMode = CW_MODE_IMAGE | CW_IMAGE_MOVE;
  initPoint2d(initialPosition,Fl::event_x(),Fl::event_y());

  FlMainWindow::MainWindow()->mode("move");

  EXITINGFUNCTION;
} /* void FlGlImageViewer::initmove(void* data) */

void FlGlImageViewer::move(void* data)
{
  ENTERINGFUNCTION; TRACEVARIABLE(initialPosition);
  if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_MOVE) {
    initPoint2d(currentPosition,Fl::event_x(),Fl::event_y()); TRACEVARIABLE(currentPosition);
    sVector2d dpct; sousVectorPoint2d(dpct,initialPosition,currentPosition);
//     if (normVector2d(dpct) > 10.) {
      sPoint3d pc = FlMainWindow::MainWindow()->viewingCamera.Position();
      sVector3d rc = FlMainWindow::MainWindow()->viewingCamera.Right();
      sVector3d uc = FlMainWindow::MainWindow()->viewingCamera.Up();
      mulVectorScalar3d(rc,FlMainWindow::MainWindow()->viewingCamera.OuvertureU() * x(dpct) * FlMainWindow::MainWindow()->viewingCamera.PixelSize() * 1.);
      mulVectorScalar3d(uc,FlMainWindow::MainWindow()->viewingCamera.OuvertureV() * y(dpct) * FlMainWindow::MainWindow()->viewingCamera.PixelSize() * 1. / 
			(/*3. */ FlMainWindow::MainWindow()->viewingCamera.AspectRatio()));
      sousVectorPoint3d(pc,pc,rc);
      sousVectorPoint3d(pc,pc,uc);
      FlMainWindow::MainWindow()->viewingCamera.Position(pc);
      copyPoint2d(currentPosition,initialPosition);
      redraw();
//     } /* if (normVector2d(dpct) > 10.) */
  } /* if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_MOVE) */
  EXITINGFUNCTION;
} /* void FlGlImageViewer::move(void* data) */

void FlGlImageViewer::initzoom(void* data)
{
  ENTERINGFUNCTION;
  FlMainWindow::MainWindow()->currentMode = CW_MODE_IMAGE | CW_IMAGE_MOVE;
  initPoint2d(initialPosition,Fl::event_x(),Fl::event_y());

  FlMainWindow::MainWindow()->mode("zoom in");

  EXITINGFUNCTION;
} /* void FlGlImageViewer::initzoom(void* data) */

void FlGlImageViewer::zoom(void* data)
{
  ENTERINGFUNCTION; TRACEVARIABLE(initialPosition);
  if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_MOVE) {
    initPoint2d(currentPosition,Fl::event_x(),Fl::event_y()); TRACEVARIABLE(currentPosition);
    sVector2d dpct; sousVectorPoint2d(dpct,initialPosition,currentPosition);
//     double ddist = normVector2d(dpct) * 5.;
// //     double dmax = sqrt(sqr(w())+sqr(h()));
//     double dmax = h();
    //if (ddist > 10.) {
      double ou = FlMainWindow::MainWindow()->viewingCamera.OuvertureU();
      double ov = FlMainWindow::MainWindow()->viewingCamera.OuvertureV();
      double difdist = 2. * (y(dpct)) / h();
      if(difdist > 1)
	difdist = .9;
      ou = ou * (1. - difdist);
      ov = ov * (1. - difdist);
      FlMainWindow::MainWindow()->viewingCamera.OuvertureU(ou);
      FlMainWindow::MainWindow()->viewingCamera.OuvertureV(ov);
      copyPoint2d(currentPosition,initialPosition);
      redraw();
      //} /* if (normVector2d(dpct) > 10.) */
  } /* if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_ZOOM) */
  EXITINGFUNCTION;
} /* void FlGlImageViewer::zoom(void* data) */

// void FlGlImageViewer::initzoomout(void* data)
// {
//   ENTERINGFUNCTION;
//   FlMainWindow::MainWindow()->currentMode = CW_MODE_IMAGE | CW_IMAGE_ZOOMOUT;
//   initPoint2d(initialPosition,Fl::event_x(),Fl::event_y());

//   FlMainWindow::MainWindow()->mode("zoom out");

//   EXITINGFUNCTION;
// } /* void FlGlImageViewer::initzoomout(void* data) */

// void FlGlImageViewer::zoomout(void* data)
// {
//   ENTERINGFUNCTION; TRACEVARIABLE(initialPosition);
//   if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_ZOOMOUT) {
//     initPoint2d(currentPosition,Fl::event_x(),Fl::event_y()); TRACEVARIABLE(currentPosition);
//     sVector2d dpct; sousVectorPoint2d(dpct,initialPosition,currentPosition);
//     double ddist = normVector2d(dpct);
//     double dmax = sqrt(sqr(w())+sqr(h()));
//     if (ddist > 10.) {
//       double ou = FlMainWindow::MainWindow()->viewingCamera.OuvertureU();
//       double ov = FlMainWindow::MainWindow()->viewingCamera.OuvertureV();
//       double difdist = ddist / dmax;
//       ou = ou * (1. + difdist);
//       ov = ov * (1. + difdist);
//       FlMainWindow::MainWindow()->viewingCamera.OuvertureU(ou);
//       FlMainWindow::MainWindow()->viewingCamera.OuvertureV(ov);
//       copyPoint2d(currentPosition,initialPosition);
//       redraw();
//     } /* if (normVector2d(dpct) > 10.) */
//   } /* if (FlMainWindow::MainWindow()->currentMode & CW_IMAGE_ZOOMOUT) */
//   EXITINGFUNCTION;
// } /* void FlGlImageViewer::zoomout(void* data) */

// void FlGlImageViewer::endmanipulate(void* data)
// {
//   ENTERINGFUNCTION;
//   FlMainWindow::MainWindow()->currentMode = CW_MODE_IMAGE;
//   initPoint2d(initialPosition,0.,0.);
//   initPoint2d(currentPosition,0.,0.);

//   FlMainWindow::MainWindow()->mode(NULL);

//   EXITINGFUNCTION;
// } /* void FlGlImageViewer::endmanipulate(void* data) */




void FlGlImageViewer::s_initmove(void* widget,void* data)
{
  ((FlGlImageViewer*)widget)->initmove(data);
} /* void FlGlImageViewer::s_initmove(void* widget,void* data) */

void FlGlImageViewer::s_move(void* widget,void* data)
{
  ((FlGlImageViewer*)widget)->move(data);
} /* void FlGlImageViewer::s_move(void* widget,void* data) */

void FlGlImageViewer::s_initzoom(void* widget,void* data)
{
  ((FlGlImageViewer*)widget)->initzoom(data);
} /* void FlGlImageViewer::s_initzoom(void* widget,void* data) */

void FlGlImageViewer::s_zoom(void* widget,void* data)
{
  ((FlGlImageViewer*)widget)->zoom(data);
} /* void FlGlImageViewer::s_zoom(void* widget,void* data) */

// void FlGlImageViewer::s_initzoomout(void* widget,void* data)
// {
//   ((FlGlImageViewer*)widget)->initzoomout(data);
// } /* void FlGlImageViewer::s_initzoomout(void* widget,void* data) */

// void FlGlImageViewer::s_zoomout(void* widget,void* data)
// {
//   ((FlGlImageViewer*)widget)->zoomout(data);
// } /* void FlGlImageViewer::s_zoomout(void* widget,void* data) */

// void FlGlImageViewer::s_endmanipulate(void* widget,void* data)
// {
//   ((FlGlImageViewer*)widget)->endmanipulate(data);
// } /* void FlGlImageViewer::s_endmanipulate(void* widget,void* data) */


void FlGlImageViewer::s_selectpoint(void* widget,void* data){
  ////cout << "s_selectpoint" << endl;
  //((FlGlImageViewer*)widget)->selectpoint(data);
  sPoint2d p;
  sVector3d vu = FlMainWindow::MainWindow()->viewingCamera.Up();
  sVector3d vr = FlMainWindow::MainWindow()->viewingCamera.Right();
  sPoint3d c = FlMainWindow::MainWindow()->viewingCamera.Position();
  double ou = FlMainWindow::MainWindow()->viewingCamera.OuvertureU();
  double ov = FlMainWindow::MainWindow()->viewingCamera.OuvertureV();

  initPoint2d(p,Fl::event_x(),Fl::event_y());
  FLtoGL(p,((FlGlImageViewer*)widget)->currentPosition,((FlGlImageViewer*)widget)->w(),((FlGlImageViewer*)widget)->h(),ou,ov,c,vu,vr);

  FlMainWindow::MainWindow()->selectpoint(data);
}
 
void FlGlImageViewer::s_validpolygon(void* widget,void* data){
  ////cout << "s_validpolygon" << endl;
  FlMainWindow::MainWindow()->validpolygon(data);
}
 
void FlGlImageViewer::s_equalize(void* widget,void* data){
  FlMainWindow::MainWindow()->s_valid_set_polygons(data);
}

void FlGlImageViewer::s_undo(void* widget,void* data){
  //cout << "FlGlImageViewer::undo" <<  endl;

  FlMainWindow::MainWindow()->undo(data);
}

FlGlImageViewer::FlGlImageViewer(const int xx,const int yy,const int ww,const int hh,const char* title = NULL)
  :
  Fl_Gl_Window(xx,yy,ww,hh,title) ,
  loaded(OFF)
{
    //cout << __FUNCTION__ << " : debut" << endl;

    FlMainWindow::MainWindow()->currentMode = CW_MODE_IMAGE;
    FlMainWindow::MainWindow()->imageList = 0;
    
    //cout << __FUNCTION__ << " : 1" << endl;

  imageHandler = new EventHandler();
    //cout << __FUNCTION__ << " : 2" << endl;
  imageHandler->addHandler(evt_initmove	,(handlerfunction*)FlGlImageViewer::s_initmove	,(void*)this,(void*)NULL);
  imageHandler->addHandler(evt_move	,(handlerfunction*)FlGlImageViewer::s_move	,(void*)this,(void*)NULL);
  imageHandler->addHandler(evt_initzoom	,(handlerfunction*)FlGlImageViewer::s_initzoom	,(void*)this,(void*)NULL);
  imageHandler->addHandler(evt_zoom	,(handlerfunction*)FlGlImageViewer::s_zoom	,(void*)this,(void*)NULL);
//   imageHandler->addHandler(evt_initzoomout,(handlerfunction*)FlGlImageViewer::s_initzoomout,(void*)this,(void*)NULL);
//   imageHandler->addHandler(evt_zoomout,(handlerfunction*)FlGlImageViewer::s_zoomout,(void*)this,(void*)NULL);
//   imageHandler->addHandler(evt_endmove,(handlerfunction*)FlGlImageViewer::s_endmanipulate,(void*)this,(void*)NULL);
//   imageHandler->addHandler(evt_endzoom,(handlerfunction*)FlGlImageViewer::s_endmanipulate,(void*)this,(void*)NULL);
//   imageHandler->addHandler(evt_endzoomout,(handlerfunction*)FlGlImageViewer::s_endmanipulate,(void*)this,(void*)NULL);

    //cout << __FUNCTION__ << " : 3" << endl;

  equalizationHandler = new EventHandler();
  equalizationHandler->addHandler(evt_selectpoint	,(handlerfunction*)FlGlImageViewer::s_selectpoint	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_validpolygon	,(handlerfunction*)FlGlImageViewer::s_validpolygon	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_valid_set_polygons,(handlerfunction*)FlGlImageViewer::s_equalize	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_undo		,(handlerfunction*)FlGlImageViewer::s_undo	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_initial		,(handlerfunction*)FlMainWindow::s_initial	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_normalize		,(handlerfunction*)FlMainWindow::s_normalize	,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_gray		,(handlerfunction*)FlMainWindow::s_gray		,(void*)this,(void*)NULL);
  equalizationHandler->addHandler(evt_modified		,(handlerfunction*)FlMainWindow::s_modified	,(void*)this,(void*)NULL);


  //originHandler = new EventHandler();

    //cout << __FUNCTION__ << " : 4" << endl;


  point3d(oc,0.5,0.5,10.); FlMainWindow::MainWindow()->viewingCamera.Position(oc);
  vector3d(dc,0.,0.,-1.); FlMainWindow::MainWindow()->viewingCamera.Direction(dc);
  vector3d(rc,1.,0.,0.); FlMainWindow::MainWindow()->viewingCamera.Right(rc);
  vector3d(uc,0.,1.,0.); FlMainWindow::MainWindow()->viewingCamera.Up(uc);
  FlMainWindow::MainWindow()->viewingCamera.OuvertureU(1.);
  FlMainWindow::MainWindow()->viewingCamera.OuvertureV(1. * ((double)h()) / ((double)w()));
  FlMainWindow::MainWindow()->viewingCamera.PixelSize(1./w());
  FlMainWindow::MainWindow()->viewingCamera.AspectRatio(((double)w())/((double)h()));

    //cout << __FUNCTION__ << " : 5" << endl;
  resizable(this);
    //cout << __FUNCTION__ << " : fin" << endl;


} /* FlGlImageViewer::FlGlImageViewer(int xx,int yy,int ww,int hh,const char* title = NULL) */

FlGlImageViewer::~FlGlImageViewer()
{

  //delete originHandler;

  delete equalizationHandler;
  delete imageHandler;
  //delete commonHandler;
} /* FlGlImageViewer::~FlGlImageViewer() */

int FlGlImageViewer::handle(int event)
{
  int res = 0;
  sEvent evt;
  initializeEvent(evt,event);

  /*if (FlMainWindow::MainWindow()->currentMode & CW_MODE_IMAGE) {
    res = imageHandler->handle(evt);
  } else if (FlMainWindow::MainWindow()->currentMode & CW_MODE_EQUALIZING) {
    res = equalizationHandler->handle(evt);
    }*/

  res = ((equalizationHandler->handle(evt)) || (imageHandler->handle(evt)));
 
  if (!res) res = Fl_Gl_Window::handle(event);
  return res;
} /* FlGlImageViewer::handle(int event) */

void FlGlImageViewer::draw()
{
  /* initialize gl device */
  glViewport(0,0,w(),h());
  glClearColor(0.,0.,0.,1.);
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);
  /* get camera parameters */
  sPoint3d c = FlMainWindow::MainWindow()->viewingCamera.Position();
  sVector3d vd = FlMainWindow::MainWindow()->viewingCamera.Direction();
  sVector3d vu = FlMainWindow::MainWindow()->viewingCamera.Up();

  sVector3d vr = FlMainWindow::MainWindow()->viewingCamera.Right();

  double ou = FlMainWindow::MainWindow()->viewingCamera.OuvertureU();
  double ov = FlMainWindow::MainWindow()->viewingCamera.OuvertureV();
  /* initialize point of view */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-ou/2.,ou/2.,-ov/2.,ov/2.,-1000.,1000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(x(c),y(c),z(c),x(c)+x(vd),y(c)+y(vd),z(c)+z(vd),x(vu),y(vu),z(vu));
  /* draw image */
  glColor3f(1.,1.,1.);
  //  if (glIsList(FlMainWindow::MainWindow()->imageList))
    glCallList(FlMainWindow::MainWindow()->imageList);
  /* draw current feature */

  //cout << "draw : debut" << endl;

  //vector<sPoint2d>::const_iterator it_p;
  vector<Polygon>::iterator it;

  sPoint2d ancien;
  sPoint2d premier;

  for(it = FlMainWindow::MainWindow()->traitement.polygons_ombr.begin();it != FlMainWindow::MainWindow()->traitement.polygons_ombr.end();it++){
    it->draw();
  }
  FlMainWindow::MainWindow()->traitement.currentPolygon_ombr.draw();

  for(it = FlMainWindow::MainWindow()->traitement.polygons_eclair.begin();it != FlMainWindow::MainWindow()->traitement.polygons_eclair.end();it++){
    it->draw();
  }
  FlMainWindow::MainWindow()->traitement.currentPolygon_eclair.draw();

//FlMainWindow::MainWindow()->ax,FlMainWindow::MainWindow()->bx,FlMainWindow::MainWindow()->ay,FlMainWindow::MainWindow()->by);

  /*glColor3f(1.,0.,0.);
  for(it_p = FlMainWindow::MainWindow()->currentPolygon.begin();it_p != FlMainWindow::MainWindow()->currentPolygon.end();it_p++){
    glColor3f(1.,0.,0.);
    //cout << "1 point" << endl;
    //getchar();
    glColor3f(1.,0.,0.); glDrawVertex2d(*it_p);
    }*/
  
  //cout << "draw : fin" << endl;

} /* FlGlImageViewer::draw() */

void FlGlImageViewer::resize(int x, int y, int ww, int hh)
{
  ENTERINGFUNCTION; TRACEVARIABLE(x); TRACEVARIABLE(y); TRACEVARIABLE(ww); TRACEVARIABLE(hh);
  static int done  = 0;
  if (!done) {
    double ou = FlMainWindow::MainWindow()->viewingCamera.OuvertureU();
    double ov = FlMainWindow::MainWindow()->viewingCamera.OuvertureV();
    double arwindow = ((double)ww)/((double)hh);
    if (arwindow > 1.) {
      ou = ov * arwindow;
    } else {
      ov = ou / arwindow;
    } /* if (ar > 1.) */
    FlMainWindow::MainWindow()->viewingCamera.OuvertureU(ou);
    FlMainWindow::MainWindow()->viewingCamera.OuvertureV(ov);
  } /* if (!done) */
  done = 1 - done;
  Fl_Gl_Window::resize(x,y,ww,hh);
  EXITINGFUNCTION;
} /* FlGlImageViewer::resize(int x, int y, int w, int h) */
