#include "FlMainWindow.h"
#include "polygon.h"
#include "Spectral.h"


FlMainWindow* FlMainWindow::mainapp = NULL;

unsigned int FlMainWindow::currentMode;
Traitement FlMainWindow::traitement;

//   ImageRGB *FlMainWindow::image1,*FlMainWindow::image2,*FlMainWindow::image3,*FlMainWindow::image4;

// ImageRGB FlMainWindow::initialImage,FlMainWindow::transformedImage,FlMainWindow::transformedImage2,FlMainWindow::transformedImage3,
//   FlMainWindow::normalizedImage/*,FlMainWindow::grayImage*/;

// ImageRGB *FlMainWindow::viewedImage,*FlMainWindow::modifiedImage,FlMainWindow::pushedImage;
// bool FlMainWindow::color_viewed,FlMainWindow::color_pushed,FlMainWindow::color_modified;

// unsigned int FlMainWindow::select_eclair;
// Polygon FlMainWindow::currentPolygon_ombr(0.,1.,0.);
// Polygon FlMainWindow::currentPolygon_eclair(0.,1.,0.);
// vector<Polygon> FlMainWindow::polygons_ombr;
// vector<Polygon> FlMainWindow::polygons_eclair;


// ImageRGBf *FlMainWindow::rgbf;
// ImageGRAYf *FlMainWindow::grayf;

// unsigned int FlMainWindow::viewedImage;



FlMainWindow::FlMainWindow(int ww,int hh,const char* title = NULL) :
  Fl_Window(ww,hh,title) // , currentPolygon_ombr(0.,1.,0.) , currentPolygon_eclair(0.,1.,0.)
{

//   ax = ay = 1;
//   bx = by = 0;

   mainapp = this;
//    traitement.select_eclair = false;
 
   /*MainWindow()->traitement.f_ombr += .6;
  MainWindow()->traitement.f_ombr += .7;
  MainWindow()->traitement.f_eclair += .8;
  MainWindow()->traitement.f_eclair += .9;*/
  

  /*currentMode = CW_MODE_IMAGE;
    imageList = 0;*/

  box(FL_UP_BOX);
  labelsize(12);
  user_data((void*)(this));


   group = new Fl_Group(0,0,ww,hh-20);
   {
    
    int h = hh - 20;
    int c = h / 3;
    int d = ww - c;

    imageViewer = new FlGlImageViewer(	0	,0      ,d    	,h);
    g_ombr	= new graph(		d	,0	,c	,c	,'h'	,0.,0.,0.	,&MainWindow()->traitement.f_ombr_y);
    g_eclair	= new graph(		d	,c	,c	,c	,'h'	,0.,0.,0.	,&MainWindow()->traitement.f_eclair_y);
    g_transf	= new graph(		d	,2 * c	,c	,c	,'f'	,0.,0.,0.	,&MainWindow()->traitement.f_transf_y);

//     g_ombr	= new graph(		d	,0	,c	,c	,'h'	,1,0,0	,&MainWindow()->traitement.f_ombr_r);
//     g_eclair	= new graph(		d	,c	,c	,c	,'h'	,1,0,0	,&MainWindow()->traitement.f_eclair_r);
//     g_transf	= new graph(		d	,2 * c	,c	,c	,'f'	,1,0,0	,&MainWindow()->traitement.f_transf_r);

//     resizable(g_ombr);
//     resizable(g_eclair);
//     resizable(g_transf);

   }
   group->end();

//   g_ombr->push(		&MainWindow()->traitement.f_ombr_g	,0,.8,0);
//   g_eclair->push(	&MainWindow()->traitement.f_eclair_g	,0,.8,0);
//   g_transf->push(	&MainWindow()->traitement.f_transf_g	,0,.8,0);

//   g_ombr->push(		&MainWindow()->traitement.f_ombr_b	,0,0,1);
//   g_eclair->push(	&MainWindow()->traitement.f_eclair_b	,0,0,1);
//   g_transf->push(	&MainWindow()->traitement.f_transf_b	,0,0,1);


  int dw = ww-8;
  {
    Fl_Output* o = informationStatus = new Fl_Output(1,hh-18,30*dw/100,16);
    o->textsize(12);
    o->value("image manipulation");
  }
  {
    Fl_Output* o = modeStatus = new Fl_Output(30*dw/100 + 3,hh-18,20*ww/100,16);
    o->textsize(12);
  }
  {
    Fl_Output* o = coordinateStatus = new Fl_Output(50*dw/100 + 5,hh-18,30*ww/100,16);
    o->textsize(12);
  }
  {
    Fl_Output* o = resultStatus = new Fl_Output(80*dw/100 + 7,hh-18,20*ww/100,16);
    o->textsize(12);
  }
  

  end();

   resizable(group);
  /*fu.nbp = 0; fu.first = NULL; initPoint2d(fu.vp,0.,0.);
  fv.nbp = 0; fv.first = NULL; initPoint2d(fv.vp,0.,0.);
  fw.nbp = 0; fw.first = NULL; initPoint2d(fw.vp,0.,0.);*/

  commonHandler = new EventHandler();

//   commonHandler->addHandler(evt_switchdebug,	(handlerfunction*)FlMainWindow::s_switchdebug,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_load,		(handlerfunction*)FlMainWindow::s_load,			(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_save,		(handlerfunction*)FlMainWindow::s_save,			(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_diviz,		(handlerfunction*)FlMainWindow::s_diviz,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_undiviz,       	(handlerfunction*)FlMainWindow::s_undiviz,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_mult,		(handlerfunction*)FlMainWindow::s_mult,			(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_double_lum,	(handlerfunction*)FlMainWindow::s_double_lum,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_load_grey,	(handlerfunction*)FlMainWindow::s_load_modified,       	(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_aniso_diff,	(handlerfunction*)FlMainWindow::s_aniso_diff,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_gauss_filter,	(handlerfunction*)FlMainWindow::s_gauss_filter,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_selective_filter,(handlerfunction*)FlMainWindow::s_selective_filter,	(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_gradient,	(handlerfunction*)FlMainWindow::s_gradient,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_push_image,	(handlerfunction*)FlMainWindow::s_push_image,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_pushed_image,	(handlerfunction*)FlMainWindow::s_pushed_image,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_load_polygons,	(handlerfunction*)FlMainWindow::s_load_polygons,       	(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_save_polygons,	(handlerfunction*)FlMainWindow::s_save_polygons,       	(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_clear_polygons,	(handlerfunction*)FlMainWindow::s_clear_polygons,       (void*)this,(void*)NULL);
  commonHandler->addHandler(evt_fill_hole,	(handlerfunction*)FlMainWindow::s_fill_hole,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_equalize,	(handlerfunction*)FlMainWindow::s_equalize,		(void*)this,(void*)NULL);
  commonHandler->addHandler(evt_histogram,	(handlerfunction*)FlMainWindow::s_histogram,		(void*)this,(void*)NULL);
//   commonHandler->addHandler(evt_import,(handlerfunction*)FlMainWindow::s_importData,(void*)this,(void*)NULL);
//   commonHandler->addHandler(evt_export,(handlerfunction*)FlMainWindow::s_exportData,(void*)this,(void*)NULL);
//   commonHandler->addHandler(evt_calibrate,(handlerfunction*)FlMainWindow::s_calibrate,(void*)this,(void*)NULL);

  //cout << __FUNCTION__ << " : fin" << endl;

} /* FlMainWindow::FlMainWindow(int ww,int hh,const char* title = NULL) */

FlMainWindow::~FlMainWindow()
{
  delete group;
  delete resultStatus;
  delete coordinateStatus;
  delete modeStatus;
  delete informationStatus;
  delete imageViewer;
  delete g_ombr;
  delete g_eclair;
  delete g_transf;

} /* FlMainWindow::~FlMainWindow() */

int FlMainWindow::handle(int event)
{
  static bool pile_ou_face = true;	
  
  int res = 0;
  sEvent evt;
  initializeEvent(evt,event);
  
  if(pile_ou_face){				   // si les evenements sont envoyes en double, on annule un evenement sur deux
    res = commonHandler->handle(evt);
    pile_ou_face = false;
  }
  else{
    pile_ou_face = true;
  }
  
  if (!res) res = Fl_Window::handle(event);
  
  return res;

} /* FlGlImageViewer::handle(int event) */

// void FlMainWindow::resize(int x, int y, int ww, int hh){

//   int h = hh - 20;
//   int c = h / 3;
//   int d = ww - c;
  
//   imageViewer->resize(	0	,0      ,d    	,h);
//   g_ombr->resize(	d	,0	,c	,c);
//   g_eclair->resize(	d	,c	,c	,c);
//   g_transf->resize(	d	,2 * c	,c	,c);
  
// }

// void FlMainWindow::draw(){
//   FlMainWindow::MainWindow()->imageViewer->redraw();
//   FlMainWindow::MainWindow()->g_ombr->redraw();
//   FlMainWindow::MainWindow()->g_eclair->redraw();
//   FlMainWindow::MainWindow()->g_transf->redraw();
// }


sPoint2d FlMainWindow::im2gl(sPoint2d p){
  //return sPoint2d(ax * x(p) + bx,ay * y(p) + by);
  return sPoint2d( x(p) , MainWindow()->traitement.initial_image().Height() - y(p));
}

double FlMainWindow::im2glD(double d){
  return MainWindow()->traitement.initial_image().Height() - d;
}

/*
sPoint2d FlMainWindow::gl2im(sPoint2d p){
  //return sPoint2d((x(p) - bx) / ax,(y(p) - by) / ay);
  return sPoint2d(x(p) , MainWindow()->viewedImage->Height() - y(p));
  }*/



void FlMainWindow::information(const char* c)
{
  char str[2]; str[0] = ' '; str[1] = '\0';
  informationStatus->value(c == NULL ? str : c);
  redraw();
  //Fl::flush();
} /* FlMainWindow::information(const string& c) */

void FlMainWindow::mode(const char* c)
{
  char str[2]; str[0] = ' '; str[1] = '\0';
  modeStatus->value(c == NULL ? str : c);
  redraw();
  //Fl::flush();
} /* FlMainWindow::mode(const string& c) */

void FlMainWindow::coordinate(const char* c)
{
  char str[2]; str[0] = ' '; str[1] = '\0';
  coordinateStatus->value(c == NULL ? str : c);
  redraw(); 
  // Fl::flush();
} /* FlMainWindow::coordinate(const string& c) */

void FlMainWindow::result(const char* c)
{
  char str[2]; str[0] = ' '; str[1] = '\0';
  resultStatus->value(c == NULL ? str : c);
  redraw();
  // Fl::flush();
} /* FlMainWindow::result(const string& c) */








void FlMainWindow::selectpoint(void *data){
  //cout << "FlGlimageViewer::selectpoint : debut" << endl;

  //cout << "FlGlimageViewer::selectpoint : x = " << x(FlMainWindow::MainWindow()->imageViewer->currentPosition) << " , y = " << y(FlMainWindow::MainWindow()->imageViewer->currentPosition) << endl;
  if (glIsList(MainWindow()->imageList)){
    if(traitement.select_eclair){
      traitement.currentPolygon_eclair += im2gl((FlMainWindow::MainWindow()->imageViewer->currentPosition));
    }
    else{
      traitement.currentPolygon_ombr += im2gl((FlMainWindow::MainWindow()->imageViewer->currentPosition));
    }
    FlMainWindow::MainWindow()->imageViewer->redraw();
  }
}
//cout << "FlGlimageViewer::selectpoint : fin" << endl;
//getchar;

void FlMainWindow::fresh_f(){
  vector<Polygon>::const_iterator it,it2;
  int x,y;
  bool appartient;

//   MainWindow()->traitement.f_ombr_r.clear();
//   MainWindow()->traitement.f_ombr_g.clear();
//   MainWindow()->traitement.f_ombr_b.clear();
//   MainWindow()->traitement.f_eclair_r.clear();
//   MainWindow()->traitement.f_eclair_g.clear();
//   MainWindow()->traitement.f_eclair_b.clear();
  MainWindow()->traitement.f_ombr_y.clear();
  MainWindow()->traitement.f_eclair_y.clear();
  MainWindow()->traitement.f_eclair_y2.clear();
  
  if(traitement.polygons_ombr.empty() && traitement.polygons_eclair.empty() && traitement.currentPolygon_ombr.empty() && traitement.currentPolygon_eclair.empty()){
    for(y = 0;y < traitement.viewed_image()->Height();y++){
      for(x = 0;x < traitement.viewed_image()->Width();x++){
	MainWindow()->traitement.f_eclair_y += Spectral::get_y((*(MainWindow()->traitement.viewed_image()))[y][x]);
	MainWindow()->traitement.f_eclair_y2 += Spectral::get_y(Spectral::normalize(((*(MainWindow()->traitement.viewed_image()))[y][x])));
      }
    }
    
    FlMainWindow::MainWindow()->g_ombr->redraw();
    FlMainWindow::MainWindow()->g_eclair->redraw();
    FlMainWindow::MainWindow()->g_transf->redraw();
  }
  else{
    for(y = 0;y < traitement.viewed_image()->Height();y++){
      for(x = 0;x < traitement.viewed_image()->Width();x++){
	appartient = false;
	for(it = traitement.polygons_ombr.begin() ; (it != traitement.polygons_ombr.end()) && (!appartient) ; it++)
	  appartient = ((*it)(x,y));
	if(appartient){
	  MainWindow()->traitement.f_ombr_y += Spectral::get_y((*(MainWindow()->traitement.viewed_image()))[y][x]);
	}
	else{
	  for(it2 = traitement.polygons_eclair.begin() ; (it2 != traitement.polygons_eclair.end()) && (!appartient) ; it2++)
	    appartient = ((*it2)(x,y));
	  if(appartient){
	    MainWindow()->traitement.f_eclair_y += Spectral::get_y((*(MainWindow()->traitement.viewed_image()))[y][x]);
	    MainWindow()->traitement.f_eclair_y2 += Spectral::get_y(Spectral::normalize(((*(MainWindow()->traitement.viewed_image()))[y][x])));
	  }
	}
      }
    }
  MainWindow()->traitement.f_transf_y = MainWindow()->traitement.f_ombr_y>>MainWindow()->traitement.f_eclair_y;
  MainWindow()->traitement.f_transf_y2 = MainWindow()->traitement.f_ombr_y>>MainWindow()->traitement.f_eclair_y2;
  
  FlMainWindow::MainWindow()->g_ombr->redraw();
  FlMainWindow::MainWindow()->g_eclair->redraw();
  FlMainWindow::MainWindow()->g_transf->redraw();
  }
  
}

void FlMainWindow::validpolygon(void *data){
  //cout << "FlGlimageViewer::validpolygon : debut" << endl;
  
  ImageRGBPixel p;
  unsigned char r,g,b;
  
  if (glIsList(MainWindow()->imageList)){
    if(traitement.select_eclair){
      if(traitement.currentPolygon_eclair.size() > 2){
	!(traitement.currentPolygon_eclair);
	FlMainWindow::MainWindow()->traitement.polygons_eclair.push_back(traitement.currentPolygon_eclair);
      }
      traitement.currentPolygon_eclair.clear();
    }
    else{
      if(traitement.currentPolygon_ombr.size() > 2){
	!(traitement.currentPolygon_ombr);
	FlMainWindow::MainWindow()->traitement.polygons_ombr.push_back(traitement.currentPolygon_ombr);
      }
      traitement.currentPolygon_ombr.clear();
    }
    //fresh_f();
    FlMainWindow::MainWindow()->imageViewer->redraw();
  }
  
  //cout << "FlGlimageViewer::validpolygon : fin" << endl;

}
 
void FlMainWindow::undo(void *data){
  vector<Polygon>::iterator it;
  if(traitement.select_eclair){
    if(!traitement.currentPolygon_eclair.empty()){
      traitement.currentPolygon_eclair.pop();
      FlMainWindow::MainWindow()->imageViewer->redraw();
    }
    else if(!traitement.polygons_eclair.empty()){
      it = traitement.polygons_eclair.end();
      it--;
      it->unvalid();
      traitement.currentPolygon_eclair = *it;
      traitement.polygons_eclair.pop_back();
      //fresh_f();
      FlMainWindow::MainWindow()->imageViewer->redraw();
    }
    else{
      traitement.select_eclair = false;
//       for(it = traitement.polygons_ombr.begin();it != traitement.polygons_ombr.end();it++){
// 	it->init_color(0.,1.,0.);
//       }
      FlMainWindow::MainWindow()->imageViewer->redraw();
    }
  }
  else{
    if(!traitement.currentPolygon_ombr.empty()){
      traitement.currentPolygon_ombr.pop();
      FlMainWindow::MainWindow()->imageViewer->redraw();
    }
    else if(!traitement.polygons_ombr.empty()){
      vector<Polygon>::iterator it = traitement.polygons_ombr.end();
      it--;
      it->unvalid();
      traitement.currentPolygon_ombr = *it;
      traitement.polygons_ombr.pop_back();
      //fresh_f();
      FlMainWindow::MainWindow()->imageViewer->redraw();
    }
  }
}

 

void FlMainWindow::s_switchdebug(void* widget,void* data)
{
  if (isON(getDebugMode()))
    unsetDebugMode();
  else
    setDebugMode();
} /* void FlMainWindow::s_switchdebug(void* data) */

void FlMainWindow::s_switchmode(void* widget,void* data)
{
  if(traitement.viewed_image() == &(traitement.transformed_image()))
    traitement.view_transformed_image2();
  else if(traitement.viewed_image() == &(traitement.transformed_image2()))
    traitement.view_transformed_image3();
  else if(traitement.viewed_image() == &(traitement.transformed_image3()))
    traitement.view_transformed_image();
  aff_image();
  if(traitement.viewed_image() == &(traitement.transformed_image()))
    FlMainWindow::MainWindow()->information("image 1");
  else if(traitement.viewed_image() == &(traitement.transformed_image2()))
    FlMainWindow::MainWindow()->information("image 2");
  else if(traitement.viewed_image() == &(traitement.transformed_image3()))
    FlMainWindow::MainWindow()->information("image 3");
} /* void FlMainWindow::s_switchmode(void* data) */


void FlMainWindow::s_save(void* widget,void* data){
  ENTERINGFUNCTION;

  FlMainWindow::MainWindow()->mode("save image");
  FlMainWindow::MainWindow()->coordinate("select an image file to save");

  char* fname = fl_file_chooser("Pick an image file to save","*.tga","");
  if (fname != NULL) {
    /* loading image file */

    FlMainWindow::MainWindow()->coordinate("saving rgb image");
    traitement.save(fname);

  EXITINGFUNCTION;
  }
} /* void FlMainWindow::s_save(void* data) */


// void FlMainWindow::s_importData(void* widget,void* data)
// {
//   ENTERINGFUNCTION;

//   FlMainWindow::MainWindow()->mode("import features");

//   char* fname = fl_file_chooser("Pick a feature file","*.feat","");
//   if (fname != NULL) {
//   } /* if (fname != NULL) */

//   FlMainWindow::MainWindow()->mode(NULL);

//   EXITINGFUNCTION;
// } /* void FlMainWindow::s_importData(void* data) */

// void FlMainWindow::s_exportData(void* widget,void* data)
// {
//   ENTERINGFUNCTION;
  
//   FlMainWindow::MainWindow()->mode("export features");

//   char* fname = fl_file_chooser("Pick a feature file","*.feat","");
//   if (fname != NULL) {
//   } /* if (fname != NULL) */

//   FlMainWindow::MainWindow()->mode(NULL);

//   EXITINGFUNCTION;
// } /* void FlMainWindow::s_exportData(void* data) */

// void FlMainWindow::s_calibrate(void* widget,void* data)
// {
//   ENTERINGFUNCTION;

//   FlMainWindow::MainWindow()->mode("calibrate camera");
//   FlMainWindow::MainWindow()->mode(NULL);

//   EXITINGFUNCTION;
// } /* void FlMainWindow::s_calibrate(void* data) */


void FlMainWindow::aff_image(){
  
  FlMainWindow::MainWindow()->coordinate("initialize display list");

  if (glIsList(MainWindow()->imageList))
    glDeleteLists(MainWindow()->imageList,1);
  MainWindow()->imageList = glGenLists(1);
  glNewList(MainWindow()->imageList,GL_COMPILE);
  /* initialize gl texture 2d */
  
  
  FlMainWindow::MainWindow()->coordinate("initialize texture 2d");
  
  glShadeModel(GL_SMOOTH);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);

    gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB, MainWindow()->traitement.viewed_image()->Width(),
		      MainWindow()->traitement.viewed_image()->Height(),GL_RGB, GL_UNSIGNED_BYTE,
		      MainWindow()->traitement.viewed_image()->Data());
  
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glEnable(GL_TEXTURE_2D);
  /* initialize gl textured polygon */
  
  FlMainWindow::MainWindow()->coordinate("initialize textured polygon");
  
  glBegin(GL_POLYGON);

    for (int i=0;i<4;i++) {
      glTexCoord2f(0.,1.); glVertex3f(0.,0.,0.);
      glTexCoord2f(1.,1.); glVertex3f(MainWindow()->traitement.viewed_image()->Width()-1.,0.,0.);
      glTexCoord2f(1.,0.); glVertex3f(MainWindow()->traitement.viewed_image()->Width()-1.,MainWindow()->traitement.viewed_image()->Height()-1.,0.);
      glTexCoord2f(0.,0.); glVertex3f(0.,MainWindow()->traitement.viewed_image()->Height()-1.,0.);
    }

  glEnd();
  glEndList();
  MainWindow()->imageViewer->redraw();


  FlMainWindow::MainWindow()->mode(NULL);
  FlMainWindow::MainWindow()->coordinate(NULL);
  
}

void FlMainWindow::init_camera(){
  FlMainWindow::MainWindow()->coordinate("initialize orthographic camera");
  
  sPoint3d pc;
  initPoint3d(pc,MainWindow()->traitement.initial_image().Width() / 2., MainWindow()->traitement.initial_image().Height() /2., 100.); MainWindow()->viewingCamera.Position(pc);
  
  double arwindow = ((double)(MainWindow()->imageViewer->w()))/((double)(MainWindow()->imageViewer->h()));
  double arwindow2 = ((double)(MainWindow()->traitement.initial_image().Width()))/((double)(MainWindow()->traitement.initial_image().Height()));
  double ou = MainWindow()->traitement.initial_image().Width();
  double ov = MainWindow()->traitement.initial_image().Height();

  //cout << __FUNCTION__ << " : w = " << (double)(MainWindow()->imageViewer->w()) << " , h = " << ((double)(MainWindow()->imageViewer->h())) << endl;
  //cout << __FUNCTION__ << " : width = " << MainWindow()->traitement.viewed_image()->Width() << " , height = " << MainWindow()->traitement.viewed_image()->Height() << endl;
  
  if (arwindow > arwindow2) {
    ou = ov * arwindow;
  } 
  else {
    ov = ou / arwindow;      
  } /* if (ar > 1.) */
  
    //cout << __FUNCTION__ << " : ou = " << ou << " , ov = " << ov << endl;
  
  MainWindow()->viewingCamera.OuvertureU(ou);
  MainWindow()->viewingCamera.OuvertureV(ov);
  /* initialize gl display list */
  
}

// bool FlMainWindow::rgb_viewed(){
// //   switch(traitement.viewed_image()){
// //   case &grayImage : return false;
// //   default : return true;
// //   }
//   return (!(traitement.viewed_image() & 2));
// }

// bool FlMainWindow::float_viewed(){
// //   switch(traitement.viewed_image()){
// //   case &(traitement.initial_image() : return false;
// //   default : return true;
// //   }
//   return (traitement.viewed_image() & 1);
// }



