#include "data/LightSource.h"

sLightSource::sLightSource()
{
  _filename[0] = '\0';
  _name[0] = '\0';
  _data[0] = '\0';

  _spectrum._name[0] = '\0';
  _spectrum._c0 = 0.;
  _spectrum._c1 = 0.;
  _spectrum._c2 = 0.;
  _spectrum._nbvalues = 0;

  L = 0.;
  l = 0.;
  _stepDir = 0.;
  _nbDir = 0;
  _stepPlans = 0.;
  _nbPlans = 0;
  _firstPlan = 0.;
}

sLightSource::sLightSource(const sLightSource& v)
{
  strcpy(_filename,v._filename);
  strcpy(_name,v._name);
  strcpy(_data,v._data);

  strcpy(_spectrum._name,v._spectrum._name);
  _spectrum._c0 = v._spectrum._c0;
  _spectrum._c1 = v._spectrum._c1;
  _spectrum._c2 = v._spectrum._c2;
  _spectrum._nbvalues = v._spectrum._nbvalues;
  for (int i=0;i<_spectrum._nbvalues;i++)
    {
      _spectrum._values[0][i] = v._spectrum._values[0][i];
      _spectrum._values[1][i] = v._spectrum._values[1][i];
    }

  L = v.L;
  l = v.l;
  _stepDir = v._stepDir;
  _nbDir = v._nbDir;
  _stepPlans = v._stepPlans;
  _nbPlans = v._nbPlans;
  _firstPlan = v._firstPlan;
}

sLightSource::~sLightSource()
{
}

ostream& operator << (ostream& out,const sLightSource& light)
{
  out << "sLightSource[" << light._name << "]";
  return out;
}
