#include "graph.h"


#define BORD ((GLfloat).05)
//#define PIXEL_PAR_DEGRE ((GLfloat)3.5)
//#define   steps ((double)200)
//#define   step ((double)(1 / steps))
//#define   mult ((double)5)
//#define   mult2 ((double)1)



graph::graph(int x,int y,int w,int h,char h_f,GLfloat r,GLfloat v,GLfloat b,fonct *f,const char *l) : Fl_Gl_Window(x,y,w,h,l) {
  init(f,r,v,b,h_f);
  _step = (1 + (2 * BORD)) / w ;
  resizable(this);
}

void graph::init(fonct *f,GLfloat r,GLfloat v,GLfloat b,char h_f){
  if(h_f == '0')
    _h_f = 'h';
  else
    _h_f = h_f;
  
  if(r == -1)
    _r = 0;
  else
    _r = r;
  
  if(v == -1)
    _v = 0;
  else
    _v = v;
  
  if(b == -1)
    _b = 0;
  else
    _b = b;
  
  _f = f;
}

void graph::init_color(GLfloat r,GLfloat v,GLfloat b){
  _r = r;
  _v = v;
  _b = b;
}

void graph::push(fonct *f,GLfloat r,GLfloat v,GLfloat b,char h_f){
  //throw 0;
  v_h_f.push_back(_h_f);
  v_r.push_back(_r); 
  v_v.push_back(_v);
  v_b.push_back(_b);
  v_f.push_back(_f);
  
  if(h_f != '0')
    _h_f = h_f;
  
  if(r != -1)
    _r = r;
  
  if(v != -1)
    _v = v;
  
  if(b != -1)
    _b = b;
  
  _f = f;
}

/*void graph::init_f(char h_f,fonct *f){
  _h_f = h_f;
  _f = f;
  }*/

void graph::resize(int x, int y, int ww, int hh){
  //_step = (1 + (2 * BORD)) / ww ;
  Fl_Gl_Window::resize(x,y,ww,hh);
}

void graph::draw(){
    //cout << __FUNCTION__ <<  " : debut" << endl;

//   glClearColor(.93,.93,.93,0);
  glClearColor(1,1,1,0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glEnable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho( -BORD , 1 + BORD , -BORD , 1 + BORD , -1 , 1 );
 
  glMatrixMode(GL_MODELVIEW);
 
  glBegin(GL_LINES);
  glColor3f(0,0,0);
  glVertex3f(0,0,0);
  glVertex3f(1,0,0);
  glVertex3f(0,0,0);
  glVertex3f(0,1,0);
  glEnd();
  

  vector<GLfloat>::const_iterator i_r,i_v,i_b;
  vector<char>::const_iterator i_h_f;
  vector<fonct*>::const_iterator i_f;

  vector<vector<double> > vvd;
  vector<vector<double> >::iterator vvdi;
  vector<double> vd;
  
  double max = 0;
  

  for(i_f = v_f.begin(),i_h_f = v_h_f.begin(),i_r = v_r.begin(),i_v = v_v.begin(),i_b = v_b.begin();i_f != v_f.end();i_f++,i_h_f++,i_r++,i_v++,i_b++){
    if(*i_f){
      ////cout << __FUNCTION__ <<  " : r = " << r << " : v = " << v << " : b = " << b << endl;getchar();
      if(*i_h_f == 'h'){
	vvd.push_back(vd);
	vvdi = vvd.end();
	vvdi--;
	dessiner_deriv_debut((*i_f)->integr(),*(vvdi++),max);
      }
      else{
	glColor3f(*i_r,*i_v,*i_b);
	dessiner(**i_f);
      }
    }
  }

  if(_f){
    if(_h_f == 'h'){
      vvd.push_back(vd);
	vvdi = vvd.end();
	vvdi--;
      dessiner_deriv_debut(_f->integr(),*vvdi,max);
    }
    else{
      glColor3f(_r,_v,_b);
      dessiner(*_f);
    }
  }

  vvdi = vvd.begin();
  for(i_f = v_f.begin(),i_h_f = v_h_f.begin(),i_r = v_r.begin(),i_v = v_v.begin(),i_b = v_b.begin();i_f != v_f.end();i_f++,i_h_f++,i_r++,i_v++,i_b++){
    if((*i_f) && (*i_h_f == 'h')){
      glColor3f(*i_r,*i_v,*i_b);
      dessiner_deriv_fin(*(vvdi++),max);
    }
  }

  if(vvdi != vvd.end()){
    glColor3f(_r,_v,_b);
    dessiner_deriv_fin(*vvdi,max);
  }
}
 
void graph::dessiner_deriv_debut(const fonct &f,vector<double> &vd,double &max){
  
  double d,f1,f2,df,df1,df2,c;
  vd.clear();

//   d = 0;
//   f1 = f.evaluer(0);

//   while(d <= 1){
//     d += _step;
//     f2 = f.evaluer_lower(d);
//     df = f2 - f1;
//     f1 = f2;
    
//     vd.push_back(df);
 
//     if(df > max)
//       max = df;
//   }

//   vd.push_back(df);

  d = 0;
  f1 = f.evaluer(0);
  d += _step;
  f2 = f.evaluer_lower(d);
  df2 = f2 - f1;
  d += _step;
  if(d > 1) return;
  f1 = f.evaluer_lower(d);
  df1 = f1 - f2;
  c = (df2 + df1) / 2;
  vd.push_back(c);
  if(c > max)
    max = c;

  while(d <= 1){
    d += _step;
    f2 = f.evaluer_lower(d);
    df = f2 - f1;
    f1 = f2;
    
    c = (df2 + df1 + df) / 3;
    vd.push_back(c);
    if(c > max)
      max = c;
  }

  c = (df + df1) / 2;
  if(c > max)
    max = c;
  vd.push_back(c);  

}
  
void graph::dessiner_deriv_fin(vector<double> &v,double max){
  
  vector<double>::const_iterator it;
  double d;

  glBegin(GL_LINE_STRIP);
  for(it = v.begin() , d = 0 ; it != v.end() ; it++ , d += _step){
    ////cout << __FUNCTION__ << " : " << d << " , " << ((*it) / max) << endl;
    //glVertex3d(d,0,-.2);
    glVertex3d(d,(*it) / max,-.1);
  }
  glEnd();
}

void graph::dessiner(const fonct &f){
  double d;

  glBegin(GL_LINE_STRIP);

  for(d = 0;d <= 1;d += _step){
    ////cout << __FUNCTION__ << " : " << d  << " , " << f.evaluer(d) << endl;
    //glVertex3d(d,0,0);
    glVertex3d(d,f.evaluer(d),0);
  }
  glVertex3d(d,f.evaluer(d),0);
  glEnd();
}


/*
void graph::dessiner_histo(const fonct &f){
fonct i = (++f / &f);
//dessiner(i);
double d;
//glBegin(GL_POINTS);
glBegin(GL_LINE_STRIP);
for(d = 0;d <= 1;d += _step){
//glVertex3d(it->first,0,0);
//glVertex3f(it->first,it->second / mult,0);
glVertex3d(d,0,-.2);
glVertex3d(d,(i.evaluer(d+_step) - i.evaluer(d)) / (_step * mult),-.1);
}
glEnd();
}
*/
