#include "gui/FlMenu.h"
#include "gui/FlEvents.h"
#include "gui/FlMainWindow.h"
#include "gui/Labels.h"

#include "recherche/Recherche.h"

#define LabelStartIndex 107
#define maxSolutionPerMenu 30

void initializeMenu(Fl_Menu_Bar* menubar)
{
  char str[255];
  menubar->menu(NULL);
  sprintf(str,"%s",labels[LabelStartIndex+0]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+0],labels[LabelStartIndex+1]);
  menubar->add(str,0, (Fl_Callback*)(NULL), 0, FL_MENU_DIVIDER);
  sprintf(str,"%s/%s",labels[LabelStartIndex+0],labels[LabelStartIndex+35]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_export), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+0],labels[LabelStartIndex+36]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_import), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+0],labels[LabelStartIndex+37]);
  menubar->add(str,0, (Fl_Callback*)(FlMainWindow::cb_export3d), 0, FL_MENU_DIVIDER);
  sprintf(str,"%s/%s",labels[LabelStartIndex+0],labels[LabelStartIndex+2]);
  menubar->add(str, FL_CTRL + 'q', (Fl_Callback*)(FlMainWindow::cb_quit), 0);

  sprintf(str,"%s",labels[LabelStartIndex+3]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+4]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_simulationparameters), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+5]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_launchsimulation), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6],labels[LabelStartIndex+7]);
  menubar->add(str,NULL,(Fl_Callback*)(FlMainWindow::cb_visualize), (void*)(TUNNELMODEL_NFF));
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6],labels[LabelStartIndex+8]);
  menubar->add(str,NULL,(Fl_Callback*)(FlMainWindow::cb_visualize), (void*)(TUNNELMODEL_INITIAL));
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6],labels[LabelStartIndex+9]);
  menubar->add(str,NULL,(Fl_Callback*)(FlMainWindow::cb_visualize), (void*)(TUNNELMODEL_SOLUTION),
	       ((nbSolutions > 0) ? 0 : FL_MENU_INACTIVE) |
	       ((GlobalData::getSimulationParameters()._finalstepParameters._simulationMode == SIMULATIONMODE_SHOOTING) ? FL_MENU_DIVIDER : 0));

  if (GlobalData::getSimulationParameters()._finalstepParameters._simulationMode == SIMULATIONMODE_SHOOTING)
    {
      if (GlobalData::solutionInitialized())
	{
	  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6],labels[LabelStartIndex+34]);
	  menubar->add(str,FL_Enter,(Fl_Callback*)(FlMainWindow::cb_shootlaunch), 0);
	}
      else
	{
	  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+3],labels[LabelStartIndex+6],labels[LabelStartIndex+34]);
	  menubar->add(str,FL_Enter,(Fl_Callback*)(FlMainWindow::cb_shootlaunch), 0, FL_MENU_INACTIVE);
	}
    }

  sprintf(str,"%s",labels[LabelStartIndex+10]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+10],labels[LabelStartIndex+11]);
  menubar->add(str, FL_CTRL + 'n', (Fl_Callback*)(FlMainWindow::cb_newtunnel), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+10],labels[LabelStartIndex+12]);
  menubar->add(str, FL_CTRL + 't', (Fl_Callback*)(FlMainWindow::cb_loadtunnel), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+10],labels[LabelStartIndex+13]);
  menubar->add(str, FL_CTRL + 's', (Fl_Callback*)(FlMainWindow::cb_savetunnel), 0);

  sprintf(str,"%s",labels[LabelStartIndex+14]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+14],labels[LabelStartIndex+15]);
  menubar->add(str, FL_CTRL + 'l', (Fl_Callback*)(FlMainWindow::cb_loadlights), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+14],labels[LabelStartIndex+16]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_savelights), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+14],labels[LabelStartIndex+17]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_listlights), 0);

  sprintf(str,"%s",labels[LabelStartIndex+18]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+19]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+19],labels[LabelStartIndex+20]);
  menubar->add(str, FL_CTRL + 'f', (Fl_Callback*)(FlMainWindow::cb_loadfloors), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+19],labels[LabelStartIndex+21]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_savefloors), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+19],labels[LabelStartIndex+22]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_listfloors), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+23]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+23],labels[LabelStartIndex+24]);
  menubar->add(str, FL_CTRL + 'w', (Fl_Callback*)(FlMainWindow::cb_loadwalls), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+23],labels[LabelStartIndex+25]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_savewalls), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+23],labels[LabelStartIndex+26]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_listwalls), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+27]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+27],labels[LabelStartIndex+28]);
  menubar->add(str, FL_CTRL + 'r', (Fl_Callback*)(FlMainWindow::cb_loadroofs), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+27],labels[LabelStartIndex+29]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_saveroofs), 0);
  sprintf(str,"%s/%s/%s",labels[LabelStartIndex+18],labels[LabelStartIndex+27],labels[LabelStartIndex+30]);
  menubar->add(str, 0, (Fl_Callback*)(FlMainWindow::cb_listroofs), 0);

  sprintf(str,"%s",labels[LabelStartIndex+31]);
  menubar->add(str, 0, 0, 0, FL_SUBMENU);
  sprintf(str,"%s/%s",labels[LabelStartIndex+31],labels[LabelStartIndex+32]);
  menubar->add(str, 0, (Fl_Callback*)(NULL), 0);
  sprintf(str,"%s/%s",labels[LabelStartIndex+31],labels[LabelStartIndex+33]);
  menubar->add(str, 0, (Fl_Callback*)(NULL), 0);

  menubar->global();
}
