#include "gui/FlSelectResolution.h"

#include "recherche/Globals.h"

#define LabelStartIndex 0

FlSelectResolution::FlSelectResolution() :
  Fl_Window(300,300,"Select. resolution")
{
  box(FL_UP_BOX);
  labelsize(12);
  user_data((void*)(this));
  resizable(NULL);

  {
    Fl_Hold_Browser* o = _resolutionList = new Fl_Hold_Browser(5,5,290,245,"Solutions :");
    for (int i=0;i<nbSolutions;i++)
      {
	char str[255];
	 sRepartition r;
	ident(r,lesSolutions[i]);
	sprintf(str,"[%d %d %d,%d %d %d,%s %s %s %s,%8.1f]",
		r.ramp[0],r.ramp[1],r.ramp[2],
		r.nsou[0],r.nsou[1],r.nsou[2],
		r.sou->_name,r.fr->_spectrumName,r.wl->_spectrumName,r.rf->_spectrumName,
		r.prix);
	o->add(str,(void*)i);
      }
  }

  _validateButton = new Fl_Button(10,275,80,20,"Ok");
  _validateButton->callback((Fl_Callback*)(FlSelectResolution::cb_validate));
  _cancelButton = new Fl_Button(110,275,80,20,"Cancel");
  _cancelButton->callback((Fl_Callback*)(FlSelectResolution::cb_cancel));

  end();
  set_modal();
  _buttonClicked = 0;
}

FlSelectResolution::~FlSelectResolution()
{
}

int FlSelectResolution::clicked()
{
  return _buttonClicked;
}

void FlSelectResolution::cb_validate_i(Fl_Widget* o, void* v)
{
  _buttonClicked = _resolutionList->value();
  if (_buttonClicked == 0) _buttonClicked = -1;
}

void FlSelectResolution::cb_validate(Fl_Widget* o, void* v)
{
  ((FlSelectResolution*)(o->parent()))->cb_validate_i(o,v);
}

void FlSelectResolution::cb_cancel_i(Fl_Widget* o, void* v)
{
  _buttonClicked = -1;
}

void FlSelectResolution::cb_cancel(Fl_Widget* o, void* v)
{
  ((FlSelectResolution*)(o->parent()))->cb_cancel_i(o,v);
}
