#include "includes.h"
#include "FlGlImageViewer.h"
#include "FlMainWindow.h"


bool verbose;

void help_(){

	cout << endl << endl << "*****************************        HELP        *****************************" << endl << endl << endl;
	cout << " \t -h \t help" << endl << endl;
	cout << " \t -v \t verbose" << endl << endl;
	cout << " \t -l <filename>" << endl;
	cout << " \t  \t load image file" << endl << endl;
	cout << " \t -s <filename>" << endl;
	cout << " \t  \t save image file" << endl << endl;
	cout << " \t -k <filename>" << endl;
	cout << " \t  \t load image file as modified image" << endl;
	cout << " \t  \t (must have the same size than the initial image)" << endl << endl;
	cout << " \t -z <filename>" << endl;
	cout << " \t  \t load polygons file" << endl << endl;
	cout << " \t -x <filename>" << endl;
	cout << " \t  \t save polygons file" << endl << endl;
	cout << " \t -c \t clear polygons" << endl << endl;
	cout << " \t -e \t equalize histograms" << endl << endl;
	cout << " \t -f [<int> = 1]" << endl;
	cout << " \t  \t apply selective filter with the size 2 * <int> + 1" << endl << endl;
	cout << " \t -d [<int> = 1]" << endl;
	cout << " \t  \t gradient with sensibility <int>" << endl << endl;
	cout << " \t -a [<int1> = 1 [<int2> = 0]]" << endl;
	cout << " \t  \t anisotropic diffusion" << endl;
	cout << " \t  \t <int1> iterations" << endl;
	cout << " \t  \t if <int2> = 1 : diffusion function = gaussian function" << endl;
	cout << " \t  \t if <int2> = 2 : diffusion function = hyperbolic function" << endl;
	cout << " \t  \t else          : diffusion function = 1" << endl << endl;
	cout << " \t -g [<int> = 1]" << endl;
	cout << " \t  \t gaussian filter, <int> iterations" << endl << endl;
	cout << " \t -y \t compute luminosity image" << endl << endl;
	cout << " \t -n \t compute normalized image" << endl << endl;
	cout << " \t -p \t push image as first operand" << endl << endl;
	cout << " \t -/ \t divizion : pushed image / current image" << endl << endl;
	cout << " \t -\\ \t divizion : current image / pushed image" << endl << endl;
	cout << " \t -. \t mulltiplication : pushed image * current image" << endl << endl;
	cout << " \t -2 \t double luminosity of the current image" << endl << endl;
	cout << " \t -b <int_r> <int_g> <int_b>" << endl;
	cout << " \t  \t fill the holes with the color (<int_r> , <int_g> , <int_b>)" << endl << endl;
	cout << " \t -i \t current image = initial image" << endl << endl;
	cout << " \t -m \t current image = modified image" << endl << endl;
	cout << " \t -o \t current image = pushed image" << endl << endl;
	cout << endl << "******************************************************************************" << endl << endl << endl;

}

void error_(int argc,char **argv,char **err){

  char **c;
  int i;
  cout << endl << "erreur dans le passage des arguments" << endl << endl;
  for(c = &argv[0] , i = 0 ; c != err ; c++ , i++)
    cout << *c << " ";
  cout << " # " << *(c++) << " # ";
  for(i++ ; i < argc ; i++ , c++)
    cout << " " << *c;
  cout << endl;
  help_();
  exit(0);

}

// unsigned int get_int(char *c){
//   int res = 0;
//   while((*c) != NULL){
//     res *= 10;
//     res += (unsigned int) ((*c++) - '0');
//   }
// }


int main(int argc,char** argv) {

  if(argc < 2){
    Fl::visual(FL_DOUBLE|FL_INDEX);
    FlMainWindow * imw = new FlMainWindow(1100,700,"Elimination des ombres");
    //   if (argc == 2) {
    //     ImageRGB img = loadImageRGB(argv[1]);
    //     imw->Init(img);
    //   };
    imw->show();
    Fl::run();
    return 0;
  }

  else{

    verbose = false;

    unsigned int i1,i2,i3;
    float f1,f2;

    char *op;
    char **arg,**fin;
    Traitement traitement;
    
    for(arg = &argv[1] , fin = &argv[argc] ; arg < fin ; arg++){

      op = *arg;
      if(*(op++) != '-'){
	error_(argc,argv,arg);
      }
      
      if(op[1] != NULL){
	error_(argc,argv,arg);
      }

      switch(*op){

      case 'v' : 
	verbose = true;
	break;
      case 'l' : 
      case 's' : 
      case 'z' : 
      case 'x' : 
      case 'k' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	break;

      case 'd' : 
      case 'f' :
      case 'g' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  ++arg;
	}
	break;

      case 'a' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  ++arg;
	}
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  ++arg;
	}
	break;

      case 'c' : 
      case 'y' : 
      case 'n' : 
      case 'p' :
      case '/' : 
      case '\\': 
      case '.' : 
      case '2' : 
      case 'i' : 
      case 'm' : 
      case 'o' : 
      case 'h':
	break;

      case 'b' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  arg ++;
	  if((&arg[1] != fin) && (arg[1][0] != '-'))
	    arg ++;
	  else error_(argc,argv,arg);
	  if((&arg[1] != fin) && (arg[1][0] != '-'))
	    arg ++;
	  else error_(argc,argv,arg);
	}
	break;

      }
    }

    // fin de l'analyse // debut du traitement //

    for(arg = &argv[1] ; arg < fin ; arg++){

      op = *arg;
      if(*(op++) != '-'){
	error_(argc,argv,arg);
      }
      
      if(op[1] != NULL){
	error_(argc,argv,arg);
      }

      switch(*op){

      case 'v' : 
	break;

      case 'l' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	if(verbose){
	  cout << "loading image \'" << (*arg) << "\'" << endl;
	}
	traitement.load(*arg);
	break;

      case 's' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	if(verbose){
	  cout << "saving image \'" << (*arg) << "\'" << endl;
	}
	traitement.save(*arg);
	break;

      case 'z' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	if(verbose){
	  cout << "loading polygons \'" << (*arg) << "\'" << endl;
	}
	traitement.load_polygons(*arg);
	break;

      case 'x' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	if(verbose){
	  cout << "saving polygons \'" << (*arg) << "\'" << endl;
	}
	traitement.save_polygons(*arg);
	break;

      case 'c' : 
	if(verbose){
	  cout << "clearing polygons" << endl;
	}
	traitement.clear_polygons();
	break;

      case 'k' : 
	if((++arg) == fin){
	  error_(argc,argv,arg);
	}
	if(verbose){
	  cout << "loading modified image \'" << (*arg) << "\'" << endl;
	}
	if(!traitement.load_modified(*arg)){
	  cout << "loading modified image aborted : uncoherent size with the initial image" << endl;
	}
	break;

      case 'f' :
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i1 = atoi(*(++arg));
	}
	else{
	  i1 = 1;
	}
	if(verbose){
	  cout << "computing selective filter :  parameter = " << i1 << endl;
	}
	traitement.selective_filter(i1);	
	break;

      case 'd' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i1 = atoi(*(++arg));
	}
	else{
	  i1 = 1;
	}
	if(verbose){
	  cout << "computing gradient : sensibility = " << i1 << endl;
	}
	traitement.gradient(i1);	
	break;

      case 'a' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i1 = atoi(*(++arg));
	}
	else{
	  i1 = 1;
	}
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i2 = atoi(*(++arg));
	}
	else{
	  i2 = 0;
	}
	if(verbose){
	  cout << "computing anisotropic diffusion : " << i1 << " iteration";
	  if(i1 > 1)
	    cout << "s";
	  if(i2 == 1)
	    cout << " , diffusion function : gaussian" << endl;
	  else if(i2 == 2)
	    cout << " , diffusion function : hyperbolic" << endl;
	  else
	    cout << endl;
	}
	traitement.aniso_diff(i1,i2,100.,.25);	
	break;

      case 'g' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i1 = atoi(*(++arg));
	}
	else{
	  i1 = 1;
	}
	if(verbose){
	  cout << "computing gaussian filter : " << i1;
	  if(i1 > 1)
	    cout << " iterations" << endl;
	  else
	    cout << " iteration" << endl;
	}
	traitement.gauss_filter_split(i1);	
	break;

      case 'y' : 
	if(verbose){
	  cout << "computing luminosity image" << endl;
	}
	traitement.gray();	
	break;

      case 'n' : 
	if(verbose){
	  cout << "computing normalized image" << endl;
	}
	traitement.normalize();	
	break;

      case 'p' : 
	if(verbose){
	  cout << "pushing image " << endl;
	}
	traitement.push();	
	break;

      case '/' : 
// 	if((&arg[1] != fin) && (arg[1][0] != '-')){
// 	  i1 = atoi(*(++arg));
// 	  i2 = atoi(*(++arg));
// 	  i3 = atoi(*(++arg));
// 	}
// 	else{
// 	  i1 = -1;
// 	}
	if(verbose){
// 	  if(i1 == -1)
	    cout << "computing divized image" << endl;
// 	  else
// 	    cout << "computing divized image : r = " << i1 <<" , g = " << i2 << " , b = " << i3 << endl;
	}
// 	if(i1 == -1)
	  traitement.diviz();	
// 	else
// 	  traitement.diviz(i1,i2,i3);	
// 	break;

      case '\\' : 
	if(verbose){
	  cout << "computing undivized image" << endl;
	}
	traitement.undiviz();	
	break;

      case '.' : 
	if(verbose){
	  cout << "computing multiplied image" << endl;
	}
	traitement.mult();	
	break;

      case '2' : 
	if(verbose){
	  cout << "computing duble luminosity image" << endl;
	}
	traitement.double_lum();	
	break;

      case 'b' : 
	if((&arg[1] != fin) && (arg[1][0] != '-')){
	  i1 = atoi(*(++arg));
	  i2 = atoi(*(++arg));
	  i3 = atoi(*(++arg));
	}
	else{
	  i1 = -1;
	}
	if(verbose){
	  cout << "filling hole in image : r = " << i1 <<" , g = " << i2 << " , b = " << i3 << endl;
	}
	if(i1 == -1)
	  traitement.fill_hole(0,0,0);	
	else
	  traitement.fill_hole(i1,i2,i3);	
	break;

      case 'i' : 
	if(verbose){
	  cout << "activing initial image" << endl;
	}
	traitement.initial();	
	break;

      case 'm' : 
	if(verbose){
	  cout << "activing modified image" << endl;
	}
	traitement.modified();	
	break;

      case 'o' : 
	if(verbose){
	  cout << "activing pushed image" << endl;
	}
	traitement.pushed();	
	break;

      case 'h':
	help_();
	break;

      default :
	error_(argc,argv,arg);
      }
    }
  }
  return 0;
}





