#include "others/SystemFuncs.h"

#include <sys/stat.h>
#include <unistd.h>

char filter[255];

char* getFilter(char* ext)
{
  sprintf(filter,"*%s",ext);
  return filter;
}

void goThroughBlankChar(ifstream& in)
{
  char c;
  c = in.get();
  while (c == ' ') c = in.get();
  in.seekg(-1,ios::cur);
}

void dumpPath(char** dir)
{
  int id = 0;
  while (dir[id] != NULL) { cout << "[" << dir[id] << "]"; id++; }
  cout << endl;
}

int findNextDirectorySeparator(char* dir,int id)
{
  int res = id;
  while ((res < strlen(dir)) && (dir[res] != '/')) res++;
  return res;
}

char** splitDirectories(char* dir)
{
  char** res;
  int nbslash = (dir[0] == '/' ? 0 : 1);
  for (int i=0;i<strlen(dir);i++)
    if (dir[i] == '/') nbslash++;
  res = (char**)(new (char*)[nbslash+1]);
  int idchar = 0;
  int idslash = 0;
  for (int i=0;i<nbslash;i++)
    {
      int idnext = findNextDirectorySeparator(dir,idchar+1);
      res[idslash] = new char[idnext-idchar+1];
      strncpy(res[idslash],&(dir[idchar]),idnext-idchar);
      res[idslash][idnext-idchar] = '\0';
      idslash++;
      idchar = idnext;
    }
  res[idslash] = (char*)NULL;
  return res;
}

int countSubDirectories(char** split)
{
  int nb = 0;
  while (split[nb] != NULL) nb++;
  return nb;
}

char** removeSubDirectory(char** split,int id)
{
  int nb = countSubDirectories(split);
  char** res = (char**)(new (char*)[nb]);
  int idsub = 0;
  int idcrt = 0;
  while (split[idsub] != NULL)
    {
      if (idsub != id)
	{
	  res[idcrt] = split[idsub];
	  idcrt++;
	}
      idsub++;
    }
  res[nb-1] = NULL;
  delete [] split[id];
  delete [] split;
  return res;
}

char** replaceInCurrentPath(char** crtpath,int id,char** crtsubpath)
{
  int i;
  int nbcrt = countSubDirectories(crtpath);
  int nbcrtsub = countSubDirectories(crtsubpath);
  int nvnb = (nbcrt-id+1)+nbcrtsub + 1;
  char** res = (char**)(new (char*)[nvnb]);
  for (i=0;i<nbcrtsub;i++) res[i] = crtsubpath[i];
  for (;i<nvnb-1;i++) res[i] = crtpath[i-nbcrtsub+id];
  res[nvnb-1] = NULL;
  return res;
}

char** insertInCurrentPath(char** crtpath,int id,char** crtsubpath)
{
  int i;
  int nbcrt = countSubDirectories(crtpath);
  int nbcrtsub = countSubDirectories(crtsubpath);
  int nvnb = nbcrt + nbcrtsub + 1;
  char** res = (char**)(new (char*)[nvnb]);
  for (i=0;i<id;i++) res[i] = crtpath[i];
  for (i=id;(i-id)<nbcrtsub;i++) res[i] = crtsubpath[i-id];
  for (i=id+nbcrtsub;i<nvnb-1;i++) res[i] = crtpath[i-id-nbcrtsub];
  res[nvnb-1] = NULL;
  return res;
}

char** getAbsoluteDirectory(char* dir)
{
  char* homedir = getenv("HOME");
  char* working = getenv("PWD");
  char** splithome = splitDirectories(homedir);
  char** splitworking = splitDirectories(working);
  char** splitdir = splitDirectories(dir);
  int id = 0;
  /* test first sub-directory case : '~' , '.' , '..' */
  if (!strcmp(splitdir[0],"~"))
    {
      splitdir = replaceInCurrentPath(splitdir,0,splithome);
    }
  else if (!strcmp(splitdir[0],"."))
    {
      splitdir[0] = new char[4]; sprintf(splitdir[0],"/.");
      splitdir = replaceInCurrentPath(splitdir,0,splitworking);
    }
  else if (!strcmp(splitdir[0],".."))
    {
      splitdir[0] = new char[4]; sprintf(splitdir[0],"/..");
      splitdir = insertInCurrentPath(splitdir,0,splitworking);
    }
  else if (splitdir[0][0] != '/')
    {
      char* tmp = splitdir[0];
      splitdir[0] = new char[strlen(tmp)+1]; sprintf(splitdir[0],"/%s",tmp);
      splitdir = insertInCurrentPath(splitdir,0,splitworking);
    }
  while (splitdir[id] != NULL)
    {
      if (!strcmp(splitdir[id],"/."))
	{
	  splitdir = removeSubDirectory(splitdir,id);
	}
      else if (!strcmp(splitdir[id],"/.."))
	{
	  cout << "{/..} " << id << " ";; dumpPath(splitdir);
	  splitdir = removeSubDirectory(splitdir,id);
	  cout << "{/..} " << id << " ";; dumpPath(splitdir);
	  id--;
	  splitdir = removeSubDirectory(splitdir,id);
	  cout << "{/..} " << id << " "; dumpPath(splitdir);
	}
      else if (splitdir[id][1] == '~')
	{
	  int err;
	  char fname[255];
	  char execline[255];
	  sprintf(fname,"%s/getdirname",working);
	  ofstream output(fname,ios::out);
	  output << "#! /usr/bin/tcsh" << endl;
	  output << "cd " << &(splitdir[id][1]) << endl;
	  output << "pwd >! " << working << "/dirname.txt" << endl;
	  output.close();
	  sprintf(execline,"chmod 755 %s/getdirname",working); err = system(execline);
	  sprintf(execline,"%s/getdirname",working); err = system(execline);
	  sprintf(fname,"%s/dirname.txt",working);
	  ifstream input(fname,ios::in);
	  char nvdir[255]; input.getline(nvdir,255,'\n');
	  input.close();
	  sprintf(execline,"\\rm -f %s/dirname.txt %s/getdirname",working,working); err = system(execline);
	  char** path = splitDirectories(nvdir);
	  splitdir = replaceInCurrentPath(splitdir,id+1,path);
	  id = 0;
	}
      else id++;
    }
  return splitdir;
}

char* concatSplittedDirectories(char** splitdir)
{
  int lg = 0;
  for (int i=0;splitdir[i] != NULL;i++) lg += strlen(splitdir[i]);
  char* res = new char[lg+1]; res[0] = '\0';
  for (int i=0;splitdir[i] != NULL;i++) sprintf(res,"%s%s",res,splitdir[i]);
  return res;
}

void freeSplittedDirectories(char** splitdir)
{
  int i=0;
  while (splitdir[i] != NULL)
    {
      delete [] splitdir[i];
      i++;
    }
  delete [] splitdir;
}

void getFilenameIndexes(const char* fname,int& lastsep,int& point)
{
  int i;
  for (i=strlen(fname)-1;i>=0;i--) if (fname[i] == '/') break;
  lastsep = i;
  for (i=lastsep;i<strlen(fname);i++) if (fname[i] == '.') break;
  point = i;
}

int existFile(const char* fname)
{
  ifstream in(fname,ios::in);
  if (!in) return 0;
  else { in.close(); return 1; }
}

int existDirectory(const char* dname)
{
  struct stat   s;
  return !stat(dname, &s) && (s.st_mode&0170000)==0040000;
}
