#include "others/includes.h"
#include "others/GlobalData.h"
#include "others/Parameters.h"

#include "gui/launch.h"
#include "radiosite/StaticMemory.h"
#include "recherche/Recherche.h"

int main(int argc,char** argv) {
  Parameters::initializeDefaultParameters();
  Parameters::initializeProgramParameters(argv[0]);
  GlobalData::initialize();
  GlobalData::initializeDefaultData();
  Parameters::initializeCommandLineParameters(argc,argv);
  if (Parameters::_interfaceMode == ON)
    {
      return launchGUI(argc,argv);
    }
  else
    {
      Parameters::dumpParameters();
      GlobalData::dumpGlobalData();
      if (Parameters::_configurationSearch == ON) GlobalData::lancerRecherche();
      if (Parameters::_outputSearchResult == ON) GlobalData::saveResolutionSearchResult(Parameters::_resolutionSearchFilename);
      if (Parameters::_finalSimulation == ON) {
	StaticMemory::allocate(maxNumberOfPointsInSpectrum,Parameters::_MaxM,GlobalData::getSimulationParameters()._finalstepParameters._waveletBasis);
	GlobalData::getMaillageSolution();
	GlobalData::saveMaillageSolution(Parameters::_geometricDataFilename);
	StaticMemory::free(maxNumberOfPointsInSpectrum,Parameters::_MaxM,GlobalData::getSimulationParameters()._finalstepParameters._waveletBasis);
      }
      return ERROR_NONE;
    }
};
