
#include "polygon.h"
#include "FlMainWindow.h"

/* protected:

  bool _valid;
  vector<sPoint2d> _v;
  map<int,set<int> > _m;

 public:
*/
Polygon::Polygon(float r,float g,float b){
  _valid = false;
  _desc = false;
  _r = r;
  _g = g;
  _b = b;
  // _v.clear();
}

/*void Polygon::operator+=(int x,int y){
  _v.push_back(sPoint2d(x,y));
  }*/
 
void Polygon::operator+=(sPoint2d p){
  vector<sPoint2d>::const_iterator it = _v.end();
  if((it == _v.begin()) || (x(*(--it)) != x(p))  || (y(*it) != y(p))){
    _v.push_back(p);
  }   
}
  
void Polygon::operator!(){
  _valid = true;
  init_carte();
}
 
void Polygon::unvalid(){
  _valid = false;
  _m.clear();
}
 
bool Polygon::operator*()const{
  return _valid;
}

bool Polygon::operator()(int x,int y)const{
  set<int>::const_iterator it;
  map<int,set<int> >::const_iterator it_m = _m.find(y);

//   if(it_m != _m.end()){
//     it = it_m->second.find(x);
//     return it != it_m->second.end();
//   }

  if(it_m == _m.end())
    return false;
  for(it = it_m->second.upper_bound(x);it != it_m->second.end();it++){
    if(++it == it_m->second.end())
      return true;
  }
  return false;
}

bool Polygon::operator()(const sPoint2d p)const{
  return (*this)(x(p),y(p));
}

#ifdef WITH_FL_GL
void Polygon::draw()/*const*/{
  //_v.clear();
  sPoint2d premier,ancien;
  vector<sPoint2d>::const_iterator it;
  if(_valid){
    glColor3f(_r,_g,_b);
    it = _v.begin();
    if(it != _v.end()){
      ////cout <<  "draw : un polygone valide" << endl;
      copyPoint2d(FlMainWindow::im2gl(*it) , premier);
      copyPoint2d(FlMainWindow::im2gl(*it) , ancien);
      for(it++;it != _v.end();it++){
	glDrawLine2d(ancien , FlMainWindow::im2gl(*it));
	copyPoint2d(FlMainWindow::im2gl(*it) , ancien);
      }
      glDrawLine2d(ancien , premier);
    }
  }
  else{
    glColor3f(_r,_g,_b);
    for(it = _v.begin();it != _v.end();it++){
      //////cout << "draw : size = " <<_v.size() <<  endl;
      glDrawVertex2d(FlMainWindow::im2gl(*it));
    }
  }
}
#endif

void Polygon::clear(){
  _valid = false;
  _v.clear();
  _m.clear();
}
 
int Polygon::size()const{
  return _v.size();
}

bool Polygon::empty()const{
  return _v.empty();
}

void Polygon::pop(){
  _v.pop_back();
}
 
void Polygon::init_color(float r,float g,float b){
  _r = r;
  _g = g;
  _b = b;
}

void Polygon::inserer(int x, int y){ 
  ////cout << "Polygon::inserer : " << x << " , " << y << endl;
  map<int,set<int> >::iterator it_m;
  set<int> s_int;
  it_m = _m.find(y);
  if(it_m == _m.end()){
    s_int.insert(x);
    _m[y] = s_int;
    //////cout << __FUNCTION__ << " : nouvelle liste" << endl;
    //////cout << "0";
  }
  else{
    if(it_m->second.find(x) == it_m->second.end()){
      s_int = it_m->second;
      s_int.insert(x);
      _m.erase(y);
      _m[y] = s_int;
      //////cout << "+";
      //      it_m->second.insert(x);
    }
    else{
      it_m->second.erase(x);
      //////cout << "-";
    }
  }      
}
 
void Polygon::inserer_segment(int x1,int y1,int x2,int y2){//,int x3,int y3){
  if(y2 == y1)
    return;

  inserer(x2,y2);	// inserer l'extremite de fin dans la carte
      
  if(((y1 < y2) && (_desc)) || ((y1 > y2) && (!_desc))) // si on change de sens, enlever la derniere extremite
    inserer(x1,y1);

  int j;
  
  // insertion du segment dans la carte
  if(y1 < y2){
    _desc = false;
    for(j = y1 + 1;j < y2;j++)
      inserer(x1 + ((x2 - x1) * (j - y1) / (y2 - y1)),j);
  }
  else{
    _desc = true;
    for(j = y1 - 1;j > y2;j--)
      inserer(x1 + ((x2 - x1) * (j - y1) / (y2 - y1)),j);
  }

}
   
void Polygon::init_carte(){
  int x1,x2,x3,y1,y2,y3;
  vector<sPoint2d>::const_iterator it;

  it = _v.begin();

  if(it == _v.end())
    return;
  
  x1 = it->x;
  y1 = it->y;
  it++;
  if(it == _v.end())
    return;
  x2 = it->x;
  y2 = it->y;
  it++;
  if(it == _v.end())
    return;

  _desc = false;	// on suppose qu'avant le premier segment, on monte

  for(;it != _v.end();it++){
    inserer_segment(x1,y1,x2,y2);
    x1 = x2;
    y1 = y2;
    x2 = it->x;
    y2 = it->y;
  }
  
  inserer_segment(x1,y1,x2,y2);
  it = _v.begin();
  x1 = it->x;
  y1 = it->y;
  inserer_segment(x2,y2,x1,y1);

  if(_desc)
    inserer(x1,y1);	// si en fait on descendait on rectifie l'extremite initiale;
  
//   map<int,set<int> >::iterator it_m;
//   set<int>::iterator it_s;
//   for(it_m = _m.begin();it_m != _m.end();it_m++){
//     for(it_s = it_m->second.begin();it_s != it_m->second.end(),(*it_s) < 0 ;it_s++){
//       ////cout << " y = " << it_m->first << " , x = " << *it_s << endl;getchar();
//     }
//   }
}

const vector<sPoint2d>& Polygon::get_v()const{
  return _v;
}



