#include "radiosite/Lambda.h"

void ecrire_res(Lambda *Sres,char name[20])
{
  cout << "ecrire_res(" << name << ")" << endl;
  int i;
  FILE *f;
  if ((f=fopen(name, "w"))==NULL) cerr << "can't write file" << endl;
  for (i=0;i<Sres->taille;i++)
    fprintf(f,"%g %g \n",Sres->pts[i].x,Sres->pts[i].y);
  fclose(f);
}

void read_res(Lambda *Sres,char name[20])
{
  cout << "read_res(" << name << ")" << endl;
  int i=0,k;
  double absc,val;
  FILE *f;
  if ((f=fopen(name, "r"))==NULL) cerr << "can't read file" << endl;
  while (!feof(f))
    {
      fscanf(f, "%lf %lf", &absc, &val);
      if (!feof(f))
	{
	  Sres->pts[i].x=absc;
	  Sres->pts[i].y=val;
	  i++;
	}
    }
  fclose(f);
  Sres->taille=i;
  for (k=i;k<maxNumberOfPointsInSpectrum;k++)
    {
      Sres->pts[k].x=0;
      Sres->pts[k].y=0;
    }
}

void initSpectre(Lambda *S, sLightSourceSpectrum& lightspectrum)
{
  int i=0;
  for (;i<lightspectrum._nbvalues;i++)
    {
       S->pts[i].x = lightspectrum._values[0][i];
       S->pts[i].y = lightspectrum._values[1][i];
   }
   i--;
   while (S->pts[i].y==S->pts[i-1].y || S->pts[i].y==0){
       S->pts[i].x=0;
       S->pts[i].y=0;
       i--;
   }
   S->taille=i+1;
}

void initLambda(Lambda *S, Lambda *Sres)
{
  int i;
  for (i=0; i< S->taille;i++)
    {
      Sres->pts[i].x=S->pts[i].x;
      Sres->pts[i].y=S->pts[i].y;
    }
  Sres->pts[S->taille].x=2*S->pts[S->taille-1].x-S->pts[S->taille-2].x;
  Sres->pts[S->taille].y=S->pts[S->taille-1].y;
  Sres->pts[S->taille+1].x=2*S->pts[S->taille-1].x-S->pts[S->taille-3].x;
  Sres->pts[S->taille+1].y=S->pts[S->taille-1].y;
  Sres->taille=S->taille;
}

void calculNouveauxV(Point *V_2,Point *V_1,Point *V0,Point *V1,Point *V2,Point *V_1N,Point *V1N)
{
  cout << "V-2 " << V_2->x << "  " << V_2->y << endl;
  cout << "V-1 " << V_1->x << "  " << V_1->y << endl;
  cout << "V0 " << V0->x << "  " << V0->y << endl;
  cout << "V1 " << V1->x << "  " << V1->y << endl;
  cout << "V2 " << V2->x << "  " << V2->y << endl;
  double A,B,C,D,E,F,den;
  B=(V0->x-V_1->x)*(V0->x-V_1->x)/(V1->x-V_1->x);
  A=2*V0->x-V_1->x-V_2->x-B;
  C=-V_1->y*(V0->x-V_2->x)-V0->y*(V0->x-V_1->x);
  D=V1->x-V0->x-((V1->x-V0->x)*(V0->x-V_1->x)/(V1->x-V_1->x));
  E=(V1->x-V0->x)*(1+(V0->x-V_1->x)/(V1->x-V_1->x))+(V2->x-V1->x);
  F=V0->y*(V0->x-V1->x)+V1->y*(V0->x-V2->x);
  cout << A << "  " << B << "  " << C << "  " << D << "  " << E << "  " << F << endl;
  den=D*B-A*E;
  if (den > smallEpsilonValue || (-den)>smallEpsilonValue)
    {
      V1N->x=V1->x;
      V1N->y=(A*F-D*C)/den;
      V_1N->x=V_1->x;
      V_1N->y=(C*E-B*F)/den;
      cout << "V-1N " << V_1N->x << "  " << V_1N->y << endl;
      cout << "V1N " << V1N->x << "  " << V1N->y << endl;
    }
}

double erreur(Point *V_1,Point *V_1N,Point *V0,Point *V1N,Point *V1)
{
  double a1, b1, a2, b2, a3, b3;
  double Err,ABx,ABy,AV0x,AV0y;
  Point AA,BB;
  Point *A = &(AA), *B = &(BB);
//   A = new Point;
//   B = new Point;
  /* droite (V-1 V0) */
  a1=(V0->y - V_1->y)/(V0->x - V_1->x);
  b1= V_1->y - a1*V_1->x;
  /* droite (V-1N V1N) */
  a2=(V1N->y - V_1N->y)/(V1N->x - V_1N->x);
  b2= V_1N->y - a2*V_1N->x;
  /* droite (V0 V1) */
  a3=(V1->y - V0->y)/(V1->x - V0->x);
  b3= V0->y - a3*V0->x;
  /* A : Point d'intersection de (V-1 V0) et de (V-1N V1N) */
  if ((a2-a1)==0 && (a3-a2)==0) { delete A; delete B; return 0; }
  if ((a2-a1)==0) A->x=0;
  else A->x=(b1-b2)/(a2-a1);
  A->y= a1*A->x + b1;
  /* B : Point d'intersection de (V0 V1) et de (V-1N V1N) */
  if ((a3-a2)==0) B->x= 0;
  else  B->x=(b2-b3)/(a3-a2);
  B->y= a3*B->x + b3;
  ABx= B->x - A->x;
  ABy= B->y - A->y;
  AV0x= V0->x - A->x;
  AV0y= V0->y - A->y;
  /*Aire du triangle AVoB */
  Err= (ABx * AV0y)-( AV0x * ABy);
//   delete B;
//   delete A;
  if (Err >= 0) return Err;
  else return (-Err);
}

void oter(Lambda *Sres,int pos)
{
  int i;
  if (pos>=0)
    {
      for (i=pos; i<= Sres->taille;i++)
	{
	  Sres->pts[i].x=Sres->pts[i+1].x;
	  Sres->pts[i].y=Sres->pts[i+1].y;
	}
      Sres->pts[Sres->taille+1].x=0;
      Sres->pts[Sres->taille+1].y=0;
      Sres->taille--;
    }
}

void egal(Lambda *Sres,Lambda *Sfixe)
{
  int i;
  Sfixe->taille =Sres->taille;
  for (i=0; i<Sfixe->taille;i++)
    Sfixe->pts[i].x=Sres->pts[i].x;
}

void reajustement(Lambda *S,Lambda *Sres,Lambda *Sfinal)
{
  int i,j,k,pred=0;
  double V0,I0,I_1,V_1,V1,I1,I_2,I2,int1;
  for (i=0;i<Sfinal->taille;i++)
    {
      j=pred;
      while (j < Sres->taille && Sres->pts[j].x < Sfinal->pts[i].x) j++;
      pred=j;
      if (Sres->pts[j].x != Sfinal->pts[i].x)
	{
	  k=0;
	  while (S->pts[k].x != Sfinal->pts[i].x ) k++;
	  V0=S->pts[k].y;
	  I0=Sfinal->pts[i].x;
	  if (pred > 1 && pred < Sres->taille-1)
	    {
	      I_1=Sres->pts[pred-1].x;
	      V_1=Sres->pts[pred-1].y;
	      I_2=Sres->pts[pred-2].x;
	      V1=Sres->pts[pred].y;
	      I1=Sres->pts[pred].x;
	      I2=Sres->pts[pred+1].x;
	      int1=V_1+(V1-V_1)*(I0-I_1)/(I1-I_1)-V0;
	      Sres->pts[pred-1].y= ((I0-I_1)*(V_1+int1)+(I_1-I_2)*V_1)/(I0-I_2);
	      Sres->pts[pred].y=((I1-I0)*(V1+int1)+(I2-I1)*V1)/(I2-I0);
	    }
	  for (k=Sres->taille-1; k>=pred;k--)
	    {
	      Sres->pts[k+1].x=Sres->pts[k].x;
	      Sres->pts[k+1].y=Sres->pts[k].y;
	    }
	  Sres->pts[pred].x=Sfinal->pts[i].x;
	  Sres->pts[pred].y=V0;
	  Sres->taille++;
	}
    }
}

void reducSpectre(Lambda *S,double E_seuil,Lambda *Sres,Lambda *Sfixe)
{
  double E, Emin, Eint;
  int i, pos, j, premierefois=0;
  double V_1x, V_1y, V1x, V1y;
  Point AA,BB,VV_1N,VV1N;

  Point *A = &AA,*B = &BB,*V_1N = &VV_1N, *V1N = &VV1N;

//   V_1N = new Point;
//   V1N = new Point;
//   A = new Point;
//   B = new Point;

  E=0;
  initLambda(S,Sres);
  if (Sfixe->taille == 0) premierefois=1;
  while (E<E_seuil && Sres->taille>0)
    {
      Emin=hugeValue;
      /* les deux premiers points du spectre */
      A->x=2*S->pts[0].x-S->pts[1].x;
      A->y=S->pts[0].y;
      B->x=2*S->pts[0].x-S->pts[2].x;
      B->y=S->pts[0].y;
      if (premierefois)
	{
	  calculNouveauxV(B,A,&Sres->pts[0],&Sres->pts[1],&Sres->pts[2],V_1N, V1N);
	  Eint=erreur(A,V_1N,&Sres->pts[0],V1N,&Sres->pts[1]);
	  if (Eint < Emin)
	    {
	      Emin=Eint;
	      pos=0;
	      V_1x=V_1N->x;
	      V_1y=V_1N->y;
	      V1x=V1N->x;
	      V1y=V1N->y;
	    }
	  calculNouveauxV(A,&Sres->pts[0],&Sres->pts[1],&Sres->pts[2],&Sres->pts[3],V_1N, V1N);
	  Eint=erreur(&Sres->pts[0],V_1N,&Sres->pts[1],V1N,&Sres->pts[2]);
	  if (Eint < Emin)
	    {
	      Emin=Eint;
	      pos=1;
	      V_1x=V_1N->x;
	      V_1y=V_1N->y;
	      V1x=V1N->x;
	      V1y=V1N->y;
	    }
	  /* les autres */
	  for (i=2; i<Sres->taille;i++)
	    {
	      calculNouveauxV(&Sres->pts[i-2],&Sres->pts[i-1],&Sres->pts[i],&Sres->pts[i+1],&Sres->pts[i+2],V_1N, V1N);
	      Eint=erreur(&Sres->pts[i-1],V_1N,&Sres->pts[i],V1N,&Sres->pts[i+1]);
	      if (Eint < Emin)
		{
		  Emin=Eint;
		  pos=i;
		  V_1x=V_1N->x;
		  V_1y=V_1N->y;
		  V1x=V1N->x;
		  V1y=V1N->y;
		}
	    }
	}
      else
	{	 /*premierefois =0 */
	  j=0;
	  if (Sres->pts[0].x != Sfixe->pts[j].x)
	    {
	      calculNouveauxV(B,A,&Sres->pts[0],&Sres->pts[1],&Sres->pts[2],V_1N, V1N);
	      Eint=erreur(A,V_1N,&Sres->pts[0],V1N,&Sres->pts[1]);
	      if (Eint < Emin)
		{
		  Emin=Eint;
		  pos=0;
		  V_1x=V_1N->x;
		  V_1y=V_1N->y;
		  V1x=V1N->x;
		  V1y=V1N->y;
		}
	    }
	  else j++;
	  if (Sres->pts[1].x != Sfixe->pts[j].x)
	    {
	      calculNouveauxV(A,&Sres->pts[0],&Sres->pts[1],&Sres->pts[2],&Sres->pts[3],V_1N, V1N);
	      Eint=erreur(&Sres->pts[0],V_1N,&Sres->pts[1],V1N,&Sres->pts[2]);
	      if (Eint < Emin)
		{
		  Emin=Eint;
		  pos=1;
		  V_1x=V_1N->x;
		  V_1y=V_1N->y;
		  V1x=V1N->x;
		  V1y=V1N->y;
		}
	    }
	  else j++;
	  /* les autres */
	  for (i=2; i<Sres->taille;i++)
	    {
	      if (Sres->pts[i].x != Sfixe->pts[j].x)
		{
		  calculNouveauxV(&Sres->pts[i-2],&Sres->pts[i-1],&Sres->pts[i],&Sres->pts[i+1],&Sres->pts[i+2],V_1N, V1N);
		  Eint=erreur(&Sres->pts[i-1],V_1N,&Sres->pts[i],V1N,&Sres->pts[i+1]);
		  if (Eint < Emin)
		    {
		      Emin=Eint;
		      pos=i;
		      V_1x=V_1N->x;
		      V_1y=V_1N->y;
		      V1x=V1N->x;
		      V1y=V1N->y;
		    }
		}
	      else j++;
	    }
	}
      E+=Emin;
      if (E<E_seuil)
	{
	  Sres->pts[pos+1].x=V1x;
	  Sres->pts[pos+1].y=V1y;
	  if (pos!=0)
	    {
	      Sres->pts[pos-1].x=V_1x;
	      Sres->pts[pos-1].y=V_1y;
	    }
	  oter(Sres,pos);
	}
    }

//   delete B; /* eric's version */ // free(V_1N);
//   delete A; /* eric's version */ // free(V1N);
//   delete V1N; /* eric's version */ // free(A);
//   delete V_1N; /* eric's version */ // free(B);
}

/*
  modification par rapport a la version d'eric
      on ne prend qu'une source en parametre
*/

int reducLambda(sLightSource* light, int *nbondes, Lambda *Sfinal)
{
  char name[20];
  Lambda SS,SSres,SSfixe;
  Lambda *S = &SS,*Sres = &SSres,*Sfixe = &SSfixe;
  int i,k,nblamb;
  FILE *f;
  char * var;
  int res;

//   S = new Lambda;
//   Sres = new Lambda;
//   Sfixe = new Lambda;
  nblamb = 100;

  Sfixe->taille=0;
  var = light->_filename;
  initSpectre(S,light->_spectrum);
  reducSpectre(S,__simulationParameters._errorThreshold,Sres,Sfixe);
  egal(Sres,Sfixe);
  sprintf(name, "%s%d", "temp", 0);
  ecrire_res(Sres,name);
  if (Sfixe->taille !=0 && Sfixe->taille < nblamb)
    {
      nblamb = Sfixe->taille ;
      for(i=0;i<nblamb;i++)
	Sfinal->pts[i].x=Sfixe->pts[i].x;
      Sfinal->taille = nblamb;

      sprintf(name, "%s%d", "temp", 0);
      read_res(Sres,name);
      sprintf(name,"%s%s",var,".res");
      if (Sres->taille < Sfinal->taille){
	/*
	  initSpectre(S,var);
	*/
	initSpectre(S,light->_spectrum);
	reajustement(S,Sres,Sfinal);
	ecrire_res(Sres,name);
      }
      else { ecrire_res(Sres,name); } 
    }

  if (nblamb!=100)
    {
      res = 1;
//       fprintf(stderr,"\n Nombre de longueurs d'ondes necessaires pour representer correctement \n");
//       fprintf(stderr," le spectre d'emission de la source avec une erreur < %g \n",__simulationParameters._errorThreshold);
//       fprintf(stderr," >>>>>  %d longueurs d'ondes \n \n \n",nblamb);
    }
  else
    {
      res = 0;
      fprintf(stderr,"\n SEUIL D'ERREUR E_seuil = %g TROP GRAND.REDUISEZ LE!\n",__simulationParameters._errorThreshold);
    }
  if (res)
    {
      sprintf(name, "%s%d", "temp", 0);
      if ((f=fopen(name, "r"))!=NULL) remove(name);
      *nbondes=nblamb;
    }
//   delete Sfixe;
//   delete Sres;
//   delete S;
  return res;
}

int sampledSpectrumSize = 0;
double _sampledSpectrumdata[maxNumberOfPointsInSpectrum];
double* sampledSpectrum = _sampledSpectrumdata;

void calculSpectreReduit2(sLightSource* light)
{
  int i,nbondes;
  Lambda SSfinal;
  Lambda *Sfinal = &SSfinal;
  char * var;
//   Sfinal = new Lambda;
  if (reducLambda(light, &nbondes, Sfinal))
    {
      sampledSpectrumSize = nbondes;
//       if (sampledSpectrum != NULL) delete [] sampledSpectrum;
//       sampledSpectrum = new double[maxNumberOfPointsInSpectrum];
      for(i=0;i<sampledSpectrumSize;i++)
	sampledSpectrum[i]=Sfinal->pts[i].x;
    }
//   delete Sfinal;
}

int findPreviousArrayIndex(double* array,double value)
{
  int idx = 0;
  while (array[idx] < value) idx++;
  return idx;
}

void reduireSpectre(double* newspectrum,double* spectrumWavelength,double* spectrumValue)
{
  for (int i=0;i<sampledSpectrumSize;i++)
    {
      int j = findPreviousArrayIndex(spectrumWavelength,sampledSpectrum[i]);
      newspectrum[i] = spectrumValue[j];
    }
}
