#include "radiosite/Luminaire.h"

int Luminaire::_numberOfInstances = 0;

void Luminaire::stat()
{
  cout << "Luminaire::stat(" << sizeof(Luminaire) << ") :: " << _numberOfInstances << endl;
}

Luminaire::Luminaire() :
  Nb_Plans(0) ,
  step_plans(0.) ,
  Nb_dir(0) ,
  step_dir(0.) ,
  first_plan(0)
{
  _numberOfInstances++;
}

Luminaire::Luminaire(Luminaire& s) :
  Nb_Plans(s.Nb_Plans) ,
  step_plans(s.step_plans) ,
  Nb_dir(s.Nb_dir) ,
  step_dir(s.step_dir) ,
  first_plan(s.first_plan)
{
  for (int i=0;i<Nb_Plans;i++)
    for (int j=0;j<Nb_dir;j++)
      val[i][j] = s.val[i][j];
  _numberOfInstances++;
}

Luminaire::~Luminaire()
{
  _numberOfInstances--;
}

Luminaire& Luminaire::operator=(const Luminaire& s)
{
  if (this != &s)
    {
      Nb_Plans = s.Nb_Plans;
      step_plans = s.step_plans;
      Nb_dir = s.Nb_dir;
      step_dir = s.step_dir;
      first_plan = s.first_plan;
      for (int i=0;i<Nb_Plans;i++)
	for (int j=0;j<Nb_dir;j++)
	  val[i][j] = s.val[i][j];
    }
  return *this;
}
