#include "radiosite/OpticalProperty.h"

#include "radiosite/Lambda.h"
#include "radiosite/StaticMemory.h"

int Optical_prop::_numberOfInstances = 0;

void Optical_prop::stat()
{
  cout << "Optical_prop::stat(" << sizeof(Optical_prop) << ") :: " << _numberOfInstances << endl;
}

Optical_prop::Optical_prop() :
  refl(0.) ,
  emmit(0.)
{
  material[0] = '\0';
  ALLOCATEARRAY(spectrum,double,sampledSpectrumSize);
  for (int i=0;i<sampledSpectrumSize;i++) spectrum[i] = 0.;
  _numberOfInstances++;
}

Optical_prop::Optical_prop(Optical_prop& s) :
  refl(s.refl) ,
  emmit(s.emmit)
{
  material[0] = '\0';
  ALLOCATEARRAY(spectrum,double,sampledSpectrumSize);
  for (int i=0;i<sampledSpectrumSize;i++) spectrum[i] = s.spectrum[i];
  _numberOfInstances++;
}

Optical_prop::~Optical_prop()
{
  FREEARRAY(spectrum,double,sampledSpectrumSize);
  _numberOfInstances--;
}

Optical_prop& Optical_prop::operator=(const Optical_prop& s)
{
  if (this != &s)
    {
      strcpy(material,s.material);
      refl = s.refl;
      emmit = s.emmit;
      for (int i=0;i<sampledSpectrumSize;i++) spectrum[i] = s.spectrum[i];
    }
  return *this;
}
