#include "radiosite/StaticMemory.h"

long StaticMemory::_memoryallocated = 0;

int StaticMemory::_allocated = 0;
int StaticMemory::_maxS = -1;
int StaticMemory::_maxM = -1;
int StaticMemory::_M = -1;

double** StaticMemory::Shoot_shootenergy_C = NULL;
double* StaticMemory::Shoot_shootenergy_f = NULL;
double* StaticMemory::Shoot_shootenergy_B = NULL;
double* StaticMemory::Shoot_gatherfromsourcewithpushpull_f = NULL;
double* StaticMemory::Shoot_gatherfromsourcewithpushpull_B = NULL;
double*** StaticMemory::Shoot_gatherfromsourcewithpushpull_c = NULL;
double** StaticMemory::Shoot_shootfromsourceonestep_C = NULL;
double* StaticMemory::Shoot_pushpullsource_SW = NULL;
double* StaticMemory::Shoot_pushpullsource_NW = NULL;
double* StaticMemory::Shoot_pushpullsource_SE = NULL;
double* StaticMemory::Shoot_pushpullsource_NE = NULL;

double* StaticMemory::Solver_gatherwithpushpull_f = NULL;
double* StaticMemory::Solver_gatherwithpushpull_B = NULL;
double*** StaticMemory::Solver_gatherwithpushpull_c = NULL;
double** StaticMemory::Solver_solve_C = NULL;
double** StaticMemory::Solver_solve2_C = NULL;

double** StaticMemory::Wavelet_pullupenergytoroot_TMP_PULL = NULL;
double** StaticMemory::Wavelet_pullupenergytoroot_PULL = NULL;

Vlist *StaticMemory::Voxel_addtovlist_p = NULL;

void StaticMemory::allocate(int maxS,int MaxM,int M)
{
  if (StaticMemory::_allocated) {
    if (!((StaticMemory::_maxS == maxS) && (StaticMemory::_maxM == MaxM) && (StaticMemory::_M == M))) StaticMemory::free(maxS,MaxM,M);
    else return;
  }

  int i,j;
  ALLOCATEARRAY(StaticMemory::Shoot_shootenergy_C,double*,maxS);
  for(i = 0; i < maxS; i ++) ALLOCATEARRAY(StaticMemory::Shoot_shootenergy_C[i],double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_shootenergy_f,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_shootenergy_B,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_f,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_B,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c,double**,4);
  for(i = 0; i < 4; i ++) {
    ALLOCATEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c[i],double*,maxS);
    for(j = 0; j < maxS; j ++) ALLOCATEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c[i][j],double,MaxM*MaxM);
  }
  ALLOCATEARRAY(StaticMemory::Shoot_shootfromsourceonestep_C,double*,maxS);
  for(i = 0; i < maxS; i ++) ALLOCATEARRAY(StaticMemory::Shoot_shootfromsourceonestep_C[i],double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Shoot_pushpullsource_SW,double,M*M);
  ALLOCATEARRAY(StaticMemory::Shoot_pushpullsource_NW,double,M*M);
  ALLOCATEARRAY(StaticMemory::Shoot_pushpullsource_SE,double,M*M);
  ALLOCATEARRAY(StaticMemory::Shoot_pushpullsource_NE,double,M*M);

  ALLOCATEARRAY(StaticMemory::Solver_gatherwithpushpull_f,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Solver_gatherwithpushpull_B,double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Solver_gatherwithpushpull_c,double**,4);
  for(i = 0; i < 4; i ++) {
    ALLOCATEARRAY(StaticMemory::Solver_gatherwithpushpull_c[i],double*,maxS);
    for(j = 0; j < maxS; j ++) ALLOCATEARRAY(StaticMemory::Solver_gatherwithpushpull_c[i][j],double,MaxM*MaxM);
  }
  ALLOCATEARRAY(StaticMemory::Solver_solve_C,double*,maxS);
  for(i = 0; i < maxS; i ++) ALLOCATEARRAY(StaticMemory::Solver_solve_C[i],double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Solver_solve2_C,double*,maxS);
  for(i = 0; i < maxS; i ++) ALLOCATEARRAY(StaticMemory::Solver_solve2_C[i],double,MaxM*MaxM);

  ALLOCATEARRAY(StaticMemory::Wavelet_pullupenergytoroot_TMP_PULL,double*,maxS);
  for (int i=0;i<maxS;i++) ALLOCATEARRAY(StaticMemory::Wavelet_pullupenergytoroot_TMP_PULL[i],double,MaxM*MaxM);
  ALLOCATEARRAY(StaticMemory::Wavelet_pullupenergytoroot_PULL,double*,maxS);
  for (int i=0;i<maxS;i++) ALLOCATEARRAY(StaticMemory::Wavelet_pullupenergytoroot_PULL[i],double,MaxM*MaxM);

  StaticMemory::_allocated = 1;
  StaticMemory::_maxS = maxS;
  StaticMemory::_maxM = MaxM;
  StaticMemory::_M = M;
}

void StaticMemory::free(int maxS,int MaxM,int M)
{
  if (!StaticMemory::_allocated) return;

  int i,j;
  for (int i=0;i<maxS;i++) FREEARRAY(StaticMemory::Wavelet_pullupenergytoroot_PULL[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Wavelet_pullupenergytoroot_PULL,double*,maxS);
  for (int i=0;i<maxS;i++) FREEARRAY(StaticMemory::Wavelet_pullupenergytoroot_TMP_PULL[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Wavelet_pullupenergytoroot_TMP_PULL,double*,maxS);

  for(i = 0; i < maxS; i ++) FREEARRAY(StaticMemory::Solver_solve2_C[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Solver_solve2_C,double*,maxS);
  for(i = 0; i < maxS; i ++) FREEARRAY(StaticMemory::Solver_solve_C[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Solver_solve_C,double*,maxS);
  for(i = 0; i < 4; i ++) {
    for(j = 0; j < maxS; j ++) FREEARRAY(StaticMemory::Solver_gatherwithpushpull_c[i][j],double,MaxM*MaxM);
    FREEARRAY(StaticMemory::Solver_gatherwithpushpull_c[i],double*,maxS);
  }
  FREEARRAY(StaticMemory::Solver_gatherwithpushpull_c,double**,4);
  FREEARRAY(StaticMemory::Solver_gatherwithpushpull_B,double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Solver_gatherwithpushpull_f,double,MaxM*MaxM);

  FREEARRAY(StaticMemory::Shoot_pushpullsource_NE,double,M*M);
  FREEARRAY(StaticMemory::Shoot_pushpullsource_SE,double,M*M);
  FREEARRAY(StaticMemory::Shoot_pushpullsource_NW,double,M*M);
  FREEARRAY(StaticMemory::Shoot_pushpullsource_SW,double,M*M);
  for(i = 0; i < maxS; i ++) FREEARRAY(StaticMemory::Shoot_shootfromsourceonestep_C[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Shoot_shootfromsourceonestep_C,double*,maxS);
  for(i = 0; i < 4; i ++) {
    for(j = 0; j < maxS; j ++) FREEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c[i][j],double,MaxM*MaxM);
    FREEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c[i],double*,maxS);
  }
  FREEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_c,double**,4);
  FREEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_B,double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Shoot_gatherfromsourcewithpushpull_f,double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Shoot_shootenergy_B,double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Shoot_shootenergy_f,double,MaxM*MaxM);
  for(i = 0; i < maxS; i ++) FREEARRAY(StaticMemory::Shoot_shootenergy_C[i],double,MaxM*MaxM);
  FREEARRAY(StaticMemory::Shoot_shootenergy_C,double*,maxS);

  StaticMemory::_allocated = 0;
  StaticMemory::_maxS = -1;
  StaticMemory::_maxM = -1;
  StaticMemory::_M = -1;
}

void StaticMemory::stat()
{
  TRACEFUNCTION; TRACEVARIABLE(StaticMemory::_memoryallocated);
}
