#include "recherche/Globals.h"

/*
  parametres de recherche
  en variables globales pour ne pas avoir ouatmill
  parametres dans chaque fonction
*/

int MM = 2;
double AArea_Threshold = 0.3;
double TThreshold = 0.0001;

 sTunnelParameters _tp;
 sIlluminationParameters _sp;
 sRequiredRadianceCurve _rrc;
 Motif _mbase;
 Motif _mrecouv;
 sRepartition tres;

int nbSolutions = 0;
int maxSolutions = maxNumberOfConfiguration;
 sRepartition lesSolutions[maxNumberOfConfiguration];

Env* _maillage;
cList< sLightSource* > _ls;
cList< sMaterialReflectanceSpectrum* > _lf;
cList< sMaterialReflectanceSpectrum* > _lw;
cList< sMaterialReflectanceSpectrum* > _lr;

double coutmin;
int _numberOfRamps;
int _positionOnMotif;
int _nbemit;

int lfi = -1;
int lfw = -1;
int lfr = -1;

ostream& operator<<(ostream& out, sRepartition& r)
{
  out << "[" << r.ramp[0] << " " << r.ramp[1] << " " << r.ramp[2] << ",";
  out << r.nsou[0] << " " << r.nsou[1] << " " << r.nsou[2] <<",";
  out << "[" << r.sou << "]" << " " << "[" << r.fr << "]" ;
  out << " " << "[" << r.wl << "]" << " " << "[" << r.rf << "]" ;
  out << " , " << r.prix << "]";
  return out;
}

int vraiegal( sRepartition& r1, sRepartition& r2)
{
  for (int i=0;i<3;i++)
    {
      if (r1.nsou[i] != r2.nsou[i]) { return 0; }
      if (r1.ramp[i] != r2.ramp[i]) { return 0; }
    }
  if ((r1.sou == r2.sou) && (r1.fr == r2.fr) && (r1.wl == r2.wl) && (r1.rf == r2.rf)) { return 1; }
  { return 0; }
}

int egal( sRepartition& r1, sRepartition& r2)
{
  for (int i=0;i<3;i++)
    {
      if (r1.nsou[i] != r2.nsou[i]) return 0;
      if (r1.ramp[i] != r2.ramp[i]) return 0;
    }
  return 1;
}

void ident( sRepartition& r1, sRepartition& r2)
{
  for (int i=0;i<3;i++)
    {
      r1.nsou[i] = r2.nsou[i];
      r1.ramp[i] = r2.ramp[i];
    }
  r1.sou = r2.sou;
  r1.fr = r2.fr;
  r1.wl = r2.wl;
  r1.rf = r2.rf;
  r1.prix = r2.prix;
}
